#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

vector<vector<bool>>cr;
int k, n;

string correct(string s) {
	int i = s.size() - 1;
	while (i >= 0 && s[i] == s.back())
		i--;
	if (i >= 0) {
		if (cr[s[i] - 'a'][s.back() - 'a']) {
			while (s.back() != s[i])
				s.pop_back();
			return s;
		}
	}
	if (cr[s.back() - 'a'][s.back() - 'a']) {
		string ans = "";
		for (int j = 0; j <= i + 1; j++)
			ans.push_back(s[j]);
		return ans;
	}
	return s;
}

int main() {
	cin >> k >> n;
	cr.resize(k, vector<bool>(k));
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char x; cin >> x;
			cr[i][j] = (x == '1');
		}
	string s, t;
	t.push_back('z' + 1);
	cin >> s;
	vector<vector<string>>dp(n, vector<string>(k, t));
	dp[0][s[0] - 'a'] = s[0];
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < k; j++) {
			dp[i][s[i] - 'a'] = min(dp[i][s[i] - 'a'], dp[i - 1][j] + s[i]);
		}
		for (int j = 0; j < k; j++) {
			if (dp[i - 1][j] != t && cr[j][s[i] - 'a'])
				dp[i][j] = dp[i - 1][j];
		}
	}
	for (int i = 0; i < k - 1; i++)
		dp[n - 1][k - 1] = min(dp[n - 1][k - 1], dp[n - 1][i]);
	cout << correct(dp[n - 1][k - 1]);
	return 0;
}