#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define left left666
#define right right666
#define dist dist666
#define prev prev666
#define tm tm666

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18;
const int inf = 1.5e9, P = 1e9 + 7,  X = 2007, N = 2e5;
int n;
vector<int> g[N], pos[N], num, leaves, ans[N];
map<int, int> act;
pii dp[N];

bool dfs(int v) {
    vector<pair<pii, int> > seg;
    for (int u : g[v]) {
        if (!dfs(u)) {
            return false;
        }
        seg.push_back({dp[u], u});
    }
    if (seg.size()) {
        int r = -1, l = -1;
        sort(all(seg));
        for (pair<pii, int> elem : seg) {
            int id = elem.ss, left = elem.ff.ff, right = elem.ff.ss;
            if (left <= r) {
                return false;
            }
            if (l == -1) {
                l = left;
            }
            r = right;
            ans[v].push_back(id + 1);
        }
        dp[v] = {l, r};
    } else {
        ans[v].push_back(dp[v].ff);
    }
    return true;
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int u;
                cin >> u;
                u--;
                g[i].push_back(u);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; j++) {
                int a;
                cin >> a;
                pos[i].push_back(a);
                num.push_back(a);
            }
            leaves.push_back(i);
        }
    }
    int m = num.size();
    for (int mask = 0; mask < (1 << m); mask++) {
        act.clear();
        for (int i = 0; i < n; i++) {
            ans[i] = {};
        }
        for (int i = 0; i < m; i++) {
            if (mask & (1 << i)) {
                act[num[i]] = 1;
            }
        }
        int FL = 1;
        for (int v : leaves) {
            int cnt = 0;
            for (int a : pos[v]) {
                if (act[a]) {
                    cnt++;
                    dp[v] = {a, a};
                    break;
                }
            }
            if (cnt != 1) {
                FL = 0;
                break;
            }
        }
        if (FL && dfs(0)) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                for (int elem : ans[i]) {
                    cout << elem << ' ';
                }
                cout << "\n";
            }
            /*cout << "dp\n";
            for (int i = 0; i < n; i++) {
                cout << dp[i].ff << ' ' << dp[i].ss << "\n";
            }
            cout << "\n";*/
            return;
        }
    }
    cout << "No\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    //cout << setprecision(15) << fixed;
    solve();
    return 0;
}
