#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void permutations(uint64_t n, vector <vector <string>> ar, vector <uint64_t> ans, vector <bool> used, string s, vector <uint64_t> &ans_)
{
	if (ans.size() == n)
	{
		vector <string> pos(ar[0].size(), "");
		string res, prov = "";
		bool trig = true;
		for (auto k : ans)
		{
			for (uint64_t l = 0; l < ar[k].size(); ++l)
			{
				if (pos[l].empty() && !ar[k][l].empty())
				{
					prov += s[l];
					if (prov != ar[k][l])
					{
						trig = false;
						break;
					}
				}
				pos[l] += ar[k][l];
			}
			if (!trig)
			{
				break;
			}
		}
		for (auto k : pos)
		{
			res += k[0];
		}
		//cout << res.size() << '\n';
		//cout << s.size();
		if (res == s)
		{
			ans_ = ans;
		}
		
	}
	for (uint64_t k = 0; k < n; ++k)
	{
		if (!used[k])
		{
			used[k] = true;
			ans.push_back(k);
			permutations(n, ar, ans, used, s, ans_);
			ans.pop_back();
			used[k] = false;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	uint64_t n, m, indx, size;
	string s, elem;
	vector <vector <string>> ar;
	vector <uint64_t> ans_ = {};
	
	cin >> n >> m;
	vector <bool> used(n, false);
	cin >> s;
	for (uint64_t k = 0; k < n; ++k)
	{
		cin >> size;
		ar.push_back({});
		for (uint64_t l = 0; l < size; ++l)
		{
			cin >> indx >> elem;
			for (uint64_t i = ar[k].size(); i < indx - 1; ++i)
			{
				ar[k].push_back("");
			}
			ar[k].push_back(elem);
		}
		for (uint64_t i = ar[k].size(); i < m; ++i)
		{
			ar[k].push_back("");
		}
	}
	/* 
	for (auto k : ar)
	{
		cout << k.size() << " ";
		for (auto l : k)
		{
			cout << l;
		}
		cout << '\n';
	}
	*/
	permutations(n, ar, {}, used, s, ans_);
	if (ans_.empty())
	{
		cout << "-1";
	}
	else
	{
		for (auto k : ans_)
		{
			cout << k + 1 << ' ';
		}
	}


	return 0;
}