#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
string dp[(int)1e4 + 10];
int A[1000][1000];
void cmn(string& s, string t) {
	if (t.empty()) return;
	if (s.empty() || s > t) s = t;
}
bool can_er(string s) {
	int n = cap(s);
	vector<int> used(n);
	int cnt = 0;
	while (cnt < n - 1) {
		bool ok = false;
		for (int i = n - 1; i >= 1; i--) if (!used[i]) {
			int x;
			for (int j = i - 1; j >= 0; j--) if (!used[j]) {
				x = s[j] - 'a';
				break;
			}
			int y = s[i] - 'a';
			if (A[x][y]) {
				used[i] = true;
				ok = true;
				break;
			}
		}
		if (!ok) return false;
		cnt++;
	}
	return true;
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int k, n;
	string s;
	cin >> k >> n;
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	cin >> s;
	s += char('z' + 1);
	n++;
	dp[0] = s[0];
	for (int i = 1; i < n; i++) {
		dp[i] = s.substr(0, i + 1);
		for (int j = i - 1; j >= 0; j--) {
			if (can_er(s.substr(j, i - j))) {
				cmn(dp[i], dp[j] + s[i]);
			}
		}
	}
	dp[n - 1].pop_back();
	cout << dp[n - 1];
	return 0;
}
/*
3 7
010
001
100
abacaba
*/