#include <bits/stdc++.h>
using namespace std;

#define size(a) (int)(a.size())
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)

const int max_n = 2000 + 5;
int n;
vector<int> work[max_n];
int dp[max_n][max_n];
vector<int> gr[max_n];

void dfs(int v) {
	if (!size(gr[v])) {
		//cout << v + 1 << ": ";
		for(int i : work[v]) {
			//cout << i << " ";
			for(int l = i;l >= 0;l--) {
				chkmin(dp[v][l], i);
			}
		}
		return;
	}

	for(int to : gr[v]) {
		dfs(to);
	}

	for(int l = 0;l < max_n;l++) {
		vector<int> max_r((1 << size(gr[v])), max_n - 3);
		max_r[0] = l - 1;
		for(int mask = 1;mask < size(max_r);mask++) {

			for(int i = 0;i < size(gr[v]);i++) {
				if (!((mask >> i) & 1)) continue;
				int to = max_r[mask ^ (1 << i)];
				int nxt = dp[gr[v][i]][to + 1];
				chkmin(max_r[mask], nxt);
			}
		}
		dp[v][l] = max_r.back();
	}

	/*cout << "dp " << v + 1 << ": ";
	for(int i = 0;i < 10;i++)
		cout << dp[v][i] << " ";
	cout << endl;*/
}

void solve() {
	for(int i = 0;i < max_n;i++) {
		for(int j = 0;j < max_n;j++)
			dp[i][j] = 2001;
	}

	map<int, int> tmp;

	cin >> n;
	for(int i = 0;i < n;i++) {
		int t, k;
		cin >> t >> k;
		if (t == 1) {
			for(int j = 0;j < k;j++) {
				int to;
				cin >> to;
				gr[i].emplace_back(--to);
			}
		}else {
			for(int j = 0;j < k;j++) {
				int to;
				cin >> to;
				work[i].emplace_back(to);
				tmp[to] = 0;
			}
		}
	}
	int c = 0;
	for(auto v : tmp) {
		tmp[v.first] = c++;
	}
	for(int i = 0;i < n;i++) {
		for(int& j : work[i]) {
			j = tmp[j];
			//cout << "work " << j << endl;
		}
	}

	dfs(0);

	cout << (dp[0][0] < size(tmp) ? "Yes" : "No") << endl;
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	solve();
}