#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 10100;

vector<int> dfs(int v, vector<vector<int> > &ray, vector<vector<int> > &data)
{
    if (ray[v].size() != 0) return ray[v];
    vector<vector<int> > s;
    for (auto e : data[v])
        s.push_back(dfs(e, ray, data));
    sort(s.begin(), s.end());
    vector<int> p;
    for (int i = 0; i < s.size(); i++)
        for (auto e : s[i]) p.push_back(e);
    return p;
}

vector<int> restore(int v, vector<vector<int> > &ray, vector<vector<int> > &data, vector<vector<int> > &ans)
{
    if (ray[v].size() != 0)
    {
        ans[v] = ray[v];
        return ray[v];
    }
    vector<pair<vector<int>, int> > s;
    for (auto e : data[v])
        s.push_back({restore(e, ray, data, ans), e});
    sort(s.begin(), s.end());
    vector<int> p;
    for (int i = 0; i < s.size(); i++)
        for (auto e : s[i].first) p.push_back(e);
    for (int i = 0; i < s.size(); i++)
        ans[v].push_back(s[i].second);
    return p;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    int m = 0;
    vector<int> t(n), k(n);
    vector<vector<int> > data(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i] >> k[i];
        data[i] = vector<int>(k[i]);
        if (t[i] == 2) m += k[i];
        for (int j = 0; j < k[i]; j++)
            cin >> data[i][j], data[i][j]--;
    }
    for (int mask = 0; mask < (1 << m); mask++)
    {
        vector<vector<int> > ray2(n);
        int pnt = 0;
        int T = 1;
        for (int i = 0; i < n; i++)
        {
            if (t[i] == 2)
            {
                for (int j = 0; j < data[i].size(); j++)
                {
                    if ((1 << pnt) & mask)
                        ray2[i].push_back(data[i][j]);
                    pnt++;
                }
                if (ray2[i].size() != 1)
                {
                    T = 0;
                    continue;
                }
            }
        }
        if (T)
        {
            vector<int> res = dfs(0, ray2, data);
            int tr = 1;
            for (int i = 1; i < res.size(); i++)
            {
                if (res[i] < res[i - 1]) tr = 0;
            }
            if (tr)
            {
                vector<vector<int> > ans(n);
                restore(0, ray2, data, ans);
                cout << "Yes\n";
                for (int i = 0; i < n; i++)
                {
                    for (auto e : ans[i])
                    {
                        cout << e + 1 << " ";
                    }
                    cout << "\n";
                }
                return 0;
            }
        }
    }
    cout << "No\n";
}

/*
3
1 2 2 3
2 1 1
2 1 2
*/
