#include<bits/stdc++.h>

#define int long long
#define ld long double
#define pb push_back

using namespace std;

const int N = 510;
bool dp[N][N][N];
vector<vector<int>> mn(N, vector<int>(N, 1e9));
vector<int> u;
vector<int> g[N];

void dfs(int v, int p = -1){
    vector<int> a;
    if (g[v].size() == 0) {
        for (int i = N - 2; i >= 0; i--){
            mn[v][i] = min(mn[v][i], mn[v][i + 1]);
            for (int j = i; j < N; j++){
                if (dp[v][i][j]){
                    mn[v][i] = min(mn[v][i], j);
                }
            }
        }
        return;
    }
    for (auto to : g[v]){
        if (to != p){
            a.pb(to);
            dfs(to, v);
        }
    }
    int k = g[v].size();
    for (int i = 0; i < u.size(); i++){
        vector<vector<bool>> can((1 << k), vector<bool>(u.size()));
        can[0][i] = 1;
        for (int j = 0; j < (1 << k); j++){
            for (int f = 0; f < k; f++){
                if (!(j & (1 << f))){
                    for (int q = 0; q < u.size(); q++){
                        if (can[j][q] && mn[a[f]][q] < u.size()){
                            can[j | (1 << f)][mn[a[f]][q]] = 1;
                        }
                    }
                }
            }
        }
        for (int j = 0; j < u.size(); j++){
            if (can[(1 << k) - 1][j]){
                dp[v][i][j] = 1;
            }
        }
    }
    for (int i = N - 2; i >= 0; i--){
        mn[v][i] = min(mn[v][i], mn[v][i + 1]);
        for (int j = i; j < N; j++){
            if (dp[v][i][j]){
                mn[v][i] = min(mn[v][i], j);
            }
        }
    }
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> can(n + 1);
    for (int i = 1; i <= n; i++){
        int t;
        cin >> t;
        if (t == 1){
            int k;
            cin >> k;
            for (int j = 0; j < k; j++){
                int a;
                cin >> a;
                g[i].pb(a);
            }
        }
        else{
            int k;
            cin >> k;
            for (int j = 0; j < k; j++){
                int a;
                cin >> a;
                can[i].pb(a);
                u.pb(a);
            }
        }
    }
    sort(u.begin(), u.end());
    u.erase(unique(u.begin(), u.end()), u.end());
    for (int i = 1; i <= n; i++){
        for (auto to : can[i]){
            int j = lower_bound(u.begin(), u.end(), to) - u.begin();
            dp[i][j][j] = 1;
        }
    }
    dfs(1);
    for (int i = 0; i < N; i++){
        for (int j = 0; j < N; j++){
            if (dp[1][i][j]){
                cout << "Yes";
                return 0;
            }
        }
    }
    cout << "No\n";
    return 0;
}
