#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vector<pair<int, char>>> a(n);
    forn(i, n) {
        int k;
        cin >> k;
        forn(j, k) {
            int x;
            char y;
            cin >> x >> y;
            --x;
            a[i].eb(x, y);
        }
    }
    vi order(n);
    iota(all(order), 0);
    do{
        bool flag = 1;
        vector <bool> deleted(m, 0);
        for (auto u : order) {
            for (auto [x, y] : a[u]) {
                if (s[x] != y && !deleted[x]) {
                    flag = 0;
                    break;
                }
                if (s[x] == y) {
                    deleted[x] = 1;
                }
            }
        }
        if (flag) {
            for (auto u : order) {
                cout << u + 1 << ' ';
            }
            return;
        }
    }while(next_permutation(all(order)));
    cout << "-1";
}

signed main() {
    IO();
    Solve();
    return 0;
}
