#include <iostream> 
#include <vector>
#include <algorithm>
#define int long long
#define vi vector<int>
using namespace std;

bool check(string s, string a) {
	for (int i = 0; i < s.size(); ++i)
		if (a[i] != ' ' && s[i] != ' ' && s[i] != a[i])
			return false;
	return true;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<string> a(n);
	for (int i = 0; i < n; ++i) {
		a[i].assign(m, ' ');
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int ind;
			char c;
			cin >> ind >> c;
			a[i][ind - 1] = c;
		}
	}
	vi res, used(n, 1);
	for (int i = 0; i < n; ++i)
		if (used[i] && check(s, a[i])) {
			res.push_back(i);
			for (int j = 0; j < m; ++j)
				if (a[i][j] != ' ')
					s[j] = ' ';
			used[i] = 0;
			i = -1;
		}
	if (res.size() < n) {
		cout << -1;
	}
	else {
		for (auto x : res)
			cout << x + 1 << " ";
	}
}