#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <list>
#include <stack>
#include <cassert>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}

void solve();
int main() {
    setup();
    solve();
    return 0;
}

#ifdef LOCAL
const int MAXN = 100 + 10;
#else
const int MAXN = 5e5 + 10;
#endif


bool tb[27][27];
int sto[MAXN];
int canto[MAXN];
int y[MAXN];
vector<int> wh[27];

int minfor[MAXN];
int k, n;

bool cmp(int i, int j) {
    if (i == n) return j != n;
    if (j == n) return false;
    if (y[i] < y[j]) return true;
    else if (y[i] > y[j]) return false;
    else return cmp(minfor[i], minfor[j]);
}

void solve() {
    cin >> k >> n;
    range(i, k) {
        range(j, k) {
            char c; cin >> c;
            tb[i][j] = (c == '1');
        }
    }
    string s;
    cin >> s;
    range(i, n) {
        y[i] = s[i] - 'a';
    }

    rrange(i, n) {
        auto &ct = canto[i];
        ct = i + 1;
        minfor[i] = i + 1;
        while (ct < n && tb[y[i]][y[ct]]) {
            if (cmp(minfor[ct], minfor[i])) {
                minfor[i] = minfor[ct];
            }
            ct = canto[ct];
        }
    }
    int now = 0;
    while (now != n) {
        cout << (char) (y[now] + 'a');
        now = minfor[now];
    }
    cout << endl;
//    vector<int> ans;
//    int now = 0;
//    while (now != n) {
//        ans.push_back(now);
//        if (canto[now] == n) {
//            now = n;
//            break;
//        }
//        int best = now + 1;
//        for (auto i = now + 1; i <= canto[now]; ++i) {
//            if (y[i] < y[best] || (y[i] == y[best] && canto[i] > canto[best])) {
//                best = i;
//            }
//        }
//        now = best;
////        for (int c = 0; c <= y[now + 1]; ++c) {
////            auto it = upper_bound(all(wh[c]), canto[now]);
////            if (it == wh[c].begin()) continue;
////            --it;
////            int pos = *it;
////            if (pos > now){
////                now = pos;
////                break;
////            }
////        }
//    }
//    for (auto i : ans) {
//        cout << s[i];
//    }
//    cout << endl;
}
