#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;

int32_t main() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    vector<int> ans;
    bitset<MAXN> used, wrong[n], setting[n];
    vector<bool> used_s(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        bool ok = true;
        for (int j = 0; j < k; j++) {
            int pos;
            char c;
            cin >> pos >> c;

            pos--;

            setting[i].set(pos);
            if (s[pos] != c) {
                ok = false;
                wrong[i].set(pos);
            }
        }

        if (ok) {
            ans.push_back(i);
            used_s[i] = true;
            used |= setting[i];
        }
    }


    for (int t = 0; t < n; t++) {
        int sel = -1;
        for (int i = 0; i < n; i++) {
            if (used_s[i] || ((wrong[i] ^ used) & wrong[i]).count()) {
                continue;
            }

            sel = i;
            break;
        }

        if (sel == -1) {
            break;
        }

        ans.push_back(sel);
        used_s[sel] = true;
        used |= setting[sel];
    }

    cerr << used.count() << "\n";
    if (used.count() != m) {
        cout << -1;
        exit(0);
    }

    for (int i : ans) {
        cout << (i + 1) << " ";
    }

    return 0;
}
