#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()

const int N = 600;
vector<int> g[N];
vector<int> a[N];
const int INF = 1e9;
int chose[N];

int dfs(int v, int l) {
    if (g[v].empty()) {
        for(int x : a[v]) {
            if (x >= l) {
                chose[v] = x;
                return x;
            }
        }
        return -1;
    }
    sort(all(g[v]));

    for(int v : g[v]) {
        if (dfs(v, l) == -1) {
            return -1;
        }
    }

    do {
        int tmp = l;
        bool fl = 1;
        for(int x : g[v]) {
            int res = dfs(x, tmp);
            if (res == -1) {
                fl = 0;
                break;
            }
            tmp = res;
        }
        if (fl) {
            return tmp;
        }
    } while (next_permutation(all(g[v])));
    return -1;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        int k;
        cin >> k;
        if (k == 1) {
            cin >> k;
            while (k--) {
                int to;
                cin >> to;
                --to;
                g[i].push_back(to);
            }
        } else {
            cin >> k;
            while (k--) {
                int x;
                cin >> x;
                a[i].push_back(x);
            }
        }
    }
    for(int i = 0; i < n; i++ ){
        sort(all(a[i]));
    }

    int res = dfs(0, 0);
    if (res != -1) {
        cout << "YES\n";
        for(int i = 0; i < n; i++) {
            if (g[i].empty()) cout << chose[i] << endl;
            else {
                for(int x : g[i]) cout << x + 1 << ' '; cout << endl;
            }
        }
    } else {
        cout << "NO\n";
    }
}

