#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAXN = 1e4 + 228;
const int MAXK = 27;

bool canDel[MAXK][MAXK];
string s;

bool rec(int pos, int last) {
	//if (pos < last) exit(0);
	if (pos == last) return false;
	for (int i = pos - 1; i >= last; --i) {
		if (canDel[s[i] - 'a'][s[pos] - 'a']) {
			bool flag = true;
			for (int j = i + 1; j < pos; ++j) {
				if (!rec(j, i)) {
					flag = false;
					break;
				}
			}
			if (flag) {
				return true;
			}
		}
	}
	return false;
}

int k, n;
bool checkSuf(int pos) {
	for (int i = pos + 1; i < n; ++i) {
		if (!rec(i, pos)) return false;
	}
	return true;
}
vector<char> ans;

void maxDel(int last, int right) {
	for (int i = last + 1; i <= right; ++i) {
		if (!rec(i, last)) {
			ans.push_back(s[i]);
		}
	}
}

/*int addMin(int last, int right) {
	char maxC = 'z' + 1;
	int posC = -1;
	for (int i = last + 1; i < right; ++i) {
		if (s[i] < maxC) {
			maxC = s[i];
			posC = i;
		}
	}
	if (!rec(posC, last)) {
		int h = addMin(last, posC);
	}
	else {

	}
}*/

void resh(int l, int r) {
	ans.push_back(s[l]);
	if (l == r) return;
	int now = l + 1;
	while (now <= r && rec(now, l)) ++now;
	assert(now <= r);
	char minC = s[now];
	int posC = now;
	for (int i = l + 1; i < now; ++i) {
		if (s[i] < minC) {
			minC = s[i];
			posC = i;
		}
		else if (s[i] == minC && s[i] == s[now]) {
			posC = i;
		}
	}
	resh(posC, r);
}

int main() {
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char tmp;
			cin >> tmp;
			if (tmp == '0') {
				canDel[i][j] = false;
			}
			else {
				canDel[i][j] = true;
			}
		}
	}
	cin >> s;
	while (rec((int)s.size() - 1, 0)) s.pop_back();
	n = s.size();
	/*string sans = s;
	for (int mask = 1; mask < (1ll << n); mask += 2) {
		int lastOne = 0;
		bool flag = true;
		for (int i = 1; i < n; ++i) {
			if ((mask >> i) & 1) {
				lastOne = i;
			}
			else {
				if (!rec(i, lastOne)) {
					flag = false;
					break;
				}
			}
		}
		if (flag) {
			string news;
			for (int i = 0; i < n; ++i) {
				if ((mask >> i) & 1) {
					news += s[i];
				}
			}
			sans = min(sans, news);
		}
	}
	cout << sans;
	return 0;*/
	resh(0, n - 1);
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i];
	}
	/*int posLast = 0;
	while (!checkSuf(posLast)) {
		addMin(posLast, n);
	}
	char minC;
	for (int i = s.size() - 1; i >= 0; --i) {
		if (!rec(i, 0)) {
			ans.push_back(s[i]);
		}
		else {

		}
	}
	for (int i = (int)ans.size() - 1; i >= 0; --i) {
		cout << ans[i];
	}*/
}