#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::pair;
using std::string;
using std::vector;


using ll = long long;
using ld = long double;

const int MOD = 1e9 + 7;
const int BASE = 43;

vector<int> st;


vector<vector<int>> hash = {{0}};
vector<string> v = {""};

int getHash (int ind, int i, int j) {
	return ((hash[ind][j] - hash[ind][i] * (ll)st[j - i]) % MOD + MOD) % MOD;
}

bool cmp (int indi, int i, int indj, int j) {
	int l = 0, r  = std::min(i, j) + 1;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (getHash(indi, i - m, i) == getHash(indj, j - m, j))
			l  = m;
		else
			r = m;
	}
	if (r == std::min(i, j) + 1)
		return i < j;
	return v[indi][i - r] < v[indj][j - r];
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int k, n;
	cin >> k >> n;

	st.resize(n + 1);
	st[0] = 1;
	for (int i = 0; i < n; ++i)
		st[i + 1] = (st[i] * (ll)BASE) % MOD;

	int a[26][26];
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			a[i][j] = c - '0';
		}

	vector<int> s(n);
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		s[i] = c - 'a';
	}

	vector<int> right(n);

	vector<vector<int>> go(n);

	for (int i = n - 1; i >= 0; --i) {
		right[i] = i + 1;
		while (right[i] < n && a[s[i]][s[right[i]]]) {
			go[i].push_back(right[i]);
			right[i] = right[right[i]];
		}
	}

	// vector<std::set<int>> nused(k);
	// for (int i = 0; i < k; ++i)
	// 	nused[i].insert(n + 10);
	// for (int i = 0; i < n; ++i)
	// 	nused[s[i]].insert(i);

	vector<pair<int, int>> dp(n);
	dp[n - 1] = {0, 0};

	for (int i = n - 2; i >= 0; --i) {
		if (right[i] == n) {
			int ind = v.size();
			v.push_back("");
			hash.push_back({0});
			dp[i] = {ind, v[ind].size()};
			continue;
		}
		int ind = dp[i + 1].first;
		if (go[i].empty()) {
			v[ind] += s[i + 1] + 'a';
			hash[ind].push_back((hash[ind].back() * (ll)BASE + s[i + 1] + 1) % MOD);
			dp[i] = {ind, v[ind].size()};
			continue;
		}
		dp[i] = dp[go[i][0]];
		for (int j : go[i]) {
			if (cmp(dp[j].first, dp[j].second, dp[i].first, dp[i].second))
				dp[i] = dp[j];
		}
		ind = dp[go[i][0]].first;
		assert(v[ind].size() == dp[go[i][0]].second);
		v[ind] += s[i + 1] + 'a';
		hash[ind].push_back((hash[ind].back() * (ll)BASE + s[i + 1] + 1) % MOD);
		if (cmp(ind, v[ind].size(), dp[i].first, dp[i].second)) {
			dp[i] = {ind, v[ind].size()};
		} else {
			v[ind].pop_back();
			hash[ind].pop_back();
		}
		while (v[dp[i].first].size() > dp[i].second) {
			v[dp[i].first].pop_back();
			hash[dp[i].first].pop_back();
		}
	}

	string ans;
	int ind = dp[0].first;
	ans = v[ind];
	assert(ans.size() == dp[0].second);
	std::reverse(ans.begin(), ans.end());
	cout << (char)(s[0] + 'a') + ans;


	// string ans = "";
	// ans += (s[0] + 'a');



	// vector<int> cur = {0};
	// while (true) {
	// 	int min = k;
	// 	for (int i : cur) {
	// 		if (right[i] == n) {
	// 			cout << ans;
	// 			return 0;
	// 		}
	// 		for (int j = k - 1; j >= 0; --j)
	// 			if (*nused[j].upper_bound(i) <= right[i])
	// 				min = std::min(min, j);
	// 	}
	// 	assert(min != k);
	// 	vector<int> ncur;
	// 	for (int i : cur) {
	// 		auto end = nused[min].upper_bound(right[i]);
	// 		for (auto it = nused[min].upper_bound(i); it != end;) {
	// 			auto it1 = it;
	// 			++it;
	// 			ncur.push_back(*it1);
	// 			//nused[min].erase(it1);
	// 		}
	// 	}
	// 	std::sort(ncur.begin(), ncur.end());
	// 	ncur.resize(std::unique(ncur.begin(), ncur.end()) - ncur.begin());
	// 	cur = ncur;
	// 	assert(cur.size() > 0);
	// 	ans += (s[cur[0]] + 'a');
	// }


	return 0;
}