#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 5e5;
const int maxk = 26;
const int inf = 1e9;
int k, n;
int t[maxn * 4];
vector<int> del[maxk];
int lastdel[maxn];
int delitable[maxn];
int pref[maxn + 1];
vector<int> letters[maxk];
vector<char> ans;
string s;

void update(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] = val;
    } else {
        int tm = (tl + tr) / 2;
        if (pos <= tm) {
            update(v * 2, tl, tm, pos, val);
        } else {
            update(v * 2 + 1, tm + 1, tr, pos, val);
        }
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > tr || tl > r) {
        return inf;
    }
    if (l <= tl && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}

bool all(int l, int r) {
    if (l < 0)return false;
    if (l > r) {
        return true;
    } else {
        if (pref[r + 1] - pref[l] == r - l + 1) {
            return true;
        } else {
            return false;
        }
    }
}

void make(int l) {
    if (l == n) {
        return;
    }
    int ps = -1;
    if (all(l, n - 1))return;
    for (int i = 0; i < 26; ++i) {
        if (ps != -1)break;
        for (int j = (int) letters[i].size() - 1; j >= 0; --j) {
            int pos = letters[i][j];
            if (pos < l)continue;
            bool good = all(l, pos - 1);
            if (good) {
                ps = pos;
                break;
            }
        }
    }
    ans.push_back(s[ps]);
    make(ps + 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char a;
            cin >> a;
            if (a == '1') {
                del[j].push_back(i);
            }
        }
    }
    cin >> s;
    int alfpos[k];
    for (int i = 0; i < k; ++i) {
        alfpos[i] = -inf;
    }
    for (int i = 0; i < n; ++i) {
        lastdel[i] = -inf;
        for (int j = 0; j < del[s[i] - 'a'].size(); ++j) {
            lastdel[i] = max(lastdel[i], alfpos[del[s[i] - 'a'][j]]);
        }
        update(1, 0, n - 1, i, lastdel[i]);
        alfpos[s[i] - 'a'] = i;
    }
    pref[0] = 0;

    delitable[0] = 0;
    pref[0 + 1] = delitable[0];
    for (int i = 1; i < n; ++i) {
        int l = lastdel[i] + 1;
        int r = i - 1;
        delitable[i] = all(l, r) && (get(1, 0, n - 1, l, r) >= l);
        pref[i + 1] = pref[i] + delitable[i];
    }
    for (int i = 0; i < n; ++i) {
        letters[s[i] - 'a'].push_back(i);
    }
    make(0);
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i];
    }
}
