#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;

#ifndef _DEBUG
const int N = 100010;
#else
const int N = 100;
#endif
const int LOGN = 20;
const int ALP = 28;

bool del[500][500];

int pos[N];

string s;

stack < int > st;

string dp[N];

string sp[LOGN][N];

int lg2[N];

int n;

void add(int i) {
	sp[0][i] = dp[i];
	for (int j = 1; j < LOGN; ++j) {
		if (i + (1 << j) - 1 >= n)
			continue;
		sp[j][i] = min(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
	}
}

string get_min(int l, int r) {
	int j = lg2[r - l + 1];
	return min(sp[j][l], sp[j][r - (1 << j) + 1]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	for (int i = 2; i < N; ++i) {
		lg2[i] = lg2[i / 2] + 1;
	}

	int k;

	cin >> k >> n;

	for (int i = 1; i <= k; ++i) {
		string s;
		cin >> s;
		s = '0' + s;
		for (int j = 1; j < s.size(); ++j) {
			if (s[j] == '0')
				del[i + 'a' - 1][j + 'a' - 1] = 0;
			else
				del[i + 'a' - 1][j + 'a' - 1] = 1;
		}
	}

	cin >> s;

	while (!st.empty())
		st.pop();

	for (int i = n - 1; i >= 0; --i) {
		while (!st.empty() && del[s[i]][s[st.top()]])
			st.pop();
		pos[i] = n;
		if (!st.empty()) {
			pos[i] = st.top();
		}
		st.push(i);
	}


	dp[n - 1] += s[n - 1];

	add(n - 1);

	for (int i = n - 2; i >= 0; --i) {
		dp[i] += char('z' + 1);
		if (pos[i] == n) {
			dp[i] = s[i];
			add(i);
			continue;
		}
		dp[i] = s[i] + get_min(i + 1, pos[i]);
		add(i);
	}

	cout << dp[0];

}