#include <iostream>
#include "vector"
#include "set"

using namespace std;

vector<int> ans;

signed main() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<vector<pair<int, char>>> crds(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int a; char c; cin >> a >> c;
            crds[i].push_back({a - 1, c});
        }
    }
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(i);
    }
    vector<bool> cvrd(m, false);
    while (not st.empty()) {
        auto it = st.begin();
        bool found = false;
        while (it != st.end()) {
            int i = *it;
            bool good = true;
            for (auto el : crds[i]) {
                if (not cvrd[el.first] and el.second != s[el.first]) {
                    good = false;
                    break;
                }
            }
            if (good) {
                found = true;
                for (auto el : crds[i]) {
                    cvrd[el.first] = true;
                }
                ans.push_back(i + 1);
                st.erase(i);
                break;
            }
            it++;
        }
        if (not found) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (auto el : ans) {
        cout << el << " ";
    }
    cout << endl;
}
