#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>

// #pragma GCC target("avx2")

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char> > > v(n);
    vector<vector<int> > positions(m);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> v[i][j].first >> v[i][j].second;
            v[i][j].first--;
            positions[v[i][j].first].push_back(i);
        }
    }

    vector<int> cnt_bad(n, 0);
    for (int i = 0; i < n; ++i) {
        for (auto j : v[i]) {
            if (s[j.first] != j.second) {
                cnt_bad[i]++;
            }
        }
    }
    set<int> good;
    good.clear();
    vector<int> usd(n, 0);
    for (int i = 0; i < n; ++i) {
        if (cnt_bad[i] == 0) {
            good.insert(i);
            usd[i] = 1;
        }
    }
    vector<int> ans = {};
    while (!good.empty()) {
        int ind = (*good.begin());
        good.erase(good.begin());
        usd[ind] = 1;
        ans.push_back(ind);
        for (auto i : v[ind]) {
            if (positions[i.first].size() == 0) {
                continue;
            }
            for (auto j : positions[i.first]) {
                if (v[j][lower_bound(all(v[j]), make_pair(i.first, 'a')) - v[j].begin()].second != s[i.first]) {
                    cnt_bad[j]--;
                    if (cnt_bad[j] == 0 && !usd[j]) {
                        good.insert(j);
                        usd[j] = 1;
                    }
                }
            }
            positions[i.first].clear();
        }
    }
    if ((int) ans.size() == n) {
        for (auto i : ans) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}