//
// Created by roi on 08.04.2021.
//

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

#define int ll

void run() {
  int n, k;
  cin >> k >> n;
  vec<vec<int>> mat(k, vec<int>(k));
  for (int i = 0; i < k; i++) {
    string t;
    cin >> t;
    for (int j = 0; j < k; j++) {
      mat[i][j] = t[j] - '0';
    }
  }
  string s;
  cin >> s;
  vec<vec<int>> g(n);
  for (int i = 1; i < n; i++) {
    vec<int> usd(n);
    function<void(int)> dfs = [&](int u) {
      usd[u] = 1;
      if (mat[s[u] - 'a'][s[i] - 'a'])
        g[i].push_back(u);
      for (auto v : g[u]) {
        if (!usd[v]) {
          dfs(v);
        }
      }
    };
    dfs(i - 1);
  }
  vec<vec<int>> rg(n);
  for (int i = 1; i < n; i++) {
    vec<int> usd(n);
    function<void(int)> dfs = [&](int u) {
      usd[u] = 1;
      rg[u].push_back(i + 1);
      for (auto v : g[u]) {
        if (!usd[v]) {
          dfs(v);
        }
      }
    };
    for (int j : g[i]) {
      dfs(j);
    }
  }
  for (int i = 0; i < n; i++) {
    rg[i].push_back(i + 1);
  }
  vec<pair<char, int>> cur {{s[0], 0}};
  string ans;
  vec<int> usd(n);
  while (true) {
    sort(cur.begin(), cur.end());
    cur.resize(unique(cur.begin(), cur.end()) - cur.begin());
    while (cur.back().first != cur.front().first || cur.size() > 100) {
      cur.pop_back();
    }
    for (auto [ch, i] : cur) {
      usd[i] = 1;
    }
    ans.push_back(cur.front().first);
    vec<pair<char, int>> new_cur;
    bool found = false;
    for (auto [ch, i] : cur) {
      for (int j : rg[i]) {
        if (j == n) {
          found = true;
          break;
        } else  {
          new_cur.emplace_back(s[j], j);
        }
      }
      if (found)
        break;
    }
    if (found)
      break;
    cur = new_cur;
  }
  cout << ans << '\n';
}

/*
3 7
010
001
100
abacaba
 */

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}