#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int n, m;
	string s;
	cin >> n >> m >> s;
	vector<map<int, char>> v(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			v[i][a] = c;
		}
	}
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	do {
		int ok = 1;
		for (int i = 0; i < m; ++i) {
			char c = -1;
			for (int j = 0; j < n; ++j) {
				if (v[p[j]].find(i) != v[p[j]].end()) {
					c = v[p[j]][i];
					break;
				}
			}
			if (c != s[i]) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			for (int i = 0; i < n; ++i) {
				cout << p[i] + 1 << " ";
			}
			cout << endl;
			return 0;
		}
	} while (next_permutation(all(p)));
	cout << -1 << endl;
	return 0;
}