#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>
std::vector<std::string> matrix;
std::string str;
int k, n;
std::map<int, std::string> cache;
std::string solve(int from)
{
	//printf("from=%d\n", from);
	if(from == n) return "";
	if(cache.count(from)) return cache[from];
	//std::vector<char> possible(k);
	//possible[str[from]-'a'] = true;
	//possible[pc] = true;
	std::string ans = "~";
	//std::string ans = str.substr(from);
	std::vector<char> st;
	st.push_back(str[from] - 'a');
	for(int i = from+1; i < n; i++)
	{
		if(st.empty()) break;
		char curc = str[i] - 'a';
		while(!st.empty() && matrix[st.back()][curc] != '1')
			st.pop_back();
		if(st.empty()) break;
		st.push_back(curc);
		const std::string&& cur = str[from] + solve(i+1);
		ans = std::min(ans, cur);
	}
	//ans = std::min(ans, char(pc+'a') + solve(from+1, pc));
	ans = std::min(ans, str[from] + solve(from+1));
	//printf("from=%d, ans=%s\n", from, ans.data());
	return cache[from] = ans;
}
int main()
{
	std::cin >> k >> n;
	matrix.resize(k);
	for(int i = 0; i < k; i++)
		std::cin >> matrix[i];
	std::cin >> str;
	n = str.size();
	//minimize string by deleting
	//first minimize the first character
	//choose the leftmost position such that all previous characters can be deleted in some way
	//then repeat for the suffix
	//keep first a: more as possible in the beginning
	//keep last a: shorter result
	//second a possible -> first a possible too
	//first character impossible to delete
	//if k characters possible to delete, k-1 also possible
	std::string ans = solve(0);
	printf("%s\n", ans.data());
}

//use a stack
//caba:
//push c
//push a
//push b
//try to push a; pop b
//try to push a; pop a
//push a
//at end:
//pop a
//if stack empty: break
