#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>
std::vector<std::string> matrix;
std::string str;
int k, n;
std::map<int, std::string> cache;
std::string empty = "", tilde = "~";
const std::string& solve(int from)
{
	//printf("from=%d\n", from);
	if(from == n) return empty;
	if(cache.count(from)) return cache[from];
	//std::vector<char> possible(k);
	//possible[str[from]-'a'] = true;
	//possible[pc] = true;
	std::string ans = "~";
	//std::string ans = str.substr(from);
	std::vector<char> st;
	st.push_back(str[from] - 'a');
	int max_i = -1;
	std::vector<int> minc_i;
	char minc = '~';
	for(int i = from+1; i < n; i++)
	{
		if(st.empty()) break;
		char curc = str[i] - 'a';
		while(!st.empty() && matrix[st.back()][curc] != '1')
			st.pop_back();
		if(st.empty()) break;
		if(i + 1 == n) return cache[from] = str[from]+std::string("");
		if(str[i+1] < minc)
			minc = str[i+1];
		if(str[i+1] == minc) minc_i.push_back(i);
		st.push_back(curc);
		max_i = std::max(max_i, i);
	}
	for(int i : minc_i)
	{
		const std::string& cur = solve(i+1);
		ans = std::min(ans, cur);
	}
	//ans = std::min(ans, char(pc+'a') + solve(from+1, pc));
	ans = std::min(ans, solve(from+1));
	//printf("from=%d, ans=%s\n", from, ans.data());
	return cache[from] = str[from] + ans;
}
int main()
{
	std::cin >> k >> n;
	matrix.resize(k);
	for(int i = 0; i < k; i++)
		std::cin >> matrix[i];
	std::cin >> str;
	n = str.size();
	//minimize string by deleting
	//first minimize the first character
	//choose the leftmost position such that all previous characters can be deleted in some way
	//then repeat for the suffix
	//keep first a: more as possible in the beginning
	//keep last a: shorter result
	//second a possible -> first a possible too
	//first character impossible to delete
	//if k characters possible to delete, k-1 also possible
	std::string ans = solve(0);
	printf("%s\n", ans.data());
	//for(int i = 0; i < n; i++)
	//{
	//  printf("%s\n", solve(i).data());
	//}
}
