#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

int n;
vector < vector <int> > g;
vector <set <int> > a, b;

void cnt_a(int v) {
    for (auto to : g[v]) {
        cnt_a(to);
        for (auto x : a[to])
            a[v].insert(x);
        for (auto x : b[to])
            b[v].insert(x);
    }
}

vector <int> ord;
vector <int> lst;
int id;

bool dfs(int v) {
    if (g[v].empty()) {
        return (v == ord[id++]);
    }
    set <int> was;
    for (int _ = 0; _ < int(g[v].size()); _++) {
        for (auto to : g[v]) {
            if (was.count(to))
                continue;
            if (b[to].count(ord[id])) {
                was.insert(to);
                if (!dfs(to))
                    return false;
                break;
            }
        }
    }
    return true;
}

vector < vector <int> > ans;

bool solve(vector <int> &p) {
    vector <int> chk = p;
    sort(all(chk));
    if ((int)chk.size() != n)
        return false;
    for (int i = 0; i < n; i++) {
        if (chk[i] != i)
            return false;
    }
    for (int i = 0; i < n; i++) {
        ord[i] = lst[p[i]];
    }
    vector <int> cur(n);
    cur[0] = *a[ord[0]].begin();
    for (int i = 1; i < n; i++) {
        auto it = a[ord[i]].upper_bound(cur[i - 1]);
        if (it == a[ord[i]].end())
            return false;
        cur[i] = *it;
    }
    id = 0;
    return (dfs(0) && id >= n);
}

bool _dfs(int v) {
    if (g[v].empty()) {
        return (v == ord[id++]);
    }
    set <int> was;
    for (int _ = 0; _ < int(g[v].size()); _++) {
        for (auto to : g[v]) {
            if (was.count(to))
                continue;
            if (b[to].count(ord[id])) {
                was.insert(to);
                ans[v].push_back(to + 1);
                if (!_dfs(to))
                    return false;
                break;
            }
        }
    }
    return true;
}

void get_ans(vector <int> p) {
    for (int i = 0; i < n; i++) {
        ord[i] = lst[p[i]];
    }
    vector <int> cur(n);
    cur[0] = *a[ord[0]].begin();
    for (int i = 1; i < n; i++) {
        auto it = a[ord[i]].upper_bound(cur[i - 1]);
        cur[i] = *it;
    }
    for (int i = 0; i < n; i++) {
        ans[ord[i]] = {cur[i]};
    }
    id = 0;
    _dfs(0);
    for (auto x : ans) {
        print(x);
    }
}

void solve() {
    cin >> n;
    g.resize(n);
    a.resize(n);
    b.resize(n);
    map <int, int> to;
    vector <pii> mi;
    for (int i = 0; i < n; i++) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            while (k --> 0) {
                int v; cin >> v;
                g[i].push_back(v - 1);
            }
        } else {
            b[i].insert(i);
            int k; cin >> k;
            while (k --> 0) {
                int v; cin >> v;
                a[i].insert(v);
                mi.emplace_back(v, i);
            }
            to[i] = lst.size();
            lst.push_back(i);
        }
    }
    ans.resize(n);
    cnt_a(0);
    n = lst.size();
    ord.resize(n);
    int N = mi.size();
    for (int mask = 1; mask < (1 << N); mask++) {
        vector <pii> cur;
        for (int j = 0; j < N; j++) {
            if ((mask >> j) & 1) {
                cur.push_back(mi[j]);
            }
        }
        sort(all(cur));
        vector <int> p(cur.size());
        for (int i = 0; i < int(cur.size()); i++) {
            p[i] = to[cur[i].second];
        }
        if (solve(p)) {
            cout << "Yes\n";
            get_ans(p);
            return;
        }
    }
    
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}