#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>

#pragma warning(disable:4996) 
#define ll long long
using namespace std;

int main() {

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	
	vector <vector <int>> right(n);
	vector <int> wrong(n);
	vector <vector <int>> wrong1(m);

	vector <vector <int>> g;

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int a;
			char c;
			cin >> a >> c;
			if (s[a - 1] == c)
				right[i].push_back(a - 1);
			else {
				wrong[i]++;
				wrong1[a - 1].push_back(i);
			}
		}
	
	}

	

	vector <int> good(m);
	
	stack <int> st;

	for (int i = 0; i < n; i++)
		if (!wrong[i])
			st.push(i);
	vector <int> ans;

	while (!st.empty()) {
		int cur = st.top();
		ans.push_back(cur);
		st.pop();
		for (int i : right[cur])
			if (good[i] != 1) {
				good[i] = 1;
				for (int j : wrong1[i]) {
					wrong[j]--;
					if (!wrong[j])
						st.push(j);
				}
			}
	}

	bool f = true;
	for (int i = 0; i < m; i++)
		if (!good[i])
			f = false;
	for (int i = 0; i < n; i++)
		if (wrong[i])
			f = false;
	if (!f)
		return cout << -1, 0;
	for (int x : ans)
		cout << x + 1 << ' ';
	
	return 0;
}
