#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 5e5 + 10, K = 27;

char tmin[2 * N];

char ask(int l, int r) {
	l += N;
	r += N;
	char res = 127;
	while (l <= r) {
		res = min(res, tmin[l]);
		res = min(res, tmin[r]);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return res;
}

char a[K][K];
int ok[N];
int nxt[N][K];
string s;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
			cin >> a[i][j], a[i][j] = char(a[i][j] - '0');
	cin >> s;
	s += '\0';
	
	for (int i = 0; i <= n; ++i)
		tmin[i + N] = s[i];
	for (int i = N; i--; )
		tmin[i] = min(tmin[2 * i], tmin[2 * i + 1]);

	vector<pair<char, int>> st;
	for (int j = n - 1; j > 0; --j) {
		st.push_back({s[j], j});
		while (sz(st)) {
			if (a[s[j - 1] - 'a'][st.back().x - 'a'])
				st.pop_back();
			else
				break;
		}
		if (sz(st))
			ok[j] = st.back().y;
		else
			ok[j] = n + 3;
	}
	ok[n] = n + 3;

	fill(nxt[n], nxt[n + 1], n + 3);
	for (int i = n; i--; ) {
		for (int j = 0; j < k; ++j)
			nxt[i][j] = nxt[i + 1][j];
		nxt[i][s[i] - 'a'] = i;
	}
	// cout << nxt[0][0] << endl;

	vector<int> curr;
	string ans;
	curr.push_back(0);
	while (sz(curr)) {
		if (s[curr[0]] == 0)
			break;
		ans += s[curr[0]];
		char cbest = 127;
		for (int j : curr)
			cbest = min(cbest, ask(j + 1, ok[j + 1]));

		if (cbest == 0) {
			curr = {n};
			continue;
		}

		vector<int> ncurr;
		for (int j : curr) {
			// cout << j << ":" << endl;
			for (int i = j + 1; i <= ok[j + 1]; ) {
				// cout << i << endl;
				// cout << "asking for " << i - 1 << " " << cbest << endl;
				i = nxt[i][cbest - 'a'];
				// cout << "after" << i << endl;
				if (i > ok[j + 1])
					break;
				assert(s[i] == cbest);
				ncurr.push_back(i);
				// cout << "from " << i << " to ";
				i = ok[i + 1] + 1;
				// cout << i << endl;
			}
		}
		vector<int> ncurr2;
		int mx = -1;
		for (int j : curr) {
			for (int i = j + 1; i <= ok[j + 1]; ++i) {
				// i = nxt[i][cbest - 'a'];
				if (s[i] == cbest && mx < ok[i + 1]) {
					mx = ok[i + 1];
					ncurr2.push_back(i);
				}
			}
		}
		assert(ncurr == ncurr2);

		curr = ncurr;
	}
	cout << ans;
	return 0;
}