// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <set>
#include <queue>

using namespace std;

int k, n;
bool aaa[26][26];
//int arr[501][501];
vector<vector<string>> dp(501, vector<string>(501));
string s;

bool check(int l, int r) {
	stack<int> st;
	for (int i = r; i > l; i--) {
		st.push(i);
		while (!st.empty()) {
			int c1 = s[i - 1] - 'a';
			int c2 = s[st.top()] - 'a';
			if (aaa[c1][c2]) {
				st.pop();
			}
			else {
				break;
			}
		}
	}
	if (st.empty()) return true;
	return false;
}

string solve(int l, int r) {
	if (dp[l][r] != "") return dp[l][r];
	string res = s.substr(l, r - l + 1);
	for (int m1 = l + 1; m1 <= r; m1++) {
		for (int m2 = m1; m2 <= r; m2++) {
			if (check(m1 - 1, m2)) {
				res = min(solve(l, m1 - 1) + solve(m2 + 1, r), res);
			}
		}
	}
	return dp[l][r] = res;
}

int main()
{
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			if (c == '1') {
				aaa[i][j] = true;
			}
			else {
				aaa[i][j] = false;
			}
		}
	}
	cin >> s;
	cout << solve(0, n - 1);
}