#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int n, m;
string s;

int solve() {
    if (!(cin >> n >> m))
        return 1;
    cin >> s;
    vector<map<int, char>> cards(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            cards[i][p] = c;
        }
    }

    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }

    do {
        vector<char> letters(m, '-');
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (letters[j] != '-' || cards[order[i]][j] == 0) continue;
                letters[j] = cards[order[i]][j];
            }
        }
        bool fail = false;
        for (int i = 0; i < m; ++i) {
            if (letters[i] != s[i]) {
                fail = true;
                break;
            }
        }
        if (fail) continue;
        for (int e : order) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
        return 0;
    } while (next_permutation(ALL(order)));
    cout << -1 << '\n';
    return 0;
}

int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
