#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int k, n;

int solve() {
    if (!(cin >> k >> n))
        return 1;
    vector<vector<bool>> can_delete(k, vector<bool>(k, false));
    for (int i = 0; i < k; ++i) {
        string e;
        cin >> e;
        for (int j = 0; j < k; ++j) {
            if (e[j] == '1') {
                can_delete[i][j] = true;
            }
        }
    }

    string s;
    cin >> s;
    vector<int> prev(n, -1);
    vector<bool> deleted(n, false);
    for (int i = 0; i < n - 1; ++i) {
        prev[i] = i + 1;
    }
    int len = s.size();
    while (len > 1) {
        bool changed = false;
        for (int j = n - 1; j >= 0; --j) {
            if (prev[j] == -1) continue;
            int c_o = s[j] - 'a';
            int c_j = s[prev[j]] - 'a';
            if (can_delete[c_o][c_j]) {
                changed = true;
                len--;
                deleted[prev[j]] = true;
                prev[j] = prev[prev[j]];
                break;
            }
        }
        if (!changed) {
            break;
        }
    }
    string ans;
    int c = 0;
    while (c != -1) {
        ans += s[c];
        c = prev[c];
    }
    cout << ans << '\n';
    return 0;
}

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
