#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;
const int MAX = 100010;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;

struct perf {
    vector <pair <int, char>> v;
    int ind;
};

perf a[MAX];

string s;

bool check(vector <pair <int, char>> &a) {
    int x = sz(s) - sz(a);
    for (auto i : a) {
        if (s[i.X] == i.Y)
            x++;
    }
    return x;
}

bool cmp(perf &a, perf &b) {
    return check(a.v) < check(b.v);
}

vector <int> ans;

bitset <MAX> used;

int sum = 0;

bool kek(int ind) {
    for (auto i : a[ind].v) {
        if (!used[i.X] && s[i.X] != i.Y)
            return false;
    }
    return true;
}

bitset <MAX> ff;

void get(int ind) {
    ff[a[ind].ind] = 1;
    for (auto i : a[ind].v) {
        if (!used[i.X])
            used[i.X] = 1, sum++;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, x, k;
    char y;
    cin >> n >> m;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        cin >> k;
        for (int j = 0; j < k; ++j) {
            cin >> x >> y;
            x--;
            a[i].v.pb({x, y});
        }
        a[i].ind = i + 1;
    }
    sort(a, a + n, cmp);
    int uk = n;
    while (sum < m) {
        int t = 0, r = uk;
        uk = 0;
        for (int i = 0; i < r; ++i) {
            if (kek(i)) {
                get(i);
                t++;
                ans.pb(a[i].ind);
            } else {
                a[uk] = a[i];
                uk++;
            }
            if (sum == m)
                break;
        }
        if (t == 0 && sum < m) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!ff[i])
            ans.pb(i);
    }
    if (sum != m) {
        cout << -1;
        return 0;
    }
    for (auto i : ans)
        cout << i << " ";
    return 0;
}
/*/
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
/*/
