#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
template<typename T>
inline int len(T& x) {
    return x.size();
}
bool used[32][32];
void paint(int i, int j) {
    for(int ii = i; ii < 32; ++ii) {
        for(int jj = j; jj < 32; ++jj) {
            used[ii][jj] = true;
        }
    }
}
int hm(int i, int j) {
    int res = 0;
    for(int ii = i; ii < 32; ++ii) {
        for(int jj = j; jj < 32; ++jj) {
            if(!used[ii][jj]) ++res;
        }
    }
    return res;
}
void play() {
    int n, k, m; cin >> n >> k >> m;
    string s; cin >> s;
    for(auto &i: s) i -= '0';
    int cb = 0;
    while(cb < m) {
        memset(used, 0, sizeof(used));
        while(true) {
            vector<pair<int, pii>> kek;
            for(int i = 0; i < n; ++i) {
                for(int j = 0; j < n; ++j) {
                    if(used[i][j]) continue;
                    if(cb < m && (i % 2 != s[cb] || j % 2 != s[cb + 1])) continue;
                    if(i == 0 && j == 0 && cb < m) continue;
                    kek.pb({(i == 0 && j == 0 ? -1 : hm(i, j)), pii{i, j}});
                }
            }
            sort(all(kek));
            if(!kek.empty()) {
                pii wut = kek[0].second;
                cout << wut.first + 1 << ' ' << wut.second + 1 << endl;
                if(wut == pii{0, 0}) break;
                cb += 2;
                paint(wut.first, wut.second);
            }
            else {
                cout << "1 1" << endl;
                break;
            }
            int x, y; cin >> x >> y; --x; --y;
            paint(x, y);
            if(x == 1 && y == 1) break;
        }
    }
    cout << 0 << endl;

}
void recover() {
    int n, k, m; cin >> n >> k >> m;
    string ans;
    int who = 0;
    int g; cin >> g;
    while(len(ans) < m) {
        int x, y; cin >> x >> y; --x; --y;
        if(x == 0 && y == 0) {
            who = 0;
            continue;
        }
        if(who == 0) ans.pb('0' + x % 2), ans.pb('0' + y % 2);
        who ^= 1;
    }
    cout << ans << endl;
}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int tp; cin >> tp;
    if(tp == 1) play();
    else recover();
}
/*
2
32 8 16
1
32 32
31 31
30 32
30 30
29 31
29 29
27 31
28 28
26 32
27 27
32 26
26 26
25 31
25 25
23 31
24 24
1 1

 */