#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = long long;
const ull MOD = 1566566543;
const ull BASE = 239;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
const int MAXK = 26;
const int MAXN = 1e4 + 7;
int matrix[MAXK][MAXK];
int rgt[MAXN];
int k, n;
string dp[MAXN];
string s;
int perm[MAXN];
int pos[MAXN];
ull bases[MAXN];
ull hashes[MAXN];
int opt[MAXN];

ull add(ull a, ull b){
    return (a +MOD + b) % MOD;
}
ull mul(ull a, ull b){
    return (a * b) % MOD;
}

void build(){
    bases[0] = 1;
    for (int i = 1; i <= n; i++)
        bases[i] = mul(bases[i - 1], BASE);
    for (int i = 0; i < n; i++)
        hashes[i + 1] = add(mul(hashes[i], BASE), s[i]);
}
ull get(int l, int r){
    return add(bases[r], -mul(bases[r - l], hashes[l]));
}

bool ls(int a, int b){
    if (a == b)
        return false;
    int l = 0, r = min(n - a, n - b) + 1;
    while (r - l > 1){
        int m = (l + r) / 2;
        if (get(a, a + m) == get(b, b + m))
            l = m;
        else
            r = m;
    }
    if (l == min(n - a, n - b))
        return a < b;
    return s[a + r] < s[b + r];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> k >> n;

    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            matrix[i][j] = (x == '1');
        }
    cin >> s;
    dp[n] = "";
    for (int i = 0; i < n; i++) {
        dp[i] = s.substr(i);
    }
    for (int i = n - 1; i >= 0; i--) {
        char c1 = s[i] - 'a';
        dp[i] = dp[i + 1];
        rgt[i] = i;
        for (int j = i + 1; j < n; j++) {
            char c2 = s[j] - 'a';
            if (!matrix[c1][c2] && j > rgt[i])
                break;
            rgt[i] = max(rgt[i], rgt[j]);
            dp[i] = min(dp[i], dp[j + 1]);
        }
        dp[i] = s[i] + dp[i];
    }
    for (int i = 0; i < n; i++)
        cout << rgt[i] << "\n";
//    for (int i = 0; i <= n; i++)
//        cout << i << ": " << dp[i] << '\n';
    cout << dp[0] << '\n';
    return 0;
}
