#include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void debug_out() {
    cerr << endl;
}

string to_string(const char* a) {
    return (string) a;
}

string to_string(string a) {
    return a;
}

string to_string(bool a) {
    return (a ? "true" : "false");
}

string to_string(const vector<int> &a) {
    string res = "";
    bool first = 1;
    for (auto &i : a) {
        if (!first) {
            res += ", ";
        }
        first = 0;
        res += to_string(i);
    }
    return res;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << ' ' << to_string(H);
    debug_out(T...);
}

//#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
//#else
//#define debug(...) 42

//#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;
    vector<string> a(n, string(m, 0));
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            char y;
            cin >> x >> y;
            --x;
            a[i][x] = y;
        }
    }
    vector<int> per(n);
    iota(all(per), 0);
    do {
        bool cond = 1;
        for (int i = 0; i < m && cond; i++) {
            for (int j = 0; j < n && cond; j++) {
                int jj = per[j];
                if (a[jj][i]) {
                    cond &= a[jj][i] == s[i];
                    break;
                } else if (j == n - 1) {
                    cond = 0;
                }
            }
        }
        if (cond) {
            for (auto &i : per) {
                cout << i + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(all(per)));
    cout << -1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
//    cin >> T;

    while (T-- > 0) {
        solve();
    }
    return 0;
}
