#include <iostream>
#include <vector>
#include <set>
#include <cassert>
#include <string>
#include <algorithm>


using namespace std;


#pragma warning(disable:4996)
#define x first
#define y second


bool mat[26][26];
bool can[2001][2001];
int mcan[2001];
int dp1[2005];
int dp2[2005];
int to[2005];
vector<int> st[26];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char el;
			cin >> el;
			if (el == '1')
				mat[i][j] = 1;
		}
	}
	for (int i = 0; i < n; i++)
		mcan[i] = -1;
	string s;
	cin >> s;
	for (int i = 0; i < s.size(); i++) {
		st[s[i] - 'a'].push_back(i);
	}
	for (int i = 0; i < n; i++)
		can[i][i] = 1;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = i + 1; j < n; j++) {
			if (mcan[j] >= i || mat[s[i] - 'a'][s[j] - 'a']) {
				can[i][j] = 1;
				mcan[j] = max(mcan[j], i);
			}
			else
				break;
		}
	}
	for (int i = 0; i < n; i++) {
		to[i] = i;
		for (int j = i + 1; j < n; j++) {
			if (can[i][j])
				to[i] = j;
			else
				break;
		}
	}
	if (can[0][n - 1]) {
		cout << s[0] << endl;
		return 0;
	}
	string ans = "";
	ans += s[0];
	dp1[0] = 1;
	while (1) {
		//cout << ans << "  p" << endl;
		set<int> last;
		for (int i = 0; i < n; i++) {
			if (dp1[i])
				last.insert(i);
		}
		for (char x = 0; x < k; x++) {
			bool f = 0;
			for (int i : last) {
				int j = to[i];
				auto it = upper_bound(st[x].begin(), st[x].end(), i);
				if (it != st[x].end() && *it <= j + 1) {
					f = 1;
					dp2[i + 1]++;
					dp2[j + 2]--;
				}
			}
			int b = 0;
			if (f == 1) {
				ans += 'a' + x;
				for (int i = 0; i < n; i++) {
					b += dp2[i];
					if (s[i] - 'a' == x) {
						dp2[i] = min(b, 1);
					}
					else
						dp2[i] = 0;
					if (dp2[i] && can[i][n - 1]) {
						cout << ans;
						return 0;
					}
					dp1[i] = dp2[i];
					dp2[i] = 0;
				}
				break;
			}
		}
	}
	cout << ans;
	return 0;
}