#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

typedef long long ll;

constexpr int ML = 1e2 + 5;
int n, m;

bitset<ML> used;
set<int> pos;

string tom;

vector<map<int, char>> all;

int next() {
    int ans = -1, mmt = 0;
    for (int j = 0; j < n; ++j) {
        if (used[j]) continue;
        bool fl = true;
        int mt = 0;
        for (auto i: pos) {
            if (all[j].count(i) != 0 && all[j][i] != tom[i]) {
                fl = false;
                break;
            } else if (all[j].count(i) != 0 && all[j][i] == tom[i]) {
                mt++;
            }
        }

        if (fl) {
            if (ans == -1 || mt > mmt) {
                ans = j;
                mmt = mt;
            }
        }
    }

    if (ans != -1) {
        vector<int> del;
        for (auto i: pos) {
            if (all[ans].count(i) != 0 && all[ans][i] == tom[i]) {
                del.push_back(i);
            }
        }

        for (auto en: del) pos.erase(en);
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    all.resize(n);

    cin >> tom;

    for (int i = 0; i < m; ++i) {
        pos.insert(i);
    }

    for (int i = 0; i  < n; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int p;
            char ch;
            cin >> p >> ch;
            --p;

            all[i][p] = ch;
        }
    }

    vector<int> ans;
    while (!pos.empty()) {
        int nxt = next();

        if (nxt == -1) {
            cout << "-1\n";
            return;
        }

        ans.push_back(nxt);
        used[nxt] = true;
    }

    for (auto en: ans) {
        cout << en + 1<< ' ';
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cout << i + 1 << ' ';
        }
    }
}

signed main() {
    ioBoost;

    solve();

    return 0;
}