#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pii pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
const ll MAXN = 5e5 + 10;

using namespace std;

bool can_delete[27][27];
int sz[MAXN];
int p[MAXN];
int ind[MAXN];
int n, k;

bool lst(int i) {
    return i + sz[i] == n - 1;
}

string s;
set<int> nused;

string answer_find(vi st) {
    char cur_char = s[st[0]];
    for (int i : st) {
        if (lst(i)) return {cur_char};
    }
    vvi new_st(26);
    for (int i : st) {
        for (auto j = nused.upper_bound(i); j != nused.end() || (*j) <= i + sz[i] + 1; j = nused.upper_bound(*j)) {
            new_st[s[*j] - 'a'].push_back(*j);
            nused.erase(j);
        }
    }
    for (int i = 0; i < 26; ++i) {
        if (new_st[i].size()) {
            string my_ans = answer_find(new_st[i]);
            if (my_ans.size()) return my_ans + cur_char;
        }
    }

}

void solve() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c; cin >> c;
            can_delete[i][j] = c - '0';
        }
    }
    cin >> s;
    for (int i = n - 1; i > -1; --i) {
        if (i == n - 1) continue;
        while (i + sz[i] + 1 < n && can_delete[s[i] - 'a'][s[i + sz[i] + 1] - 'a']) {
            sz[i] += sz[i + sz[i] + 1] + 1;
        }
    }
    for (int i = 0; i < n; ++i) nused.insert(i);
    string ans = answer_find({0});
    reverse(all(ans));
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
