#define _USE_MATH_DEFINES
#define sqr(x) (x)*(x)
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <random>
#include <iomanip>
#include <chrono>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int n, m, p = 0;
string s;
vector<vector<pair<int, char>>> v;
vector<int> ans(n, -1), used(n), skip(m);
vector<int> bads(n);
vector<vector<int>> needs(n);

void set_cur(int i) {
	ans[p] = i;
	p++;
	for (int j = 0; j < v[i].size(); j++) {
		skip[v[i][j].first] = 1;
		for (int j : needs[v[i][j].first]) {
			bads[j]--;
			if (bads[j] == 0)
				set_cur(j);
		}
		needs[v[i][j].first].clear();
	}
}

int main() {
	fast;
	cin >> n >> m >> s;
	v.resize(n);
	ans.resize(n, -1);
	used.resize(n);
	bads.resize(n);
	needs.resize(m);
	skip.resize(m);
	for (int i = 0; i < n; i++) {
		int k, a;
		char c;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> a >> c;
			v[i][j] = { --a, c };
			if (s[a] != c) {
				bads[i]++;
				needs[a].push_back(i);
			}
		}
		if (bads[i] == 0)
			set_cur(i);
	}
	bool flag = 1;
	for (int i = 0; i < n; i++)
		if (ans[i] == -1)
			flag = 0;
	for (int i = 0; i < m; i++)
		if (!skip[i]) flag = 0;
	if (!flag) {
		cout << -1;
		exit(0);
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] + 1 << " ";
}