#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

const int MAX_K = 26;

bool can[MAX_K][MAX_K];

struct my_string {
	string * s;
	my_string():
		s(nullptr)
	{};
	my_string(char c) {
		s = new string();
		s->push_back(c);
	}
	my_string(my_string old, char append) :
		s(old.s)
	{
		s->push_back(append);
	}

};

void solve() {
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++)
			can[i][j] = (s[j] == '1');
	}
	vector<vector<int>> strings;
	char c;
	cin >> c;
	strings.push_back(vector<int>());
	strings[0].push_back(c - 'a');
	for (int i = 1; i < n; i++) {
		char c;
		cin >> c;
		c -= 'a';
		vector<vector<int>> newstrings;
		for (int j = 0; j < strings.size(); j++) {
			newstrings.push_back(vector<int>());
			for (int val : strings[j])
				newstrings.back().push_back(val);
			newstrings.back().push_back(c);
			while (newstrings.back().size() > 1 &&
				can[(*----newstrings.back().end())][(*--newstrings.back().end())]) {
				newstrings.push_back(vector<int>());
				for (int val : (*----newstrings.end()))
					newstrings.back().push_back(val);
				newstrings.back().pop_back();
			}
		}
		sort(all(newstrings));
		strings.clear();
		vector<bool> used(k);
		for (int i = 0; i < newstrings.size(); i++)
			if (!used[newstrings[i].back()]) {
				used[newstrings[i].back()] = true;
				strings.push_back(newstrings[i]);
			}
		newstrings.clear();
	}
	for (int val : strings[0])
		cout << (char)(val + 'a');
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}