#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector <int> s;
  {
    string tmp;
    cin >> tmp;
    for (auto &now : tmp) {
      s.push_back(now - 'a');
    }
  }
  vector <map <int, int>> all(n);
  for (int i = 0; i < n; i++) {
    int k;
    cin >> k;
    for (int j = 0; j < k; j++) {
      pii tmp;
      cin >> tmp.first;
      tmp.first--;
      char c;
      cin >> c;
      tmp.second = c - 'a';
      all[i][tmp.first] = tmp.second;
    }
  }
  set <pair <pii, int>> se; // {{wrong, -right}, id}
  vector <set <int>> vhod(m);
  vector <int> wrong(n), right(n);
  for (int i = 0; i < n; i++) {
    for (auto &now : all[i]) {
      vhod[now.first].insert(i);
      if (s[now.first] == now.second) {
        right[i]--;
      } else {
        wrong[i]++;
      }
    }
    se.insert({{wrong[i], right[i]}, i});
  }
  vector <int> p;
  int cnt_all = m;
  while (!se.empty()) {
    int id = se.begin()->second;
    se.erase(se.begin());
    cnt_all += right[id];
    if (wrong[id]) {
      cout << -1;
      return 0;
    }
    p.push_back(id + 1);
    for (auto &now : all[id]) {
      vhod[now.first].erase(id);
    }
    for (auto &now : all[id]) {
      for (auto &j : vhod[now.first]) {
        se.erase({{wrong[j], right[j]}, j});
        if (all[j][now.first] == s[now.first]) {
          right[j]++;
        } else {
          wrong[j]--;
        }
        all[j].erase(now.first);
        se.insert({{wrong[j], right[j]}, j});
      }
    }
    /*cout << "BEGIN" << endl;
    for (int i = 0; i < n; i++) {
      cout << wrong[i] << ' ' << right[i] << endl;
    }
    cout << "END" << endl;*/
  }
  if (cnt_all) {
    cout << -1;
    return 0;
  }
  for (auto &now : p) {
    cout << now << ' ';
  }
  return 0;
}

/*
1
1
a
1 1 a
 */

/*
3 4
 glhf
 3 1 r 3 h 4 i
 3 1 r 2 l 3 o
 2 1 g 4 f

 */