#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <random>
#include <chrono>

using namespace std;
using ll = long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll n, m, k, q;

vector <string> f;

bool ok(char a, char b) {
	return f[a - 97][b - 97] == '1';
}

int main() {
	cin >> k >> n;
	f.resize(k);
	for (auto& x : f) {
		cin >> x;
	}
	string s;
	cin >> s;
	string ans(n, 'z');
	vector <bool> used(n);
	vector <string> kek;
	for (ll mask = 0; mask < (1 << n); ++mask) {
		if (mask & 1) {
			used.assign(n, false);
			string cur = "";
			for (int i = 0; i < n; ++i) {
				if (mask & (1 << i)) {
					used[i] = true;
					cur += s[i];
				}
			}
			kek.clear();
			for (int i = 0; i < n; ++i) {
				if (used[i]) {
					kek.emplace_back();
				}
				kek.back() += s[i];
			}
			bool nice = true;
			for (int i = 0; i < kek.size(); ++i) {
				for (int j = kek[i].size() - 1; j >= 1; --j) {
					if (ok(kek[i][j - 1], kek[i][j])) {
						kek[i].erase(kek[i].begin() + j);
						if (j <= kek[i].size() - 1) ++j;
					}
				}
				if (kek[i].size() != 1) {
					nice = false;
					break;
				}
			}
			if (nice) {
				ans = min(ans, cur);
			}
		}
	}
	cout << ans << '\n';
	return 0;
}
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/