#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int N = 1e5;

unordered_map <int, char> p[N];

vi hv[3 * N];

void solve() {
    int n, m; cin >> n >> m;
    string s; cin >> s;

    vi cnt(n);

    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int x; cin >> x;
            cin >> p[i][x];
            hv[x].pb(i);
            if (s[x - 1] != p[i][x])
                cnt[i]++;
        }
    }

    set <pii> q;
    for (int i = 0; i < n; i++)
        q.insert(mp(cnt[i], i));

    vi ans;
    set <int> used;
    while (!q.empty()) {
        int i = q.begin()->se;
        q.erase(q.begin());
        if (cnt[i] != 0) {
            cout << -1; return;
        }
        ans.pb(i + 1);

        for (auto j : p[i]) {
            used.insert(j.fi);
            for (int k : hv[j.fi]) {
                if (k == i) continue;
                if (p[k][j.fi] != j.se) {
                    q.erase(mp(cnt[k], k));
                    cnt[k]--;
                    q.insert(mp(cnt[k], k));
                }
                p[k].erase(j.fi);
            }
        }
        p[i].clear();
    }

    if (used.size() != m) {
        cout << -1; return;
    }
    for (int i : ans)
        cout << i << ' ';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
