#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

vector<int> g[100000];
vector<int> a0[100000], a[100000];

bool cmp(int x, int y) {
    return a[x][0] < a[y][0];
}

bool dfs(int u) {
    if (g[u].empty()) {
        return 1;
    }
    for (auto &v : g[u]) {
        if (!dfs(v)) {
            return 0;
        }
    }
    sort(all(g[u]), cmp);
    a[u].clear();
    copy(all(a[g[u][0]]), back_inserter(a[u]));
    for (int i = 1; i < g[u].size(); i++) {
        if (a[g[u][i]][0] < a[u].back()) {
            return 0;
        }
        copy(all(a[g[u][i]]), back_inserter(a[u]));
    }
    return 1;
}

void gen(int i, int n) {
    if (i == n) {
        if (dfs(0)) {
            cout << "Yes\n";
            for (int j = 0; j < n; j++) {
                if (!g[j].empty()) {
                    for (int u : g[j]) {
                        cout << u + 1 << ' ';
                    }
                    cout << endl;
                } else {
                    cout << a[j][0] << endl;
                }
            }
            exit(0);
        }
        return;
    }
    if (a0[i].empty()) {
        gen(i + 1, n);
    } else {
        for (int j : a0[i]) {
            a[i].push_back(j);
            gen(i + 1, n);
            a[i].pop_back();
        }
    }
}

signed main() {
    fastream;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int u;
                cin >> u;
                u--;
                g[i].push_back(u);
            }
        } else {
            int k;
            cin >> k;
            a0[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> a0[i][j];
            }
        }
    }
    gen(0, n);
    cout << "No\n";
}