#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

#define int long long
#define double long double

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<pair<int, char>> ltt[n];
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        ltt[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> ltt[i][j].first >> ltt[i][j].second;
            ltt[i][j].first--;
        }
    }

    int res[n];
    bool used[n];
    memset(used, false, sizeof(used));

    for (int ri = 0; ri < n; ri++) {
        bool hds = false;
        for (int i = 0; i < n; i++) {
            if (used[i]) {
                continue;
            }
            bool ok = true;
            for (auto p : ltt[i]) {
                if (s[p.first] == '_' || s[p.first] == p.second) {
                    continue;
                }
                ok = false;
                break;
            }
            if (ok) {
                used[i] = true;
                hds = true;
                res[ri] = i;
                for (auto p : ltt[i]) {
                    s[p.first] = '_';
                }
                break;
            }
        }
        if (!hds) {
            cout << "-1\n";
            return;
        }
    }

    for (int i = 0; i < n; i++) {
        cout << res[i] + 1 << (i == n - 1 ? endl : " ");
    }
}

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
