#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

const int N = 1 << 19;
int up_to[N];

bool can[300][300];

string dp[2 * N];

void add(int i, string x) {
	i += N;
	dp[i] = x;
	i /= 2;
	while (i > 0) {
		dp[i] = min(dp[2 * i], dp[2 * i + 1]);
		i /= 2;
	}
}

string get_min(int l, int r) {
	string ans;
	bool c = true;
	l += N;
	r += N + 1;
	for (; l < r; l /= 2, r /= 2) {
		if (l & 1) {
			if (c) {
				ans = dp[l];
				c = false;
			}
			else ans = min(ans, dp[l]);
			l++;
		}
		if (r & 1) {
			--r;
			if (c) {
				ans = dp[r];
				c = false;
			}
			else ans = min(ans, dp[r]);
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int k, n;
	cin >> k >> n;
	rep(i, k) {
		string tmp;
		cin >> tmp;
		rep(j, k) {
			if (tmp[j] == '1') {
				can[i + 'a'][j + 'a'] = true;
			}
		}
	}
	string s;
	cin >> s;
	per(i, n) {
		int ind = i + 1;
		while (ind < n && can[s[i]][s[ind]]) {
			ind = up_to[ind];
		}
		up_to[i] = ind;
	}
	per(i, n) {
		add(i, string(1, s[i]) + get_min(i + 1, up_to[i]));
	}
	cout << dp[N];
	return 0;
}