#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int N = 26;
const long long MINF = -1e18;
vector<long long> val(N);

void solve(string & s)
{
    int n = s.size();
    reverse(s.begin(), s.end());
    vector<vector<long long>> ans(n + 1, vector<long long>(26));
    for (int i = 0; i < n; ++i)
    {
	if (s[i] != '?')
	{
	    int ci = s[i] - 'A';
	    long long m = ans[i][0];
	    for (int cj = 0; cj <= ci; ++cj)
            {
		m = max(m, ans[i][cj]);
	        ans[i + 1][cj] = MINF;
	    }
	    ans[i + 1][ci] = m + val[ci];
	    for (int cj = ci + 1; cj < N; ++cj)
	       ans[i + 1][cj] = ans[i][cj] - val[ci];
	}
	else
	{
	    long long m = ans[i][0];
	    for (int cj = 0; cj < N; ++cj)
	    {
	        m = max(m, ans[i][cj]);
		ans[i + 1][cj] = m + val[cj];
            }
	}
    }
    int curr_max = max_element(ans[n].begin(), ans[n].end()) - ans[n].begin();
    cout << ans[n][curr_max] << endl;
    string ans_str;
    for (int i = n - 1; i >= 0; --i)
    {
	if (s[i] != '?')
	    ans_str.push_back(s[i]);
	else
	    ans_str.push_back('A' + curr_max);
	curr_max = max_element(ans[i].begin(), ans[i].begin() + curr_max + 1) - ans[i].begin();
    }
    cout << ans_str << endl;
}


int main()
{
    val[0] = 1;
    val[1] = 5;
    for (int i = 2; i < N; ++i)
	val[i] = 10 * val[i - 2];
    int t;
    cin >> t;
    while (t--)
    {
    	string s;
	cin >> s;
	solve(s);
    }
}

/*
def solve(s):
    ans = [0] * N
    for c in s[::-1]:
        if c != '?':
            c = ord(c) - ord('A')
            ans[c] = val[c] + max(ans[:c + 1])
            for i in range(c + 1, N):
                ans[i] -= val[c]
            for i in range(0, c):
                ans[i] = MINF
        else:
            m = ans[0]
            for i in range(N):
                m = max(m, ans[i])
                ans[i] = m + val[i]
    print(max(ans))


for t in range(int(input())):
    solve(input())
*/
