#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> ans;
vector<pair<int, int>> best;
vector<int> way;

void dfs(int now, int p, int cost) {
    if (p != -1) {
        best[now].first = min(best[p].first, cost);
        best[now].second = max(best[p].second, cost);
    }
    ans[now] = best[now].first + best[now].second;
    for (auto i : g[now]) {
        if (i.first == p) continue;
        dfs(i.first, now, i.second);
    }
}

bool in(int x, int y) {
    for (int i = 0; i < way.size() - 1; i++) {
        if (x == way[i] && y == way[i + 1] || (x == way[i + 1] && y == way[i])) return true;
    }
    return false;
}

void solve(int now, int min1, int max1) {
    ans[now] = min(ans[now], min1 + max1);
    for (auto to : g[now]) {
        if (!in(now, to.first)) {
            way.push_back(to.first);
            solve(to.first, min(min1, to.second), max(max1, to.second));
            way.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    ans.assign(n, 2e9);
    best.assign(n, {1e9, 0});
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        g[v - 1].push_back({u - 1, t});
        g[u - 1].push_back({v - 1, t});
    }
    if (m == n - 1) dfs(0, -1, 0);
    else if (n <= 20 && m <= 20) {
        way = {0};
        solve(0, 1e9, 0);
    }
    for (int i = 1; i < n; i++) cout << ans[i] << '\n';
}