#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>

using namespace std;
#define int long long
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define firn(i, n) for(int i = 1; i < (int)n; i++)
vector<vector<int>>g, g1, g2;
vector<int>used, dist, col, used2;
int cnt = 0;
map<pair<int, int>, int> mp;
vector<pair<pair<int, int>, pair<int, int>>>ans;
void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u]) {
			dist[u] = dist[v] + 1;
			col[u] = 1 - col[v];
			dfs(u);
		}
	}
}
void dfs2(int v) {
	used2[v] = 1;
	for (auto u : g[v]) {
		if (!used2[u]) {	
			dfs2(u);
		}
	}
	
	int l = 0;
	int r = 0;
	while (l < (int)g1[v].size()) {
		if (dist[v] > dist[g1[v][l]] || mp[{v, g1[v][l]}] == 0) {
			l++;
			if (l == (int)g1[v].size()) {
				break;
			}
			continue;
		}
		while (r < (int)g2[v].size()) {
			if (dist[v] > dist[g2[v][r]] || mp[{g2[v][r], v}] == 0) {
				r++;
			}
			else {
				break;
			}
		}
		if (r < (int)g2[v].size()) {
			pair<int, int>ed1, ed2;
			ed1.first = v;
			ed1.second = g1[v][l];
			ed2.second = v;
			ed2.first = g2[v][r];
			mp[{v, g1[v][l]}] = 0;
			mp[{g2[v][r], v}] = 0;
			ans.push_back({ ed1, ed2 });
		}
		else {
			break;
		}

	}
	int ind1 = -1;
	forn(i, g1[v].size()){
		if (dist[v] < dist[g1[v][i]] && mp[{v, g1[v][i]}] == 1) {
			ind1 = i;
		}
	}
	if (ind1 != -1) {
		forn(i, g2[v].size()) {
			if (mp[{g2[v][i], v}] == 1) {
				pair<int, int>ed1, ed2;
				ed1.first = v;
				ed1.second = g1[v][ind1];
				ed2.second = v;
				ed2.first = g2[v][i];
				mp[{v, g1[v][ind1]}] = 0;
				mp[{g2[v][i], v}] = 0;
				ans.push_back({ ed1, ed2 });
			}
		}
	}
	else {
		int ind2 = -1;
		forn(i, g2[v].size()) {
			if (dist[v] < dist[g2[v][i]] && mp[{g2[v][i], v}] == 1) {
				ind2 = i;
				break;
			}
		}
		if (ind2 != -1) {
			forn(i, g1[v].size()) {
				if (mp[{v, g1[v][i]}] == 1) {

					pair<int, int>ed1, ed2;
					ed1.first = v;
					ed1.second = g1[v][i];
					ed2.second = v;
					ed2.first = g2[v][ind2];
					mp[{v, g1[v][i]}] = 0;
					mp[{g2[v][ind2], v}] = 0;
					ans.push_back({ ed1, ed2 });
				}
			}
		}
	}
}
signed main() {
	int n, m;
	map<pair<int, int>, int> mp2;

	cin >> n >> m;
	used.resize(n);
	dist.resize(n);
	col.resize(n);
	used.resize(n);
	used2.resize(n);
	g1.resize(n);
	g2.resize(n);
	g.resize(n);
	forn(i, m) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g1[u].push_back(v);
		g2[v].push_back(u);
		if (mp2[{u, v}] == 0) {
			mp2[{u, v }] = 1;
			mp[{u, v }] = 1;
			mp2[{v, u }] = 1;
			mp[{v, u }] = 1;
			g[u].push_back(v);
			g[v].push_back(u);
		}
	}
	forn(i, n) {
		if (!used[i]) {
			dfs(i);
			dfs2(i);
		}
	}
	if (ans.size() != m / 2) {
		cout << "No";
		return 0;
	}
	cout << "Yes" << '\n';
	forn(i, m / 2) {
		cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << '\n';
	}
	return 0;
}