#include <bits/stdc++.h>
  
using namespace std;
  
#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair
#define chkmin(a, b) a = min(a, b)
const int inf = 2e9 + 8;
const int max_n = 5e5 + 3;
int n, m;
 
vector<pii> gr[max_n];
int tin[max_n], fup[max_n], T = 1;
bool used[max_n];

int all_res = inf;
int res[max_n];

set<pii> brid;

void dfs(int v, pii pr) {
	tin[v] = fup[v] = T++;
	for(pii to : gr[v]) {
		if (to == pr) {
			pr = mp(-1, -1);
			continue;
		}

		if (tin[to.fi] == 0) {
			dfs(to.fi, mp(v, to.se));
		}
		chkmin(fup[v], fup[to.fi]);
		if (fup[to.fi] <= tin[v]) {
			chkmin(res[v], to.se);
			chkmin(res[to.fi], to.se);
		}else {
			brid.emplace(mp(v, to.fi));
			brid.emplace(mp(to.fi, v));
		}
	}
}

void dfs2(int v) {
	if (used[v]) return;
	used[v] = true;
	for(pii to : gr[v]) {
		if (brid.find(mp(v, to.fi)) == brid.end()) chkmin(res[to.fi], res[v]);
		dfs2(to.fi);
		if (brid.find(mp(v, to.fi)) == brid.end()) chkmin(res[v], res[to.fi]);
	}
}


void dfs1(int v, int mn) {
	if (used[v]) return;
	used[v] = true;
	chkmin(mn, res[v]);
	chkmin(res[v], mn);
	for(pii to : gr[v]) {	
		dfs1(to.fi, min(mn, to.se));
	}
}


void solve() {
    cin >> n >> m;
    for(int i = 0;i < m;i++) {
        int v1, v2, c;
        cin >> v1 >> v2 >> c;
        gr[--v1].emplace_back(--v2, c);
        gr[v2].emplace_back(v1, c);
    }
    for(int i = 0;i < n;i++)
    	res[i] = inf;

    dfs(0, mp(-1, -1));
    //cout << all_res << endl;

    for(int it = 0;it < 10;it++) {
    	dfs2(0);
    	fill(used, used + n, false);
	}

    dfs1(0, inf);

    for(int i = 1;i < n;i++)
    	cout << 1000000000 + min(res[i], all_res) << endl;
}   
 
 
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
  
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
  
    solve();
}