#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, q;
	cin >> n >> q;
	vector<ll> x(n);
	vector<ll> h(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> h[i];
	}
	vector<ll> dl(n, 0), dr(n, 0);
	vector<ll> v;
	dl[0] = 1e18;
	dr[n - 1] = 1e18;
	for (int i = 0; i < n - 1; i++) {
		ll j = i;
		v.push_back(i);
		ll cnt = 0;
		while ((i > 0 && x[j] - h[j] >= x[i - 1]) || (i + 1 < n && x[j] + h[j] <= x[i + 1])) {
			dr[j] += cnt;
			v.pop_back();
			if (v.empty()) {
				break;
			}
			j = v.back();
			cnt++;
		}


	}
	for (int i = n - 1; i > 0; i--) {
		ll j = i;
		v.push_back(i);
		ll cnt = 0;
		while ((i > 0 && x[j] - h[j] >= x[i - 1]) || (i + 1 < n && x[j] + h[j] <= x[i + 1])) {
			dl[j] += cnt;
			v.pop_back();
			if (v.empty()) {
				break;
			}
			j = v.back();
			cnt++;
		}
	}
	vector<ll> used(n, 1e18);
	while (q--) {
		ll l, r;
		cin >> l >> r;
		l--;
		r--;
		ll i = l;
		ll cnt = 0;
		while (i <= r) {
			if (dl[i] <= cnt) {
				cnt++;
				used[i] = q;
			}
			else {
				cnt = 0;
			}
			i++;
		}
		i = r;
		cnt = 0;
		while (i >= l) {
			if (dr[i] <= cnt || used[i] == q) {
				cnt++;
				used[i] = q;
			}
			else {
				cnt = 0;
			}
			i--;
		}
		cnt = 0;
		for (int j = l; j <= r; j++) {
			if (used[j] == q) {
				cnt++;
			}
		}
		cout << cnt << "\n";
	}
}