#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int n;
vector<vector<pair<int, int>>> a;
vector<vector<int>> ind;
vector<int> ans;
vector<char> used;
int t{};

void dfs(int v, int mn, int mx) {
	t++;
	if (t > 1e7) return;
	if (mn + mx < ans[v]) ans[v] = mn + mx;
	int m = a[v].size();
	for (int i{}; i < m; ++i) {
		if (used[ind[v][i]]) continue;
		int w = a[v][i].y;
		used[ind[v][i]] = true;
		dfs(a[v][i].x, min(mn, w), max(mx, w));
		used[ind[v][i]] = false;
	}
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int m;
	cin >> n >> m;
	a.resize(n);
	ind.resize(n);
	ans.resize(n, inf + inf);
	used.resize(m);

	int x, y, w;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		a[x].push_back({ y, w });
		a[y].push_back({ x, w });
		ind[x].push_back(i);
		ind[y].push_back(i);
	}

	dfs(0, inf, -inf);

	for (int i{ 1 }; i < n; ++i) {
		cout << ans[i] << '\n';
	}
	return 0;
}