#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

map<char, ll> mp;
const int N = (int) 3e5 + 10;

ll dp[N][256];
char par[N][256];
char prevMx[N][256];

void Upd(char c, int i) {
    for (char mx = 'A'; mx <= 'Z'; mx++) {
        if (dp[i + 1][mx] == LLONG_MIN)
            continue;
        ll lans;
        if (mx <= c) {
            lans = dp[i + 1][mx] + mp[c];
        } else {
            lans = dp[i + 1][mx] - mp[c];
        }
        if (dp[i][max(mx, c)] < lans) {
            dp[i][max(mx, c)] = lans;
            par[i][max(mx, c)] = c;
            prevMx[i][max(mx, c)] = mx;
        }
    }
}

ll Calc(const string& s) {
    ll ans = 0;
    char sufMx = 'A';
    for (int i = sz(s) - 1; i >= 0; i--) {
        char cur = s[i];
        int sign = sufMx > cur ? -1 : 1;
        ans += sign * mp[cur];
        maxq(sufMx, cur);
    }
    return ans;
}

void Solve() {
    string s;
    cin >> s;
    int n = sz(s);
    forn(i, n + 1) {
        for (char c = 'A'; c <= 'Z'; c++)
            dp[i][c] = LLONG_MIN;
    }
    if (s.back() != '?') {
        dp[n - 1][s.back()] = mp[s.back()];
        par[n - 1][s.back()] = s.back();
    }
    else {
        for (char c = 'A'; c <= 'Z'; c++) {
            dp[n - 1][c] = mp[c];
            par[n - 1][c] = c;
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        if (s[i] == '?') {
            for (char c = 'A'; c <= 'Z'; c++) {
                Upd(c, i);
            }
        } else {
            Upd(s[i], i);
        }
    }
    char mx = 'A';
    for (char c = 'A'; c <= 'Z'; c++) {
        if (dp[0][mx] < dp[0][c])
            mx = c;
    }
    string ans;
    for (int i = 0; i < n; i++) {
        ans += par[i][mx];
        mx = prevMx[i][mx];
    }
    cout << Calc(ans) << nl << ans << nl;
}

signed main() {
    ull v = 1;
    for (char c = 'A'; c <= 'Z'; c++) {
        mp[c] = v;
        if ((c - 'A') & 1)
            v *= 2;
        else
            v *= 5;
    }
    IO();
    int t = 1;
    cin >> t;
    forn(i, t) {
        Solve();
    }
}
