#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e5 + 100;
int p[MAXN];
int ep[MAXN];
vector<int> ndg[MAXN];
int used[MAXN];

vector<int> g[MAXN];

void calc_p(int v) {
    used[v] = true;
    for (auto u : ndg[v]) {
        if (!used[u]) {
            g[v].push_back(u);
            p[u] = v;
            calc_p(u);
        }
    }
}

int dp[MAXN][4];

void dfs(int v) {
    for (auto u : g[v]) {
        dfs(u);
        int sum = 0;
        for (int i = 0; i < 4; ++i) {
            sum += dp[u][i];
        }
        if (sum == 0) {
            dp[v][0] = dp[v][1] = dp[v][2] = dp[v][3] = 0;
            return;
        }
    }
    for (int mask = 0; mask < 4; ++mask) {
        if ((mask & ep[v]) != mask) {
            dp[v][mask] = 0;
            continue;
        }
        int t = 0;
        if (mask == 1) {
            t--;
        } else if (mask == 2) {
            t++;
        }
        int k = 0;
        for (auto u : g[v]) {
            if (ep[u] < 3) {
                if (dp[u][0] == 1) {
                    if (ep[u] == 1) {
                        t++;
                    } else {
                        t--;
                    }
                }
            } else {
                if (dp[u][0] == 1) {
                    continue;
                }
                if (dp[u][1] == 1 && dp[v][2] == 1) {
                    k++;
                } else if (dp[u][1] == 1) {
                    t--;
                } else if (dp[u][2] == 1) {
                    t++;
                }
            }
        }
        if ((k - t) % 2 == 0 && abs(t) <= k) {
            dp[v][mask] = 1;
        } else {
            dp[v][mask] = 0;
        }
    }
    /// cout << "v: " << v << endl;
    /// cout << dp[v][0] << " " << dp[v][1] << " " << dp[v][2] << " " << dp[v][3] << endl;
}

void build(int v, int mask) {
    vector<int> in, out;
    if (mask == 1) {
        in.push_back(p[v]); /// t--;
    } else if (mask == 2) {
        out.push_back(p[v]); /// t++;
    } else if (mask == 3) {
        in.push_back(p[v]);
        out.push_back(p[v]);
    }
    vector<int> both;
    for (auto u : g[v]) {
        if (ep[u] < 3) {
            if (dp[u][0] == 1) {
                build(u, 0);
                if (ep[u] == 1) {
                    out.push_back(u);
                } else {
                    in.push_back(u);
                }
            } else {
                build(u, ep[u]);
            }
        } else {
            if (dp[u][0] == 1) {
                build(u, 3);
                continue;
            }
            if (dp[u][1] == 1 && dp[v][2] == 1) {
                both.push_back(u);
            } else if (dp[u][1] == 1) {
                build(u, 1);
                in.push_back(u);
            } else if (dp[u][2] == 1) {
                build(u, 2);
                out.push_back(u);
            }
        }
    }
    while (in.size() < out.size()) {
        in.push_back(both.back());
        build(both.back(), 1);
        both.pop_back();
    }
    while (in.size() > out.size()) {
        out.push_back(both.back());
        build(both.back(), 2);
        both.pop_back();
    }
    while (!both.empty()) {
        in.push_back(both.back());
        build(both.back(), 1);
        both.pop_back();
        out.push_back(both.back());
        build(both.back(), 2);
        both.pop_back();
    }
    for (int i = 0; i < in.size(); ++i) {
        cout << in[i] + 1 << " " << v + 1 << " " << v + 1 << " " << out[i] + 1 << endl;
    }
}

main() {
    int n, m;
    cin >> n >> m;
    vector<array<int, 2>> edg;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edg.push_back({u, v});
        ndg[u].push_back(v);
        ndg[v].push_back(u);
    }
    vector<int> root;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            p[i] = -1;
            root.push_back(i);
            calc_p(i);
        }
    }
    for (auto e : edg) {
        int u = e[0], v = e[1];
        if (p[u] == v) {
            ep[u] |= 2;
        } else {
            ep[v] |= 1;
        }
    }
    for (auto r : root) {
        dfs(r);
        if (dp[r][0] == 0) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (auto r : root) {
        build(r, 0);
    }
    return 0;
}
/**
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
