#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 3e5 + 100, INF = 1e9;
vector<array<int, 2>> g[MAXN];
int w[MAXN];
int n, m;

int d[MAXN], up[MAXN];
int ans[MAXN];
int used[MAXN], p[MAXN];
int is_b[MAXN];

void find_b(int v) {
    /// cout << v << endl;
    up[v] = d[v];
    used[v] = true;
    int cnt = 0;
    for (auto e : g[v]) {
        int u = e[0];
        if (!used[u]) {
            p[u] = v;
            d[u] = d[v] + 1;
            find_b(u);
            up[v] = min(up[u], up[v]);
        } else if (u != p[v]) {
            up[v] = min(up[v], d[u]);
        } else {
            cnt++;
        }
    }
    /// cout << v << " " << up[v] << endl;
    if (cnt > 1) {
        up[v] = min(up[v], d[p[v]]);
    }
    if (up[v] == d[v]) {
        is_b[v] = true;
    }
}

int col[MAXN];
int cur = 0;

void color(int v, int c) {
    /// cout << v << endl;
    col[v] = c;
    used[v] = 1;
    for (auto e : g[v]) {
        int u = e[0];
        if (!used[u]) {
            if (is_b[u]) {
                cur++;
                color(u, cur);
            } else {
                color(u, c);
            }
        }
    }
}

int val[MAXN];
vector<array<int, 2>> e[MAXN];

vector<int> path;

array<int, 2> op(array<int, 2> a, array<int, 2> b) {
    return {min(a[0], b[0]), max(a[1], b[1])};
}

void dfs(int v) {
    used[v] = true;
    ans[v] = path.back();
    for (auto ed : e[v]) {
        int u = ed[0], i = ed[1];
        if (!used[u]) {
            path.push_back(min(path.back(), min(w[i], val[u])));
            dfs(u);
            path.pop_back();
        }
    }
}

array<int, 2> ed[MAXN];

main() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        ed[i] = {u, v};
        cin >> w[i];
        if (u == 0 || v == 0) {
            assert(w[i] == INF);
        }
    }
    fill(ans, ans + n, 2 * INF);
    d[0] = 0;
    find_b(0);
    fill(used, used + n, 0);
    color(0, 0);
    cur++;
    fill(val, val + cur, INF);
    /**for (int i = 0; i < n; ++i) {
        cout << is_b[i] << " ";
    }
    cout << endl;*/
    for (int i = 0; i < m; ++i) {
        int u = ed[i][0], v = ed[i][1];
        if (col[u] == col[v]) {
            val[col[u]] = min(val[col[u]], w[i]);
        } else {
            if (u > v) {
                swap(u, v);
            }
            e[u].push_back({v, i});
        }
    }
    path.push_back(val[0]);
    fill(used, used + n, 0);
    dfs(0);
    for (int i = 0; i < cur; ++i) {
        assert(!used[i]);
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[col[i]] + INF << endl;
    }
    return 0;
}
