#include <iostream>
#include <vector>

#define int long long

using namespace std;

struct edge{
    int u, t;
};

const int MAXN = 300004, INF = 1e16;
vector <edge> g[MAXN];
vector <int> ans(MAXN, INF);
vector <bool> visited(MAXN);

void dfs(int v){
    for (auto e : g[v]) {
      //  cout << v << " " << e.u << ans[v] << " " << e.t << endl;
        if (ans[e.u] > max(ans[v], e.t)) {
            ans[e.u] = max(ans[v], e.t);
            dfs(e.u);
        }
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    ans[0] = 0;
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
