#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;

void stop() {
    cout << "No\n";
    exit(0);
}
vector<pair<int, int>> ans;

int dfs(int v, int p, v2i& g, v2i& mat, vi& used) {
    used[v] = 1;
    vi in, out;
    for (int to : g[v])
        if (to != p) {
            int code = dfs(to, v, g, mat, used);
            if (code > 0)
                in.push_back(code);
            else if (code < 0)
                out.push_back(-code);
        }
    int selfIn = 0, selfOut = 0;
    if (p != -1) {
        selfIn = mat[p][v], selfOut = mat[v][p];
    }
    int n = min(in.size(), out.size());
    for (int i = 0; i < n; ++i)
        ans.emplace_back(in[i], out[i]);
    if (in.size() == out.size()) {
        if (selfIn && selfOut) {
            ans.emplace_back(selfIn, selfOut);
            return 0;
        }
        else if (selfIn)
            return -selfIn;
        else if (selfOut)
            return selfOut;
        return 0;
    }
    else if (in.size() == out.size() + 1) {  // IN more
        if (!selfOut)
            stop();
        ans.emplace_back(in[n], selfOut);
        return -selfIn;
    }
    else if (in.size() + 1 == out.size()) {  // OUT more
        if (!selfIn)
            stop();
        ans.emplace_back(selfIn, out[n]);
        return selfOut;
    }
    else
        stop();
    return 1e9;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    v2i g(n);
    v2i mat(n, vi(n));
    vector<pair<int, int>> edge;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        edge.emplace_back(v, u);
        mat[v - 1][u - 1] = i + 1;
    }
    for (int v = 0; v < n; ++v)
        for (int u = v + 1; u < n; ++u)
            if (mat[v][u] || mat[u][v]) {
                g[v].push_back(u);
                g[u].push_back(v);
            }
    vi used(n);
    for (int v = 0; v < n; ++v)
        if (!used[v]) {
            if (dfs(v, -1, g, mat, used))
                stop();
        }
    cout << "Yes\n";
    for (auto[e1, e2] : ans)
        cout << edge[e1].first << ' ' << edge[e1].second << ' '
                << edge[e1].first << ' ' << edge[e1].second << '\n';
}
