#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
//#pragma GCC target("avx,sse,sse4.1,sse4.2,mmx,abm,popcnt")

const int INF = 1000000007;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> graph(n);
	for (int i = 0; i < m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		--v;
		--u;
		graph[v].push_back({u, w});
		graph[u].push_back({v, w});
	}
	queue<int> q;
	vector<int> res(n, INF);
	q.push(0);
	res[0] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto [u, w] : graph[v]) {
			if (res[u] > max(res[v], w)) {
				res[u] = max(res[v], w);
				q.push(u);
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		assert(res[i] != INF);
		cout << res[i] << ' ';
	}
	cout << '\n';
}
