#include <bits/stdc++.h>


#define int long long
#define pb push_back
#define endl '\n'
typedef long double ld;
using namespace std;

void dfs (int v, vector<int> &used, vector<vector<pair<int, int>>> &E, vector<pair<int, int>> &minmax) {
    used[v] = 1;
    for (auto u : E[v]) {
        if (!used[u.first]) {
            minmax[u.first] = {min(minmax[v].first, u.second), max(minmax[v].second, u.second)};
            dfs(u.first, used, E, minmax);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> E(n);
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        E[u - 1].pb({v - 1, t});
        E[v - 1].pb({u - 1, t});
    }
    set<pair<int, int>> que;
    vector<int> d(n, 179179179179);
    d[0] = 0;
    que.insert({0, 0});
    while (!que.empty()) {
        int s = que.begin() -> second;
        que.erase({d[s], s});
        for (auto el : E[s]) {
            int neu = min(el.second, d[s]);
            int nev = el.first;
            if (neu < d[nev]) {
                que.erase({d[nev], nev});
                d[nev] = neu;
                que.insert({d[nev], nev});
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << d[i] + 1000000000 << " ";
    }
    cout << endl;
    return 0;
}
