#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N = 3e5 + 113;
vector<pair<int, int>> edges[N];
int n, m;
int ans[N];
void dfs1(int v, int a, int mins, int maxs)
{
    ans[v] = mins + maxs;
    for(auto i : edges[v])
    {
        if(i.first != a)
            dfs1(i.first, v, min(mins, i.second), max(maxs, i.second));
    }
}
void solve1()
{
    dfs1(1, -1, 1e9, -1e9);
    for(int i = 2; i <= n; i++)
        cout<<ans[i]<<" ";
}
void solve2()
{
    vector<int> d(n + 1);
    for(int i = 1; i <= n; i++)
        d[i] = 1e9;
    d[1] = 0;
    set<pair<int, int>> st;
    for(int i = 1; i <= n; i++)
        st.insert({d[i], i});
    while(st.size())
    {
        int v = (*st.begin()).second;
        st.erase(st.begin());
        for(auto i : edges[v])
        {
            if(d[i.first] > max(d[v], i.second))
                st.erase(st.find({d[i.first], i.first})), d[i.first] = max(d[v], i.second), st.insert({d[i.first], i.first});
        }
    }
    for(int i = 2; i <= n; i++)
        cout<<d[i]<<" ";
}
signed main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    for(int i = 0; i < m; i++)
    {
        int u, v, t;
        cin>>u>>v>>t;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }
    if(m == n - 1)
    {
        solve1();
        return 0;
    }
    bool g2 = 1;
    for(auto i : edges[1])
    {
        if(i.second != 0)
            g2 = 0;
    }
    if(g2)
    {
        solve2();
        return 0;
    }
}
