#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;

int col[maxN];
vector<pair<int, int>> g[maxN];
bool used[maxN];

vector<ar<int, 4>> answer;

int dfs(int v, int p, bool has1 = false, bool has2 = false) {
    vector<int> in, out;
    used[v] = true;
    for(auto &[u, t] : g[v]) {
        if (u == p) {
            if (t == 0) has1 = true;
            else has2 = true;
            continue;
        }
        if (used[u]) continue;
        int w = dfs(u, v);
        if (w == 0) continue;
        if (w == 1) in.push_back(u);
        else out.push_back(u);
    }
    while(!in.empty() && !out.empty()) {
        answer.push_back({in.back(), v, v, out.back()});
        in.pop_back();
        out.pop_back();
    }
    if (!in.empty() && has1) {
        answer.push_back({in.back(), v, v, p});
        in.pop_back();
        has1 = false;
    }
    if (!out.empty() && has2) {
        answer.push_back({p, v, v, out.back()});
        out.pop_back();
        has2 = false;
    }
    if (has1 && has2) {
        answer.push_back({p, v, v, p});
        has1 = false;
        has2 = false;
    }
    if (!in.empty() || !out.empty()) {
        cout << "No\n";
        exit(0);
    }
    if (has1) return 1;
    if (has2) return 2;
    return 0;
}


void solve() {
    int n, m; cin >> n >> m;
    range(_, m) {
        int u, v; cin >> u >> v;
        g[u].emplace_back(v, 0);
        g[v].emplace_back(u, 1);
    }
    for(int i = 1; i <= n; ++i) {
        if (used[i]) continue;
        if (dfs(i, -1) != 0) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    for(auto &[a, b, c, d] : answer) cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}