#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;


void solve() {
    int n, q; cin >> n >> q;
    vector<int> x(n), h(n);
    range(i, n) cin >> x[i] >> h[i];
    range(_, q) {
        int l, r; cin >> l >> r;
        l--;
        queue<int> qu;
        set<int> alive;

        auto check = [&] (int i) {
            if (i < l || i >= r) return false;
            auto it = alive.upper_bound(i);
            if (i != n - 1) {
                if (*it == n) {
                    if (x[i] + h[i] <= x[n - 1]) return true;
                } else if (x[*it] >= x[i] + h[i]) return true;
            }
            if (i != 0) {
                it--;
                it--;
                if (*it == -1) {
                    if (x[0] <= x[i] - h[i]) return true;
                } else if (x[*it] <= x[i] - h[i]) return true;
            }
            return false;
        };
        for(int i = l - 1; i <= r; ++i) {
            alive.insert(i);
        }
        set<int> us;
        for(int i = l; i < r; ++i) {
            if (check(i)) {
                qu.push(i);
                us.insert(i);
            }
        }
        int ans = 0;
        while(!qu.empty()) {
            int i = qu.front();
            alive.erase(i);
            qu.pop();
            ans++;
            int xx = *alive.lower_bound(i);
            int yy = *prev(alive.lower_bound(i));
            if (check(xx) && !us.count(xx)) {
                qu.push(xx);
                us.insert(xx);
            }
            if (check(yy) && !us.count(yy)) {
                qu.push(yy);
                us.insert(yy);
            }
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}