#include <iostream>
#include <map>
#include <cmath>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
    }
    int beg = a[0].first, end = a.back().first;
    while (q--) {
        int l, r;
        cin >> l >> r;
        int cnt = 0;
        if (a.size() == 1) {
            cout << 0 << "\n";
            continue;
        }
        vector<bool> exists(n, true);
        for (int i = 0; i <= r - l; ++i) {
            bool done = false;
            for (int j = l - 1; j <= r - 1; ++j) {
                if (!exists[j]) {
                    continue;
                }
                if (j == 0) {
                    int k = j;
                    while (k < n && !exists[k + 1]) {
                        ++k;
                    }
                    if (a[j].first + a[j].second <= a[k + 1].first && a[j].first + a[j].second <= end) {
                        cnt++;
                        exists[j] = false;
                        done = true;
                        break;
                    }
                } else if (j == a.back().first) {
                    int k = j;
                    while (k >= 0 && !exists[k - 1]) {
                        --k;
                    }
                    if (a[j].first - a[j].second >= a[k - 1].first && a[j].first - a[j].second >= beg) {
                        cnt++;
                        exists[j] = false;
                        done = true;
                        break;
                    }
                } else {
                    int k1 = j, k2 = j;
                    while (k1 < n && !exists[k1 + 1]) {
                        ++k1;
                    }
                    if (a[j].first + a[j].second <= a[k1 + 1].first && a[j].first + a[j].second <= end) {
                        cnt++;
                        exists[j] = false;
                        done = true;
                        break;
                    } else {
                        while (k2 >= 0 && !exists[k2 - 1]) {
                            --k2;
                        }
                        if (a[j].first - a[j].second >= a[k2 - 1].first a[j].first - a[j].second >= beg) {
                            cnt++;
                            exists[j] = false;
                            done = true;
                            break;
                        }
                    }

                }
            }
            if (!done) {
                break;
            }
        }
        cout << cnt << "\n";
    }
    return 0;
}
