#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 10;
const ll inf = 1e18;

ll dp[N][30];
pair <ll, ll> pref[N][30], suf[N][30];
ll p[N][30];
ll C[N][30];
ll znach[] = { 1, 5,10, 50, 100, 500, 1000, 5000, 10000, 5 * 1e4, 1e5, 5 * 1e5, 1e6, 5 * 1e6, 1e7, 5 * 1e7, 1e8, 5 * 1e8, 1e9, 5 * 1e9, 1e10, 5 * 1e10, 1e11, 5 * 1e11, 1e12, 5 * 1e12 };

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t; cin >> t;
	while (t--) {
		string s; cin >> s;
		ll n = s.length();
		for (ll i = 0; i <= n + 5; i++) {
			for (ll j = 0; j < 30; j++) {
				dp[i][j] = 0;
				p[i][j] = 0;
				pref[i][j] = { 0, 0 }; suf[i][j] = { 0, 0 };
				C[i][j] = 0;
			}
		}
		for (ll i = n - 1; i >= 0; i--) {
			if (s[i] != '?') {
				ll k = s[i] - 'A';
				for (ll j = 0; j < 26; j++) {
					if (j < k) {
						dp[i][j] = -inf;
						continue;
					}
					if (j == k) {
						dp[i][k] = pref[i + 1][k].first + znach[k];
						p[i][k] = pref[i + 1][k].second;
					}
					else {
						dp[i][j] = dp[i + 1][j] - znach[k];
						p[i][j] = j;
					}
				}
			}
			else {
				for (ll j = 0; j < 26; j++) {
					dp[i][j] = pref[i + 1][j].first + znach[j];
					p[i][j] = pref[i + 1][j].second; C[i][j] = j;
					if (j > 0 && dp[i][j] < dp[i + 1][j] - 1) {
						dp[i][j] = dp[i + 1][j] - 1;
						C[i][j] = 0; p[i][j] = j;
					}
				}
			}
			pref[i][0] = { dp[i][0], 0 };
			for (ll j = 1; j < 26; j++) {
				if (dp[i][j] > pref[i][j - 1].first) {
					pref[i][j] = { dp[i][j], j };
				}
				else {
					pref[i][j] = pref[i][j - 1];
				}
			}
			for (ll j = 25; j >= 0; j--) {
				if (dp[i][j] > suf[i][j + 1].first) {
					suf[i][j] = { dp[i][j], j };
				}
				else {
					suf[i][j] = suf[i][j + 1];
				}
			}
		}
		ll ans = -2 * inf;
		ll nach;
		for (ll i = 0; i < 26; i++) {
			if (dp[0][i] > ans) {
				ans = dp[0][i];
				nach = i;
			}
		}
		string res;
		cout << ans << '\n';
		for (ll i = 0; i < n; i++) {
			if (s[i] != '?') {
				res.push_back(s[i]);
			}
			else {
				res.push_back(C[i][nach] + 'A');
			}
			nach = p[i][nach];
		}
		cout << res << '\n';
	}
}