#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

const int N = 3e5 + 5;

vector<pair<int, int>> a[N];
vi d(N, 1e18);
void solve() {
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y, t; cin >> x >> y >> t;
		--x, --y;
		a[x].push_back({y, t});
		a[y].push_back({x, t});
	}
	
	d[0] = 0;
	vector<bool> vis(N, 0);
	priority_queue<pair<int, int>> q;
	q.push({ 0, 0 });
	while (q.size()) {
		auto v = q.top().second;
		q.pop();
		if (vis[v]) continue;
		vis[v] = 1;
		for (auto u : a[v]) {
			if (d[u.first] > max(d[v], u.second)) {
				d[u.first] = max(d[v], u.second);
				q.push({ -d[u.first], u.first });
			}
		}
	}
	for (int i = 1; i < n; ++i) cout << d[i] << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}