#include <iostream>
#include "vector"
#include "set"

using namespace std;

int INF = 1000000001;

signed main() {
    int n, m; cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b, w; cin >> a >> b >> w;
        a--; b--;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
    vector<int> minws(n, INF);
    minws[0] = 0;
    set<pair<int, int>> st;
    st.insert({0, 0});
    while (not st.empty()) {
        pair<int, int> now = *st.begin();
        int minw = now.first, v = now.second;
        for (auto el : g[v]) {
            int u = el.first, w = el.second;
            //cout << v << " " << minws[v] << " " << u << " " << minws[u] << " " << w << endl;
            if (minws[u] > max(minw, w)) {
                st.erase({minws[u], u});
                minws[u] = max(minw, w);
                st.insert({minws[u], u});
            }
        }
        st.erase(now);
    }
    for (int i = 1; i < n; ++i) {
        cout << minws[i] << endl;
    }
}