#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    string input;
    cin >> input;
    int n = input.size();
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        if (input[i] == '?') {
            a[i] = 26;
        } else {
            a[i] = input[i] - 'A';
        }
    }
    vector<double> dsums = {1, 5, 10, 50, 100, 500, 1000, 5e3, 1e4, 5e4, 1e5, 5e5, 1e6, 5e6, 1e7, 5e7, 1e8, 5e8, 1e9,
                            5e9, 1e10, 5e10, 1e11, 5e11, 1e12, 5e12};
    vector<int> sums(dsums.size());
    for (int i = 0; i < sums.size(); ++i) {
        sums[i] = (int) dsums[i];
    }
    vector<vector<int>> b(26, vector<int>(n + 1));
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < 26; ++j) {
            if (a[i - 1] < j) {
                b[j][i] = b[j][i - 1] + sums[a[i - 1]];
            } else {
                b[j][i] = b[j][i - 1];
            }
        }
    }
    int cur = 25;
    for (int i = 0; i < n; ++i) {
        int best_cur = cur;
        if (a[i] == 26) {
            for (int j = cur; j >= 0; --j) {
                if (-b[j][i] + sums[j] > -b[best_cur][i] + sums[best_cur]) {
                    best_cur = j;
                }
            }
            cur = best_cur;
            a[i] = cur;
        }
    }
    int cur_mx = a.back();
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] < cur_mx) {
            ans -= sums[a[i]];
        } else {
            ans += sums[a[i]];
            cur_mx = a[i];
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << (char) (a[i] + 'A');
    }
    cout << '\n';
}

int32_t main() {

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
