#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > g;

map<pair<int, int>, bool> e;
vector<int> dp;
vector<bool> used;
vector<pair<pair<int, int>, pair<int, int> > > ans;

void dfs(int v, int p = -1){
    used[v] = 1;
    vector<int> cnt2, cnt3;
    for(int u : g[v]){
        if(u == p)
            continue;
        dfs(u, v);
        if(dp[u] == 2) cnt2.push_back(u);
        if(dp[u] == 3) cnt3.push_back(u);
        if(dp[u] == -1){
            dp[v] = -1;
            return;
        }
    }
    bool a = e[{v, p}], b = e[{p, v}];
    int c2 = cnt2.size(), c3 = cnt3.size();
    if(cnt2.size() != cnt3.size() && (!a && !b) &&
       !(c2 + a == c3 && b == 1 || c2 == c3 + b && a == 1) ||
       (c2 + a > c3 + b + 1 || c2 + a + 1 < c3 + b)){
        dp[v] = -1;
        return;
    }
    if(c2 == c3 + b && a == 1){
        dp[v] = 3;
        for(int i = 0; i < c3; ++i)
            ans.push_back({{cnt3[i], v}, {v, cnt2[i]}});
        if(c3 < c2)
            ans.push_back({{p, v}, {v, cnt2.back()}});
        return;
    }
    if(c2 + a == c3 && b == 1){
        dp[v] = 2;
        for(int i = 0; i < c2; ++i)
            ans.push_back({{cnt3[i], v}, {v, cnt2[i]}});
        if(c2 < c3)
            ans.push_back({{cnt3.back(), v}, {v, p}});
        return;
    }
    if(c2 == c3){
        dp[v] = 1;
        for(int i = 0; i < c3; ++i)
            ans.push_back({{cnt3[i], v}, {v, cnt2[i]}});
        if(a && b)
            ans.push_back({{p, v}, {v, p}});
    }
}

int main()
{
    int n, m; cin >> n >> m;
    g.resize(n); dp.resize(n, 0);
    used.resize(n, 0);
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b; --a, --b;
        if(!e[{b, a}]){
            g[a].push_back(b);
            g[b].push_back(a);
        }
        e[{a, b}] = 1;
    }
    for(int i = 0; i < n; ++i){
        if(!used[i])
            dfs(i);
        if(dp[i] == -1){
            cout << "No";
            return 0;
        }
    }
    cout << "Yes" << '\n';
    map<pair<int, int>, bool> used;
    for(int i = 0; i < ans.size(); ++i){
        cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' ';
        cout << ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << '\n';
    }
    return 0;
}
