#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
using namespace std;
#define int long long
const int MAX = 400000;
const int INF = 1e18;
int t;
string s;
vector<pair<int, int>> tree;
int ri[MAX], le[MAX];
bool cut[MAX];
int n, q, x, y;
signed main() {
	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		tree.push_back({ x, y });
	}
	for (int i = 0; i < n; i++) {
		int l = 0, r = n; 
		while (r - l > 1) {
			int res = (r + l) / 2;
			if (tree[i].first + tree[i].second <= tree[res].first) {
				r = res;
			}
			else {
				l = res;
			}
		}
		ri[i] = r - i - 1;
		if (r == n) {
			ri[i] = INF;
		}
		l = -1;
		r = n;
		while (r - l > 1) {
			int res = (r + l) / 2;
			if (tree[i].first - tree[i].second >= tree[res].first) {
				l = res;
			}
			else {
				r = res;
			}
		}
		le[i] = i - l - 1;
		if (l == -1) {
			le[i] = INF;
		}
	}
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		int ans = 0;
		for (int j = 0; j <= r - l + 1; j++) {
			if (!cut[j]) {
				bool flag = true;
				if (j + ri[j] <= r) {
					for (int i2 = j + 1; i2 <= j + ri[j]; i2++) {
						if (!cut[i2]) {
							flag = false;
							break;
						}
					}
					if(flag == true){
						ans++;
						cut[j] = true;
					}
				}
				if (!cut[j]) {
					flag = true;
					if (j - le[j] >= l) {
						for (int i2 = j - 1; i2 >= j - le[j]; i2--) {
							if (!cut[i2]) {
								flag = false;
								break;
							}
						}
						if (flag == true) {
							ans++;
							cut[j] = true;
						}
					}
				}
			}
		}
		for (int j = l; j <= r; j++) {
			cut[j] = 0;
		}
		cout << ans << endl;
	}
	return 0;
}