#include <bits/stdc++.h>

using namespace std;

const int MAXN = 21;
vector<pair<int, int>> edges;
vector<int> graph[MAXN];
int ans[MAXN];

void solve(int v, int p, int mx, int mn) {
  for (auto e: graph[v]) {
    auto[u, w] = edges[e];
    if ((e ^ 1) == p)
      continue;
    int nmx = max(mx, w);
    int nmn = min(mn, w);
    if (ans[u] > nmx + nmn) {
      ans[u] = nmx + nmn;
      solve(u, e, nmx, nmn);
    }
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int v, u, t;
    cin >> v >> u >> t;
    v--;
    u--;
    edges.emplace_back(u, t);
    graph[v].emplace_back(edges.size() - 1);
    edges.emplace_back(v, t);
    graph[u].emplace_back(edges.size() - 1);
  }
  for (int i = 0; i < n; i++) {
    ans[i] = INT_MAX;
  }
  solve(0, -1, 0, INT_MAX);
  for (int i = 1; i < n; i++)
    cout << ans[i] << '\n';
  return 0;
}