#include <bits/stdc++.h>

using namespace std;

//#define  int long long
#define  x first
#define  y second

const int MAXN = 300000;
const int INF = 1e9 + 7;

vector<pair<int, int>> g[MAXN];

int ans[MAXN];

void dfs(int v, int mn = INF, int mx = -INF, int p = -1) {
    ans[v] = mx + mn;
    for (auto x : g[v])
        if (x.x != p)
            dfs(x.x, min(mn, x.y), max(mx, x.y), v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> dist(n, INF);
    dist[0] = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dfs(0);
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
}

signed main() {
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}