#include <iostream>
#include <map>
#include <vector>
using namespace std;

map<char, long long int> mp;
int n = 0;

pair<string, long long int> rec(string ss, int ind){
    if(ind > n){
        string s = ss;
        int m = s.size();
        char acc[m];
        acc[m-1] = s[m-1];
        for(int i = m-2;i >= 0;--i)
            acc[i] = max(acc[i+1], s[i]);
        long long int num = 0;
        for(int i = 0;i < m;++i)
            if(s[i] >= acc[i])
                num += mp[s[i]];
            else
                num -= mp[s[i]];
        return make_pair(s, num);
    }
    ++ind;
    string s = ss, mx;
    long long int Mx = 0;
    for(int i = 0;i < s.size();++i){
        if(s[i] == '?'){
            for(char c = 'A';c <= 'Z';c++){
                s[i] = c;
                pair<string, long long int> p = rec(s, ind);
                string a = p.first;
                long long int num = p.second;
                if(num > Mx)
                {
                    Mx = num;
                    mx = a;
                }
            }
            return make_pair(mx, Mx);
        }
    }
}

int main()
{
    mp['A'] = 1;
mp['B'] = 5;
mp['C'] = 10;
mp['D'] = 50;
mp['E'] = 100;
mp['F'] = 500;
mp['G'] = 1000;
mp['H'] = 5000;
mp['I'] = 10000;
mp['J'] = 50000;
mp['K'] = 100000;
mp['L'] = 500000;
mp['M'] = 1000000;
mp['N'] = 5000000;
mp['O'] = 10000000;
mp['P'] = 50000000;
mp['Q'] = 100000000;
mp['R'] = 500000000;
mp['S'] = 1000000000;
mp['T'] = 5000000000;
mp['U'] = 10000000000;
mp['V'] = 50000000000;
mp['W'] = 100000000000;
mp['X'] = 500000000000;
mp['Y'] = 1000000000000;
mp['Z'] = 5000000000000;
    int t;
    cin >> t;
    vector<pair<long long int, string> > ans;
    for(int i = 0;i < t;++i)
    {
        n = 0;
        string s;
        cin >> s;
        for(int i = 0;i < s.size();++i)
            if(s[i] == '?')
                ++n;
        pair<string, long long int> p = rec(s, 1);
        cout << p.second << '\n'<< p.first << '\n';
    }
    return 0;
}
