#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    int n, q;
    cin >> n >> q;
    vector <pair <int, int> > a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    vector <vector <int> > dp(n, vector <int>(n, n));
    for (int l = 0; l < n; l++)
        for (int r = 0; r < l; r++)
            dp[l][r] = 0;
    for (int len = 1; len <= n; len++) {
        for (int l = 0; l + len <= n; l++) {
            int r = l + len - 1;
            for (int m = l; m <= r; m++) {
                int s = 1;
                if (m)
                    s += dp[l][m - 1];
                if (m < n - 1)
                    s += dp[m + 1][r];
                if (s == 1) {
                    bool can = false;
                    if (a[0].first <= a[m].first - a[m].second)
                        if (!l || a[l - 1].first <= a[m].first - a[m].second)
                            can = true;
                    if (a[n - 1].first >= a[m].first + a[m].second)
                        if (r == n - 1 || a[r + 1].first >= a[m].first + a[m].second)
                            can = true;
                    if (can) s--;
                }
                dp[l][r] = min(dp[l][r], s);
            }
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << r - l - dp[l - 1][r - 1] + 1 << "\n";
    }
    return 0;
}
