#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using pii = pair<int, int>;

const li INF = 3e18 + 13;
const int N = 3e5 + 13;
const int A = 26;

/*

*/

vector<int> g[N], r[N], all[N];

vector<vector<int>> ans;

int used[N];
set<pii> st;

void no() {
    cout << "No" << endl;
    exit(0);
}

//0 - clear
// 1 - left edge in v
// 2 - left edge in par
int dfs(int v, int par) {
    used[v] = 1;
    vector<int> a(3, 0);
    vector<vector<pii>> rem(3);
    for(auto u : all[v]) {
        if(used[u] == 0) {
            int x = dfs(u, v);
            a[x]++;
            if(x == 1)
                rem[1].emplace_back(v, u);
            else if(x == 2)
                rem[2].emplace_back(u, v);
        }
    }

    for(int i = 0; i < min(a[1], a[2]); i++) {
        ans.push_back({rem[2][i].f, rem[2][i].s, rem[1][i].f, rem[1][i].s});
    }

    if(a[1] <= a[2]) {
        a[2] -= a[1];
        a[1] = 0;
        if(a[2] > 1) {
            no();
        }

        if(a[2] == 0) {
            if(st.count({v, par}) && st.count({par, v})) {
                ans.push_back({v, par, par, v});
                return 0;
            } else if(st.count({v, par}))
                return 2;
            else
                return 1;
        }

        if(a[2] == 1) {
            if(st.count({v, par}) == 0) {
                no();
            }

            ans.push_back({rem[2].back().f, rem[2].back().s, v, par});

            if(st.count({par, v}))
                return 1;
            else
                return 0;
        }
    } else {
        a[1] -= a[2];
        a[2] = 0;

        if(a[1] > 1) {
            no();
        }

        if(a[1] == 1) {
            if(st.count({par, v}) == 0) {
                no();
            }

            ans.push_back({par, v, rem[1].back().f, rem[1].back().s});

            if(st.count({v, par}))
                return 2;
            else
                return 0;
        }
    }

    used[v] = 2;
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;

        v--;
        u--;

        st.insert({v, u});
        g[v].push_back(u);
        r[u].push_back(v);
        all[v].push_back(u);
        all[u].push_back(v);
    }

    for(int i = 0; i < n; i++) {
        if(used[i] == 0) {
            dfs(i, -1);
        }
    }

    cout << "Yes" << '\n';
    for(auto x : ans) {
        for(auto y : x)
            cout << y + 1 << ' ';
        cout << '\n';
    }
}
