#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 3e5, maxm = 1e6;

set<int> g[maxn];
set<int> gi[maxn], go[maxn];
bool used[maxn];
vector<array<int, 4>> ans;
bool ha = true;

void dfs(int v, int p) {
	used[v] = true;
	vector<int> chi, cho;
	int pi = -1, po = -1;
	for (int u: g[v]) {
		if (u == p) {
			if (gi[v].count(u)) pi = u;
			if (go[v].count(u)) po = u;
		} else {
			dfs(u, v);
			if (!ha) return;
			if (gi[v].count(u)) chi.push_back(u);
			if (go[v].count(u)) cho.push_back(u);
		}
	}
//	cout << "V: " << v << ' ' << pi << ' ' << po << ' ' << p << endl;
//	for (int x: chi) cout << x << ' ';
//	cout << nl;
	//for (int x: cho) cout << x << ' ';
	//cout << nl;
	//cout << nl;
	
	while (gsize(chi) && gsize(cho)) {
		int u = chi.back(), u2 = cho.back();
		ans.push_back({u, v, v, u2});
		chi.pop_back();
		cho.pop_back();
	}
	
	if (gsize(chi) > 0) {
		if (po < 0) {
			ha = false;
			return;
		} else {
			int u = chi.back();
			ans.push_back({u, v, v, po});
			//go[v].erase(po);
			gi[po].erase(v);
			//cout << "ER1: " << pi << nl;
			chi.pop_back();
		}
	}
	if (gsize(cho) > 0) {
		if (pi < 0) {
			ha = false;
			return;
		} else {
			int u = cho.back();
			ans.push_back({v, u, pi, v});
			//cout << "ER: " << pi << nl;
			//gi[v].erase(pi);
			go[pi].erase(v);
			cho.pop_back();
		}
	}
	
	if (max(gsize(chi), gsize(cho)) > 0) {
		ha = false;
		return;
	}
}

int main() {
	FAST;
	
	int n, m;
	cin >> n >> m;

	while (m--) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].insert(v);
		g[v].insert(u);
		gi[v].insert(u);
		go[u].insert(v);
	}
	
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i, -1);
			if (!ha) {
				cout << "NO" << nl;
				return 0;
			} 
		}
	}
	
	cout << "YES" << nl;
	for (auto p: ans) {
		for (int j = 0; j < 4; j++) cout << p[j] + 1 << ' ';
		cout << nl;
	}
}
