from sys import stdin, stdout, exit
from copy import deepcopy, copy

input=stdin.readline

n, m = map(int, input().split())
G = [[] for _ in range(n)]

timing = {}
for _ in range(m):
    u, v, t = map(int, input().split())
    u, v = u - 1, v - 1
    G[v].append(u)
    G[u].append(v)
    timing[(u, v)] = t
    timing[(v, u)] = t

def time(x, y):
    return timing[(x, y)]

ts = []
parents = []
used = [0] * n
j = 0
i = 0
for i in range(n):
    if len(ts) <= i:
        while used[j]:
            j += 1
        ts.append(j)
        used[j] = 1
        parents.append(None)
    kids = copy(G[ts[i]])
    if parents[i] is not None:
        kids.remove(ts[parents[i]])
    ts.extend(kids)
    parents.extend([i] * len(kids))
    for el in kids:
        used[el] = 1

res = []

res[0] = 10**9, 0
for i in range(1, n):
    mn, mx = res[parents[ts[i]]]
    t = time(ts[i], parents[ts[i]])
    res[ts[i]] = min(mn, t), max(mx, t)
for rs in res[1:]:
    print(sum(rs))
