#include <bits/stdc++.h>
 
using namespace std;

#define int ll
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}
 
const ll inf = 2e18;
const int intf = 2e9;


#define fi first
#define se second

bool bit(int mask, int j) {
    return ((mask >> j) & 1);
}

struct edge {
    int u, v, t;
};

int n, m;
vector < vector <pii> > g;
vector <edge> e;

void solve() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, t; cin >> u >> v >> t; u--, v--;
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
        e.push_back({u, v, t});
    }

    vector <ll> dist(n, inf);
    priority_queue <pll> q;
    dist[0] = ll(2e9);
    q.push({-dist[0], 0});
    while (!q.empty()) {
        int v = q.top().second;
        if (dist[v] != -q.top().first) {
            q.pop();
            continue;
        }
        q.pop();
        for (auto too : g[v]) {
            ll t = e[too.second].t;
            int to = too.first;
            if (dist[to] > min(dist[v], t)) {
                dist[to] = min(dist[v], t);
                q.push({-dist[to], to});
            }
        }
    }

    for (int i = 1; i < n; i++) {
        cout << dist[i] + ll(1e9) << '\n';
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);
 
    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }
 
    return 0;
}