#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

const long long smol = -((long long) 1 << 63);

long long d = smol;
string answer;

void calculate(string s) {
    char max_ = 'A' - 1;
    long long result = 0;
    for (int i = s.length()-1; i >= 0; i--) {
        int index = s[i] - 'A';
        long long value = pow(10,index / 2);
        if (index % 2 == 1) {
            value *= 5;
        }
        if (s[i] < max_) {
            result -= value;
        } else {
            result += value;
            max_ = s[i];
        }
    }
    if (result > d) {
        d = result;
        answer = s;
    }
}

void recursive(string s, vector<int> questions) {
    if (questions.size() == 0) {
        calculate(s);
    } else {
        int i = questions[0];
        questions.erase(questions.begin());
        for (char j = 'A'; j <= 'Z'; j++) {
            s[i] = j;
            recursive(s,questions);
        }
    }
}

int main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; q++) {
        string s;
        cin >> s;
        d = smol;
        answer = "";
        vector<int> questions;
        for (int i = 0; i < s.length(); i++) {
            if (s[i] == '?') {
                questions.push_back(i);
            }
        }
        recursive(s,questions);
        cout << d << endl << answer << endl;
    }
}
