// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <queue>
#include <set>
#include <unordered_set>
#include <string>

using namespace std;

typedef long long ll;

vector<unordered_set<int>> graph, graph1;

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m;
	cin >> n >> m;
	graph.resize(n);
	graph1.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		graph[a].insert(b);
		graph1[b].insert(a);
	}
	vector<vector<int>> ans;
	set<vector<int>> sss;
	for (int i = 0; i < n; i++) {
		sss.insert({ (int)graph[i].size(), (int)graph1[i].size(), i });
	}
	while (!sss.empty()) {
		auto aa = *(sss.begin());
		sss.erase(sss.begin());
		if (aa[0] == 1 && aa[1] == 1) {
			int v = aa[2];
			int to = *(graph[v].begin());
			if (graph[to].find(v) != graph[to].end()) {
				sss.erase({ (int)graph[to].size(), (int)graph1[to].size(), to });
				ans.push_back({ v, to, to, v });
				graph[v].erase(to);
				graph[to].erase(v);
				graph1[v].erase(to);
				graph1[to].erase(v);
				sss.insert({ (int)graph[to].size(), (int)graph1[to].size(), to });
			}
		}
	}
	/*while (true) {
		bool flag = true;
		for (int v = 0; v < n; v++) {
			if (graph[v].size() == 1 && graph1[v].size() == 1) {
				int to = *(graph[v].begin());
				if (graph[to].find(v) != graph[to].end()) {
					ans.push_back({ v, to, to, v });
					graph[v].erase(to);
					graph[to].erase(v);
					graph1[v].erase(to);
					graph1[to].erase(v);
					flag = false;
						
				}
			}
		}
		if (flag) break;
	}*/
	while (true) {
		int st = -1;
		for (int i = 0; i < n; i++) {
			if (graph[i].size() == 1 && graph1[i].size() == 0) {
				st = i;
			}
			if (graph[i].size() == 0 && graph1[i].size() == 1) {
				st = i;
			}
		}
		if (st != -1) {
			while (true) {
				if (graph[st].size() == 1) {
					int to = *(graph[st].begin());
					if (graph[to].empty()) {
						return cout << "No", 0;
					}
					int aaa = *(graph[to].begin());
					ans.push_back({ st, to, to, aaa });
					graph[st].erase(to);
					graph1[to].erase(st);
					graph[to].erase(aaa);
					graph1[aaa].erase(to);
					st = to;
				}
				else if (graph1[st].size() == 1) {
					int to = *(graph1[st].begin());
					if (graph1[to].empty()) {
						return cout << "No", 0;
					}
					int aaa = *(graph1[to].begin());
					ans.push_back({ aaa, to, to, st });
					graph[aaa].erase(to);
					graph1[to].erase(aaa);
					graph[to].erase(st);
					graph1[st].erase(to);
					st = to;
				}
				else {
					break;
				}
			}
		}
		else
			break;
	}
	if (ans.size() != m / 2) {
		return cout << "No", 0;
	}

	cout << "Yes\n";
	for (auto el : ans) {
		cout << el[0] + 1 << ' ' << el[1] + 1 << ' ' << el[2] + 1 << ' ' << el[3] + 1 << '\n';
	}
}
