//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using query = pair<int, int>;

#define range(collection) collection.begin(), collection.end()
using segment = pair<int, int>;
#define l first
#define r second

struct tree01 {
    int sz;
    vector<int> sum;

    explicit tree01(int n) : sz(2 << __lg(n)), sum(2 * sz, 0) {}

    void set(int i, int x) {
        if (sum[i + sz] == x) return;
        sum[i + sz] = x;
        for (i = (i + sz) / 2; i > 0; i /= 2) sum[i] = sum[2 * i] + sum[2 * i + 1];
    }

    int leftmost(int i) {
        for (i = i + sz + 1;; i /= 2) {
            if (sum[i]) {
                while (i < sz) {
                    if (sum[2 * i]) i = 2 * i; else i = 2 * i + 1;
                }
                return i - sz;
            }
            if (i & 1) i++;
            if ((i & (i - 1)) == 0) return sz;
        }
    }

    int rightmost(int i) {
        for (i = i + sz;; i /= 2) {
            if ((i & 1) && sum[--i]) {
                while (i < sz) {
                    if (sum[2 * i + 1]) i = 2 * i + 1; else i = 2 * i;
                }
                return i - sz;
            }
            if ((i & (i - 1)) == 0) return -1;
        }
    }

    bool operator[](int i) { return sum[i + sz]; }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> x(n + 2), h(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    x[n + 1] = x[n];
    for (int j = 0; j < q; ++j) {
        int l, r;
        cin >> l >> r;
        ++r;
        vector<int> left(n + 2), right(n + 2);
        for (int i = 1; i <= n; ++i) left[i] = i - 1;
        for (int i = 1; i <= n; ++i) right[i] = i + 1;
        vector<bool> alive(n + 2,true);
        vector<int> queue;
        int cnt = 0;
        auto erase = [&](int i) {
            if (!alive[i]) return;
            alive[i] = false;
            int lf = left[i];
            int rg = right[i];
            right[lf] = rg;
            left[rg] = lf;
            if (l <= lf && x[lf] + h[lf] <= x[rg]) queue.emplace_back(lf);
            if (rg < r && x[rg] - h[rg] >= x[lf]) queue.emplace_back(rg);
            cnt++;
        };
        for (int i = l; i < r; ++i) {
            if (x[i] - h[i] >= x[i - 1] || x[i] + h[i] <= x[i + 1]) queue.push_back(i);
        }
        while (!queue.empty()) {
            int i = queue.back();
            queue.pop_back();
            erase(i);
        }
        cout << cnt << '\n';
    }
}

