#include<bits/stdc++.h>
using namespace std;
#define X first
#define Y second
#define sz(a) (int)a.size()
const int N = 3e5 + 100;
vector <pair <int, int> > g[N];
vector <pair <int, int> > g1[N];
vector <int> uniq;
int dist1[N], dist2[N];
void dfs(int v, int p = -1)
{
    for(auto to : g[v])
    {
        if(to.X == p)
        {
            continue;
        }
        dist1[to.X] = min(dist1[v], to.Y);
        dist2[to.X] = max(dist2[v], to.Y);
        dfs(to.X, v);
    }
}
int tin[N], tup[N];
int colored[N], used[N];
int timer = 0;
map <pair <int, int>, int> mp1;
void dfs1(int v, int p = -1)
{
    tin[v] = tup[v] = timer++;
    used[v] = 1;
    for(auto to : g1[v])
    {
        if(to.Y == p)
        {
            continue;
        }
        if(used[to.X])
        {
            tup[v] = min(tup[v], tin[to.X]);
        }
        else
        {
            dfs1(to.X, to.Y);
            tup[v] = min(tup[v], tup[to.X]);
            if(tup[to.X] > tin[v])
            {
                mp1[{v, to.X}] = 1;
                mp1[{to.X, v}] = 1;
            }
        }
    }
}
int minval[N];
vector <pair <int, int> > g2[N];
void dfs2(int v, int c)
{
    colored[v] = c;
    for(auto to : g[v])
    {
        if(colored[to.X] || mp1[{v, to.X}])
        {
            continue;
        }
        dfs2(to.X, c);
    }
}
int weight[N];
void minim(int &a, int b)
{
    a = min(a, b);
}
signed main()
{
 //   ios_base::sync_with_stdio(0);
   //cin.tie(0);
    //cout.tie(0);
    int n, m;
    cin >> n >> m;
    int flol = 1;
    for(int i = 0; i < m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--;
        b--;
        if(abs(a - b) != 1)
        {
            flol = 0;
        }
        weight[i] = t;
        uniq.push_back(t);
        g1[a].push_back({b, i});
        g1[b].push_back({a, i});
        g[a].push_back({b, t});
        g[b].push_back({a, t});
    }
    sort(uniq.begin(), uniq.end());
    uniq.resize(unique(uniq.begin(), uniq.end()) - uniq.begin());
    if(flol)
    {
        vector <vector <int> > dp(n, vector <int> (m, 1e9));
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < sz(g[i]); j++)
            {
                g[i][j].Y = lower_bound(uniq.begin(), uniq.end(), g[i][j].Y) - uniq.begin();
            }
        }
        for(int j = 0; j < sz(g[0]); j++)
        {
            dp[1][g[0][j].Y] = g[0][j].Y;
        }
        for(int i = 1; i < n; i++)
        {
            for(int t =0; t < m; t++)
            {
                for(int j = 0; j < sz(g[i]); j++)
                {
                    if(g[i][j].X != i + 1)
                    {
                        continue;
                    }
                    minim(dp[i + 1][min(t, g[i][j].Y)], max(dp[i][t], g[i][j].Y));
                }
            }
        }
        for(int i = 1;i < n; i++)
        {
            int ans = 2e9;
            for(int j = 0; j < m; j++)
            {
                if(dp[i][j] == 1e9)
                {
                    continue;
                }
                ans = min(ans, uniq[j] + uniq[dp[i][j]]);
            }
            cout << ans << "\n";
        }
        return 0;
    }
    if(m <= 20)
    {
        vector <vector <bool> > dp(n, vector <bool> ((1 << m), 0));
        dp[0][0] = 1;
        int f1;
        vector <int> valmin((1 << m), 1e9), valmax((1 << m), 0);
        for(int msk1 = 0; msk1 < (1 << m); msk1++)
        {
            for(int j = 0; j < m; j++)
            {
                if((1 << j) & msk1)
                {
                    valmin[msk1] = min(valmin[msk1], weight[j]);
                    valmax[msk1] = max(valmax[msk1], weight[j]);
                }
            }
        }
        for(int msk1 = 0; msk1 < (1 << m); msk1++)
        {
            for(int i = 0; i < n; i++)
            {
                if(!dp[i][msk1])
                {
                    continue;
                }
                for(auto to : g1[i])
                {
                    f1 = (1 << to.Y);
                    if(f1 & msk1)
                    {
                        continue;
                    }
                    dp[to.X][f1 | msk1] = 1;
                }
            }
        }
        for(int i = 1; i < n; i++)
        {
            int ans = 2e9;
            int mx1 = 0, mx2 = 1e9;
            for(int j = 0; j < (1 << m); j++)
            {
                if(dp[i][j])
                {
                    ans = min(ans, valmin[j] + valmax[j]);
                }
            }
            cout << ans << "\n";
        }
        return 0;
    }
    bool fl1 = 1, fl2 = 1;
    if(m == n - 1)
    {
        dist1[0] = 1e9;
        dist2[0] = -1e9;
        dfs(0);
        for(int i = 1; i < n; i++)
        {
            cout << dist1[i] + dist2[i] << "\n";
        }
        return 0;
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < sz(g[i]); j++)
        {
            g[i][j].Y = lower_bound(uniq.begin(), uniq.end(), g[i][j].Y) - uniq.begin();
            if(i == 0)
            {
                if(g[i][j].Y != 0)
                {
                    fl1 = 0;
                }
                if(g[i][j].Y != sz(uniq) -1)
                {
                    fl2 = 0;
                }
            }
        }
    }
    if(fl1)
    {
        vector <int> dist(n, 1e9);
        dist[0] = 0;
        priority_queue <pair <int, int> > q;
        q.push({0, 0});
        while(sz(q) != 0)
        {
            int v = q.top().Y;
            int d1 = q.top().X;
            q.pop();
            if(d1 != -dist[v])
            {
                continue;
            }
            for(auto to : g[v])
            {
                if(dist[to.X] > max(dist[v], to.Y))
                {
                    dist[to.X] = max(dist[v], to.Y);
                    q.push({-dist[to.X], to.X});
                }
            }
        }
        for(int i = 1; i < n; i++)
        {
            cout << uniq[dist[i]] << "\n";
        }
        return 0;
    }
    for(int i = 0; i < n; i++)
    {
        if(!used[i])
        {
            dfs1(i);
        }
    }
   // cout << "A\n";
    int c = 0;
    for(int i = 0; i < n;i++)
    {
        if(!colored[i])
        {
            c++;
            minval[c] = 1e9;
            dfs2(i, c);
        }
    }
    for(int i = 0; i < n; i++){
        for(auto to : g[i])
        {
            if(colored[i] != colored[to.X])
            {
                g2[colored[i]].push_back({colored[to.X], to.Y});
            }
            else
            {
                minval[colored[i]] = min(minval[colored[i]], to.Y);
            }
        }
    }
    queue <int> q;
    q.push(colored[0]);
    vector <bool> used1(n + 1, 0);
    vector <int> dist1(n, 1e9);
    dist1[colored[0]] = minval[colored[0]];
    used1[colored[0]] = 1;
    while(sz(q) != 0)
    {
        int v = q.front();
        q.pop();
        for(auto to : g2[v])
        {
            if(used1[to.X])
            {
                continue;
            }
            used1[to.X] = 1;
            dist1[to.X] = min(minval[to.X], min(to.Y, dist1[v]));
            q.push(to.X);
        }
    }
    for(int i = 1; i < n; i++)
    {
       // cout << minval[colored[i]] << "\n";
        cout << 1000000000 + uniq[dist1[colored[i]]] << "\n";
    }
    return 0;
}
