#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int ll
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << ' ' <<
#define __ << ' '

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

const int inf = 3e9, inf2 = 1e9;
const int MAXN = 3e5 + 10;
int ans[MAXN], used[MAXN];
vector<gp_hash_table<int, int> > gr;

void solve() {
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        ans[i] = inf;
        used[i] = 0;
    }
    int v, u, t;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> t; v--; u--;
        if (gr[v].find(u) == gr[v].end()) {
            gr[v][u] = t;
        }
        else {
            gr[v][u] = min(gr[v][u], t);
        }
        if (gr[u].find(v) == gr[u].end()) {
            gr[u][v] = t;
        }
        else {
            gr[u][v] = min(gr[u][v], t);
        }
    }
    priority_queue<pair<int, int> > q;
    for (auto &x : gr[0]) {
        ans[x.ff] = inf2;
        q.push({-inf2, x.ff});
    }
    while (!q.empty()) {
        auto tmp = q.top();
        v = tmp.ss;
        t = -tmp.ff;
        q.pop();
        if (ans[v] != t) continue;
        for (auto &x : gr[v]) {
            if (ans[x.ff] > min(t, x.ss) + inf2) {
                ans[x.ff] = min(t, x.ss) + inf2;
                q.push({-ans[x.ff], x.ff});
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}



/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 9
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/

