#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	vector<ll> sum(26);
	sum[0] = 1;
	for (int i = 1; i < 26; i++) {
		if (i % 2 == 1) {
			sum[i] = (ll)5 * sum[i - 1];
		}
		else {
			sum[i] = (ll)2 * sum[i - 1];
		}
	}

	while (t--) {
		string s;
		cin >> s;
		int n = s.size();
		vector<int> val(n);
		vector<int> ind;
		vector<vector<int>> num(26);
		vector<ll> count;
		vector<int> cnt(26, 0);
		vector<int> left;
		for (int i = 0; i < n; i++) {
			if (s[i] == '?') {
				ind.push_back(i);
				val[i] = -1;
				for (int j = 0; j < 26; j++) {
					num[j].push_back(cnt[j]);
					cnt[j] = 0;
				}
				left.resize(0);
			}
			else {
				val[i] = s[i] - 'A';
				left.push_back(val[i]);
				cnt[val[i]]++;
			}
		}
		
		if (ind.size() == 0) {
			vector<int> _max(n);
			_max[n - 1] = val[n - 1];
			for (int i = n - 2; i >= 0; i--) {
				_max[i] = max(_max[i + 1], val[i]);
			}
			ll cur = 0;
			for (int i = 0; i < n; i++) {
				if (val[i] < _max[i]) {
					cur -= sum[val[i]];
				} else {
					cur += sum[val[i]];
				}
			}
			cout << cur << endl;
			cout << s << endl;
		}
		else {
			vector<ll> cur(26, 0);
			vector<ll> _new(26);
			vector<vector<int>> pr(ind.size(), vector<int>(26));
			for (int i = 0; i < ind.size(); i++) {
				for (int j = 0; j < 26; j++) {
					ll cur_val = 0;
					if (i == 0) {
						for (int k = 0; k < 26; k++) {
							if (k < j) {
								cur_val -= sum[k] * num[k][i];
							}
							else {
								cur_val += sum[k] * num[k][i];
							}
						}
						cur[j] = cur_val + sum[j];
						continue;
					}
					ll _max = -1e18;
					int ind = -1;
					for (int k = 0; k < 26; k++) {
						if (k != 25) {
							cur_val -= sum[k] * num[k][i];
						}
						else {
							cur_val += sum[k] * num[k][i];
						}
					}
					for (int k = 25; k >= j; k--) {
						if (k != 25) {
							cur_val += (ll)2 * sum[k] * num[k][i];
						}
						if (cur_val + sum[j] > _max) {
							_max = cur_val + sum[j];
							ind = k;
						}
					}
					pr[i][j] = ind;
					_new[j] = cur[ind] + _max;
				}
				if (i != 0) {
					for (int j = 0; j < 26; j++) {
						cur[j] = _new[j];
					}
				}
			}
			vector<vector<int>> seq(26);
			for (int i = 0; i < 26; i++) {
				int t = ind.size() - 1;
				int _l = i;
				while (t >= 0) {
					seq[i].push_back(_l);
					_l = pr[t][_l];
					t--;
				}
				reverse(seq[i].begin(), seq[i].end());
			/*	for (int j = 0; j < seq[i].size(); j++) {
					cout << char('A' + seq[i][j]);
				}
				cout << endl;*/
			}
			int ind = 0;
			for (int i = 1; i < 26; i++) {
				if (cur[i] > cur[ind]) {
					ind = i;
				}
			}
			int t = 0;
			ll add = 0;
			if (left.size() != 0) {
				int nn = left.size();
				vector<int> _max(nn);
				_max[nn - 1] = val[nn - 1];
				for (int qq = nn - 2; qq >= 0; qq--) {
					_max[qq] = max(_max[qq + 1], left[qq]);
				}
				for (int qq = 0; qq < nn; qq++) {
					if (left[qq] < _max[qq]) {
						add -= sum[left[qq]];
					}
					else {
						add += sum[left[qq]];
					}
				}
			}

			cout << cur[ind] + add << endl;
			for (int i = 0; i < n; i++) {
				if (s[i] != '?') {
					cout << s[i];
				} else {
					cout << char('A' + seq[ind][t++]);
				}
			}
			cout << endl;
		}
	}
	cin >> t;
	return 0;
}

					/*
					if (i == 1) {
						cout << "heheeey " << endl;
					}
					for (int k = 0; k < 26; k++) {
						if (k != 25) {
							cur_val -= sum[k] * num[k][i];
						} else {
							cur_val += sum[k] * num[k][i];
						}
					}
					for (int k = 25; k >= j; k--) {
						if (k != 25) {
							cur_val += (ll)2 * sum[k] * num[k][i];
						}
						if (cur_val + sum[k] > _max) {
							_max = cur_val + sum[k];
							ind = k;
						}
						//cout << "check " << cur_val << endl;
					}
					cout << j << " ----- " << cur[ind] << " " << _max << " " << ind << endl;
					pr[i][j] = ind;
					_new[j] = cur[ind] + _max;
				}
				for (int j = 0; j < 26; j++) {
					cout << i << " " << j << " cbcb " << cur[j] << endl;
					cur[j] = _new[j];
				}*/
			//}
			/*for (int i = 0; i < 26; i++) {
				cout << cur[i] << endl;
			}*/
		//