#include<bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int const maxn = 150005;
vector < pair < int, int > > g[maxn];
int dp[maxn][3], used[maxn];
map < pair < int, int >, int > cntt, tmp;
int oki[maxn];
vector < vector < int > > ans;

int get(int u, int v) {
    if (u > v) swap(u, v);
    return cntt[{u, v}];
}

inline void del(int u, int v) {
    if (u > v) swap(u, v);
    cntt[{u, v}]--;
}

void dfs(int v, int p) {
    used[v] = 1;
    int child = 0;
    for (auto u : g[v]) {
        if (used[u.first] == 0) {
            child++;
            dfs(u.first, v);
        }
    }
    if (child == 0) {
        dp[v][0] = 1;
        return;
    }
    int flag = 1, out = 0, in = 0;
    for (auto u : g[v]) {
        if (u.first == p) continue;
        if (u.second) {
            if (dp[u.first][1]) {
                oki[u.first] = 1;
                continue;
            }
            if (dp[u.first][0]) out++;
            else {
                if (get(u.first, v) == 1 && !oki[u.first]) flag = 0;
                else out++;
                del(u.first, v);
            }
        }
        else {
            if (dp[u.first][2]) {
                oki[u.first] = 1;
                continue;
            }
            if (dp[u.first][0]) in++;
            else {
                if (get(u.first, v) == 1 && !oki[u.first]) flag = 0;
                else in++;
                del(u.first, v);
            }
        }
    }
    if (flag) {
        if (in == out) dp[v][0] = 1;
        else if (in - out == 1) dp[v][2] = 1;
        else if (out - in == 1) dp[v][1] = 1;
    }
}

pair < int, int > get(int v, int p, int i) {
    used[v] = 2;
    vector < pair < int, int > > out, in;
    for (auto u : g[v]) {
        if (u.first == p) continue;
        if (u.second) {
            if (dp[u.first][1]) {
                oki[u.first] = 2;
                assert(used[u.first] == 1);
                pair < int, int > cur = get(u.first, v, 1);
                ans.push_back({v, u.first, cur.first, cur.second});
                continue;
            }
            out.push_back({v, u.first});
        }
        else {
            if (dp[u.first][2]) {
                oki[u.first] = 2;
                assert(used[u.first] == 1);
                pair < int, int > cur = get(u.first, v, 2);
                ans.push_back({cur.first, cur.second, u.first, v});
                continue;
            }
            in.push_back({u.first, v});
        }
    }
    if (i == 0) {
        assert((int)in.size() == (int)out.size());
        for (int i = 0; i < (int)in.size(); ++i) {
            ans.push_back({in[i].first, in[i].second, out[i].first, out[i].second});
        }
        for (auto key : g[v]) {
            if (oki[key.first] == 1) {
                get(key.first, v, 0);
                oki[key.first] = 2;
            }
        }
        return {0, 0};
    }
    else if (i == 1) {
        assert((int)out.size() == (int)in.size() + 1);
        for (int i = 0; i < (int)in.size(); ++i) {
            ans.push_back({in[i].first, in[i].second, out[i].first, out[i].second});
        }
        for (auto key : g[v]) {
            if (oki[key.first] == 1) {
                get(key.first, v, 0);
                oki[key.first] = 2;
            }
        }
        return out.back();
    }
    else {
        assert((int)out.size() == (int)in.size() - 1);
        for (int i = 0; i < (int)in.size() - 1; ++i) {
            ans.push_back({in[i].first, in[i].second, out[i].first, out[i].second});
        }
        for (auto key : g[v]) {
            if (oki[key.first] == 1) {
                get(key.first, v, 0);
                oki[key.first] = 2;
            }
        }
        return in.back();
    }
}

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, u, v;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v;
        g[u].push_back({v, 1});
        g[v].push_back({u, 0});
        cntt[{min(u, v), max(u, v)}]++;
        tmp[{u, v}]++;
    }
    for (int i = 1; i <= n; ++i) {
        if (used[i] == 0) {
            dfs(i, 0);
            if (!dp[i][0]) {
                cout << "No" << '\n';
                exit(0);
            }
            get(i, 0, 0);
        }
    }
    cntt = tmp;
    cout << "Yes" << '\n';
    assert((int)ans.size() == m / 2);
    for (auto key : ans) {
        assert(key[1] == key[2]);
        tmp[{key[0], key[1]}]--;
        int val = tmp[{key[0], key[1]}];
        assert(val >= 0);
        tmp[{key[2], key[3]}]--;
        val = tmp[{key[2], key[3]}];
        assert(val >= 0);
        for (auto elem : key) cout << elem << " ";
        cout << '\n';
    }
    return 0;
}

