#include <vector>
#include <algorithm>
#include <iostream>
#include <set>

using namespace  std;

#define int long long
const int INF = 1e12;
vector<vector<pair<int, int>>> g, lst;
vector<int> ans;
int n, m;

void dfs(int st, int pr = -1, int mn = INF, int mx = 0){
    ans[st] = mn + mx;
    for (pair<int, int> to : lst[st]){
        if (to.first == pr) continue;
        dfs(to.first, st, min(mn, to.second), max(mx, to.second));
    }
}
signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    g.assign(n, {});
    lst.assign(n, {});
    vector<pair<int, pair<int ,int>>> edg;
    for (int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        edg.push_back({c, {a, b}});
    }
    ans.assign(n, INF);
    for (int i =0; i < m; i++){
        int a= edg[i].second.first,  b = edg[i].second.second;
        lst[a].push_back({b, edg[i].first});
        lst[b].push_back({a, edg[i].first});
    }
    dfs(0);
}
/*
7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
 */