#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

typedef long long int ll;

struct rst {
	ll l, r;
};

void kill_tree(vector<rst>& b, vector<ll>& left, vector<ll>& right, vector<ll>& h,ll l,ll r,ll x, vector<bool>& killed) {
	killed[x] = true;
	/*cout << x << " " << left[x] << " " << right[x] << " " << h[x] << " " << b[x].l << " " << b[x].r << endl;
	if (left[x] != -1) {
		ll y = left[x];
		cout << "left " << left[y] << " " << right[y] << " " << h[x] << " " << b[x].l << " " << b[x].r << endl;
	}
	if (right[x] != -1) {
		ll y = right[x];
		cout << "right " << left[y] << " " << right[y] << " " << h[x] << " " << b[x].l << " " << b[x].r << endl;
	}*/
	if (left[x] != -1) {
		b[left[x]].r += b[x].r;
		right[left[x]] = right[x];
		if (left[x] >= l && (b[left[x]].l > h[left[x]] || b[left[x]].r > h[left[x]]))
			kill_tree(b, left, right, h, l, r, left[x], killed);
	}
	if (right[x] != -1) {
		b[right[x]].l += b[x].l;
		left[right[x]] = left[x];
		if (right[x] <= r && (b[right[x]].l >= h[right[x]] || b[right[x]].r >= h[right[x]]))
			kill_tree(b, left, right, h, l, r, right[x], killed);
	}
}

ll kill_l_r(vector<rst>& b, vector<ll>& h, vector<ll>& left, vector<ll>& right, ll l, ll r, vector<bool>& killed) {
	ll res = 0;
	for (ll i = l; i <= r; i++) {
		if (!killed[i] && h[i] <= b[i].l || h[i] <= b[i].r) kill_tree(b, left, right, h, l, r, i, killed);
	}
	for (ll i = l; i <= r; i++) {
		if (!killed[i] && h[i] <= b[i].l || h[i] <= b[i].r) kill_tree(b, left, right, h, l, r, i, killed);
	}
	for (ll i = l; i <= r; i++) if (killed[i]) res++;
	return res;

}

int main() {
	ll n, q;
	cin >> n >> q;
	vector<ll> a(n);
	vector<rst> b(n);
	vector<ll> h(n);
	vector<bool> killed(n, false);
	vector<ll> left(n);
	vector<ll> right(n);
	for (ll i = 1; i < n; i++) {
		left[i] = i - 1;
		right[i - 1] = i;
	}
	left[0] = -1;
	right[n - 1] = -1;
	cin >> a[0] >> h[0];
	b[0].l = 0;
	for (ll i = 1; i < n; i++) {
		cin >> a[i] >> h[i];
		b[i].l = a[i] - a[i - 1];
		b[i - 1].r = b[i].l;
	}
	b[n - 1].r = 0;
	/*for (ll j = 0; j < n; j++) {
		if (!killed[j]) cout << j + 1 << " " << left[j] + 1 << " " << right[j] + 1 << " " << h[j] << " " << b[j].l << " " << b[j].r << endl;
	}*/
	vector<rst> b1;
	vector<ll> left1;
	vector<ll> right1;
	vector<bool> killed1;
	for (ll i = 0; i < q; i++) {
		ll l, r;
		cin >> l >> r;
		l--;
		r--;
		b1 = b;
		left1 = left;
		right1 = right;
		killed1 = killed;
		ll res=kill_l_r(b1, h, left1, right1, l, r, killed1);
		cout << res << endl;
		//cout << "\n" << endl;
		/*for (ll j = 0; j < n; j++) {
			if(!killed[j]) cout << j + 1 << " " << left[j] + 1 << " " << right[j] + 1 << " " << h[j] << " " << b[j].l << " " << b[j].r << endl;
		}*/
	}
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1


1 1
100 100 
1 1
*/