#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

map <char, ll> h;

void init() {
	ll cur = 1;
	for (char c = 'A'; c <= 'Z'; ++c) {
		h[c] = cur;
		if (c & 1) {
			cur *= 5;
		}
		else {
			cur *= 2;
		}
	}
}

ll calc(string s) {
	map <char, ll> cnt;
	ll ans = 0;
	for (int j = n - 1; j >= 0; --j) {
		bool sub = false;
		for (char c = s[j] + 1; c <= 'Z'; ++c) {
			if (cnt[c]) {
				ans -= h[s[j]];
				sub = true;
				break;
			}
		}
		if (!sub) {
			ans += h[s[j]];
			cnt[s[j]]++;
		}
	}
	return ans;
}

int main() {
	init();

	ll t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;
		n = s.size();
		ll ans = 0;
		vector <ll> pos;
		for (int i = 0; i < n; ++i) {
			if (s[i] == '?') {
				pos.push_back(i);
			}
		}


		ll left = pos.size();
		for (int i = pos.size() - 1; i >= 0; --i) {
			char el = -1;
			ll ans = -INF;
			for (char c = 'Z'; c >= 'A'; --c) {
				for (int j = 0; j <= i; ++j) {
					s[pos[j]] = c;
				}
				if (maxi(ans, calc(s))) {
					el = c;
				}
			}
			for (int j = 0; j <= i; ++j) {
				s[pos[j]] = el;
			}
		}


		
		cout << calc(s) << '\n';
		cout << s << '\n';

	}
	return 0;
}