#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve(){
    string s;
    cin >> s;
    int n = s.size();
    vector<char>ans(n);
    vector<ll>may_otr(26);
    ll otr_100 = 0;
    vector<ll>cost(26);
    for(ll i = 0, to = 1; i < 26; i++){
        cost[i] = to;
        if(i % 2 == 0){
            to *= 5;
        }
        else{
            to *= 2;
        }
    }
    vector<vector<ll> >dp(n, vector<ll>(26));
    vector<vector<ll> >parent(n, vector<ll>(26));
    vector<int>parent1(n);
    int max_letter = 0, past_q = -1;
    for(int i = 0; i < n; i++){
        if(s[i] != '?'){
            ans[i] = s[i];
            max_letter = max(max_letter, s[i] - 'A');
            for(int j = 0; j < s[i] - 'A'; j++){
                otr_100 += may_otr[j];
                may_otr[j] = 0;
            }
            may_otr[s[i] - 'A'] += cost[s[i] - 'A'];
        }
        else{
            parent1[i] = past_q;
            if(past_q == -1){
                for(int j = 0; j < 26; j++){
                    ll otr = 0;
                    for(int k = 0; k < j; k++){
                        otr += may_otr[k];
                    }
                    ll ne_otr = 0;
                    for(int k = j; k < 26; k++){
                        ne_otr += may_otr[k];
                    }
                    dp[i][j] = cost[j] + ne_otr - otr - otr_100;
                }
                max_letter = 0;
                past_q = i;
                otr_100 = 0;
                may_otr.assign(26, 0);
                continue;
            }
            for(int j = 0; j < 26; j++){
                dp[i][j] = dp[past_q][max(max_letter, j)];
                parent[i][j] = max(max_letter, j);
                for(int k = max(max_letter, j) + 1; k < 26; k++){
                    if(dp[i][j] < dp[past_q][k]){
                        dp[i][j] = dp[past_q][k];
                        parent[i][j] = k;
                    }
                }
                ll otr = 0;
                for(int k = 0; k < j; k++){
                    otr += may_otr[k];
                }
                ll ne_otr = 0;
                for(int k = j; k < 26; k++){
                    ne_otr += may_otr[k];
                }
                dp[i][j] += cost[j] + ne_otr - otr - otr_100;
            }
            otr_100 = 0;
            may_otr.assign(26, 0);
            past_q = i;
            max_letter = 0;
        }
    }
    if(past_q != -1){
        ll c = dp[past_q][max_letter], cur_letter = max_letter;
        for(int k = max_letter + 1; k < 26; k++){
            if(c < dp[past_q][k]){
                c = dp[past_q][k];
                cur_letter = k;
            }
        }
        while(past_q != -1){
            ans[past_q] = cur_letter + 'A';
            cur_letter = parent[past_q][cur_letter];
            past_q = parent1[past_q];
        }
    }
    ll res = 0;
    char cur_max = 'A';
    for(int i = n - 1; i >= 0; i--){
        if(ans[i] >= cur_max){
            res += cost[ans[i] - 'A'];
        }
        else{
            res -= cost[ans[i] - 'A'];
        }
        cur_max = max(cur_max, ans[i]);
    }
    cout << res << endl;
    for(int i = 0; i < n; i++){
        cout << ans[i];
    }
    cout << endl;
}

int main()
{
    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
