#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()

ll dp[300000][26];
char pr[300000][26];
int pred[300000][26];

const int con = 26;
ll inf = 3e18;

signed main() {

#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;

    vector<ll> cost(con);
    cost[0] = 1, cost[1] = 5;
    for (int i = 2; i < size(cost); ++i) {
        cost[i] = cost[i - 2] * (ll) 10;
    }
    cout << 26 * 300000 << "\n";

    while (t--) {
        string s;
        cin >> s;
        int n = size(s);

        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') cnt++;
        }

        if (cnt == 0) {
            ll sm = 0;
            int mx = 0;
            for (int i = n - 1; i >= 0; --i) {
                if (mx > s[i] - 'A') sm -= cost[s[i] - 'A'];
                else sm += cost[s[i] - 'A'];
                mx = max(mx, s[i] - 'A');
            }
            cout << sm << "\n";
            cout << s << "\n";
            continue;
        }

        for (int i = 0; i < con; ++i) {
            dp[0][i] = -inf;
            if (s[0] == '?') {
                dp[0][i] = cost[25];
                pr[0][i] = 'Z';
            } else {
                int j = s[0] - 'A';
                if (j < i) {
                    if (dp[0][i] < -cost[j]) {
                        dp[0][i] = -cost[j];
                        pr[0][i] = j + 'A';
                    }
                } else {
                    if (dp[0][i] < cost[j]) {
                        dp[0][i] = cost[j];
                        pr[0][i] = j + 'A';
                    }
                }
            }
        }

        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < con; ++j) {
                if (s[i] == '?') {
                    dp[i][j] = dp[i - 1][j] + cost[j];
                    pr[i][j] = j + 'A';
                    pred[i][j] = j;
                    for (int k = j + 1; k < 26; ++k) {
                        if (dp[i][j] < dp[i - 1][k] + cost[k]) {
                            dp[i][j] = dp[i - 1][k] + cost[k];
                            pr[i][j] = k + 'A';
                            pred[i][j] = k;
                        }
                    }
                } else {
                    dp[i][j] = -inf;
                    int k = s[i] - 'A';
                    if (k < j) {
                        dp[i][j] = dp[i - 1][j] - cost[k];
                        pr[i][j] = k + 'A';
                        pred[i][j] = j;
                    } else {
                        dp[i][j] = dp[i - 1][k] + cost[k];
                        pr[i][j] = k + 'A';
                        pred[i][j] = k;
                    }
                }
            }
        }
        cout << dp[n - 1][0] << "\n";
        int x = n - 1, y = 0;
        string p = "";
        p = pr[x][y] + p;
        while (x != 0) {
            y = pred[x][y];
            x--;
            p = pr[x][y] + p;
        }
        cout << p;
        cout << "\n";

        //cout << 26 * 3 * 100000 << "\n";
    }

}
