#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

int n, q;
vector<int> x, h;
vector<vector<int> > req;
vector<int> ans;

int bl = 2;

bool cmp(vector<int> &a, vector<int> &b) {
    if (a[2] / bl < b[2] / bl) return true;
    if (a[2] / bl > b[2] / bl) return false;
    if (a[1] < b[1]) return true;
    return false;
}

int fn(int ri, stack<int> &st, int lft, vector<int> &mn) {
    int l = ri - 1, r = size(st);
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (mn[mid] < lft) r = mid;
        else l = mid;
    }
    return r;
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> q;
    x.resize(n), h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    ans.resize(q);
    for (int i = 0; i < q; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        req.push_back({a, b, i});
    }

    sort(all(req), cmp);

    int l = 0, r = 0;
    stack<int> st;
    vector<int> pos(n, 0);

    vector<int> mn(n, 1e9);

    for (int i = 0; i < q; ++i) {
        int a = req[i][0], b = req[i][1];
        if (b < r) {
            while (!st.empty()) st.pop();
            int nm = a / bl;
            l = (nm + 1) * bl;
            r = (nm + 1) * bl;
        }

        while (r < req[i][1]) {
            while (!st.empty()) {
                int v = st.top();
                if (x[v] + h[v] <= x[r]) {
                    st.pop();
                } else break;
            }
            int le = x[0];
            if (l > 0) le = x[l - 1];
            if (!st.empty()) le = x[st.top()];
            if (le + h[r] > x[r]) {
                mn[size(st)] = x[r] - h[r];
                if (size(st) != 0) mn[size(st)] = min(mn[size(st) - 1], mn[size(st)]);
                pos[size(st)] = r;
                st.push(r);
            }
            r++;
        }
        int ri = x[n - 1];
        if (b != n) ri = x[b];
        while (!st.empty()) {
            int v = st.top();
            if (x[v] + h[v] <= ri) {
                st.pop();
            } else break;
        }

        stack<int> rg;
        for (int j = a; j < min(b, l); ++j) {
            while (!rg.empty()) {
                int v = rg.top();
                if (x[v] + h[v] <= x[j]) {
                    rg.pop();
                } else break;
            }
            int le = x[0];
            if (a != 0) le = x[a - 1];
            if (!rg.empty()) le = x[rg.top()];
            if (le + h[j] > x[j]) {
                rg.push(j);
            }
        }

        ri = 0;
        while (true) {
            bool ch = false;

            int lft = x[0];
            if (a != 0) lft = x[a - 1];
            if (!rg.empty()) lft = x[rg.top()];
            ri = fn(ri, st, lft, mn);

            if (!rg.empty()) {
                int v = rg.top();
                int rgh = x[n - 1];
                if (b != n) rgh = x[b];
                if (ri != size(st)) rgh = pos[ri];
                if (x[v] + h[v] <= rgh) {
                    rg.pop();
                    ch = true;
                }
            }

            if (!ch) break;
        }

        ans[req[i][2]] = b - a - size(rg) - size(st);
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }
}