#include <bits/stdc++.h>

using namespace std;

#define int long long

const int ALF = 26;
const long long MAXC = 5e12, INF = 1e18;

vector<long long> a;

long long getVal(string& s) {
    long long cnt[ALF] = {};
    long long sum = 0;
    for (int i = 0; i < s.size(); i++) {
        for (int cc = 0; cc < s[i] - 'A'; cc++) {
            sum -= cnt[cc] * a[cc];
            cnt[cc] = 0;
        }
        cnt[s[i] - 'A']++;
    }
    for (int c = 0; c < ALF; c++) {
        sum += cnt[c] * a[c];
    }
    return sum;
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    long long dp[n][ALF];
    pair<int, int> pred[n][ALF];
    for (int i = 0; i < n; i++) {
        for (int c = 0; c < ALF; c++) {
            dp[i][c] = -INF;
            pred[i][c] = {-1, -1};
        }
    }
    bool valid[n] = {};
    int cnt[ALF] = {};
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            continue;
        }
        for (int c = s[i] - 'A' + 1; c < ALF; c++) {
            valid[i] |= (cnt[c] > 0);
        }
        cnt[s[i] - 'A']++;
    }
    for (int i = 0; i < n; i++) {
        if (s[i] != '?') {
            continue;
        }
        int nearby = -1;
        for (int j = i - 1; j >= 0; j--) {
            if (s[j] == '?') {
                nearby = j;
                break;
            }
        }
        for (int c = 0; c < ALF; c++) {
            long long delta = a[c];
            for (int k = nearby + 1; k < i; k++) {
                if (!valid[k]) {
                    delta += a[s[k] - 'A'] * ((s[k] - 'A') >= c ? 1 : -1);
                }
            }
            if (nearby == -1) {
                dp[i][c] = delta;
            } else {
                for (int cc = c; cc < ALF; cc++) {
                    if (delta + dp[nearby][cc] > dp[i][c]) {
                        pred[i][c] = {nearby, cc};
                        dp[i][c] = delta + dp[nearby][cc];
                    }
                }
            }
        }
    }
    int kek = -1;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            kek = i;
            break;
        }
    }
    if (kek == -1) {
        cout << getVal(s) << endl << s << endl;
        return;
    }
    long long sum = -INF, id = -1;
    for (int c = 0; c < ALF; c++) {
        if (dp[kek][c] > sum) {
            sum = dp[kek][c];
            id = c;
        }
    }
    while (kek != -1) {
        s[kek] = id + 'A';
        auto p = pred[kek][id];
        kek = p.first, id = p.second;

    }
    cout << getVal(s) << endl << s << endl;
}

signed main() {
    a.push_back(1);
    int k = 5;
    while (a.back() != MAXC) {
        a.push_back(a.back() * k);
        k = (k == 2 ? 5 : 2);
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
