#pragma comment(linker, "/STACK:10000000000")
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

//const int MAX_MEM = 1e8;
//int mpos = 0;
//char mem[MAX_MEM];
//inline void * operator new (size_t n) {
//    assert((mpos += n) <= MAX_MEM);
//    return (void *) (mem + mpos - n);
//}
//inline void operator delete (void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(x) (x) * (x)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(386493230);

const int inf = 1e18;
const int maxn = 3e5 + 10;
const int maxk = 26;
int used[maxk];
int dp[maxn][maxk];
int p[maxn][maxk];
int val[maxk];

int sgn(int res) {
    return (res ? -1 : 1);
}

int get_num(int x) {
    return val[x];
}

int calc_num(int x) {
    int k = x / 2;
    int res = 1;
    for (int i = 0; i < k; i++) {
        res *= 10;
    }
    if (x & 1) res *= 5;
    return res;
}

void solve() {
    string s;
    cin >> s;
    int n = sz(s);
    memset(used, 0, sizeof used);
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < maxk; j++) {
            dp[i][j] = -inf;
        }
    }
    dp[n][0] = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            for (int ch = 0; ch < maxk; ch++) {
                for (int j = 0; j <= ch; j++) {
                    if (amax(dp[i][ch], dp[i + 1][j] + sgn(0) * get_num(ch))) {
                        p[i][ch] = j;
                    }
                }
            }
        } else {
            bool was = false;
            int ch = s[i] - 'A';
            for (int j = ch + 1; j < maxk; j++) was |= used[j];
            for (int j = 0; j < maxk; j++) {
                if (j <= ch) {
                    if (amax(dp[i][j], dp[i + 1][j] + sgn(was) * get_num(ch))) {
                        p[i][j] = j;
                    }
                } else {
                    if (amax(dp[i][j], dp[i + 1][j] + sgn(1) * get_num(ch))) {
                        p[i][j] = j;
                    }
                }
            }
            used[ch] = 1;
        }
    }
    int j = 0;
    for (int ch = 0; ch < maxk; ch++) {
        if (dp[0][ch] > dp[0][j]) {
            j = ch;
        }
    }
    cout << dp[0][j] << "\n";
    vi ans;
    for (int i = 0; i < n; i++) {
        if (s[i] == '?') ans.push_back(j);
        else ans.push_back(s[i] - 'A');
        j = p[i][j];
    }
    for (auto &el : ans) {
        cout << char('A' + el);
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
    for (int i = 0; i < maxk; i++) {
        val[i] = calc_num(i);
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}