#include <bits/stdc++.h>

using namespace std;


string encode(string s) {
	int n = s.size();

	uint32_t xor_ones_pos = 0;
	for(int i = 0; i < n; i++) {
		if(s[i] == '1') {
			xor_ones_pos ^= i + 1;
		}
	}

	int parity = 0;
	for(int i = 0; i < n; i++) {
		parity ^= s[i] - '0';
	}

	stringstream ss;
	ss << s << bitset<17>(xor_ones_pos) << parity;
	return ss.str();
}


string decode(string t) {
	int n = t.size() - 18;

	uint32_t xor_ones_pos = 0;
	for(int i = n; i < n + 17; i++) {
		xor_ones_pos = xor_ones_pos * 2 + (t[i] - '0');
	}

	uint32_t cur_xor_ones_pos = 0;
	for(int i = 0; i < n; i++) {
		if(t[i] == '1') {
			cur_xor_ones_pos ^= i + 1;
		}
	}

	string s = t.substr(0, n);

	if(xor_ones_pos == cur_xor_ones_pos) {
		return s;
	}

	int parity = t[n + 17] - '0';

	int cur_parity = 0;
	for(int i = 0; i < n; i++) {
		cur_parity ^= t[i] - '0';
	}
	if(parity == cur_parity) {
		return s;
	}

	uint32_t pos = (xor_ones_pos ^ cur_xor_ones_pos) - 1;
	s[pos] ^= 1;
	return s;
}


signed main() {
	int t;
	cin >> t;

	string s;
	cin >> s;

	if(t == 1) {
		cout << encode(s) << endl;
	} else {
		cout << decode(s) << endl;
	}

	return 0;
}