#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define ld long double
#define pb emplace_back

const ll mod = 536870911;
const ll p = 179;
const int MAXN = 2e5;
const int MAXK = 29;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<ll> my_pow(MAXN);
    my_pow[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        my_pow[i] = (my_pow[i - 1] * p) % mod;
    }
    int g;
    cin >> g;
    if (g == 1) {
        string s;
        cin >> s;
        ll h = 0;
        for (int i = (int)s.size() - 1; i >= 0; i--) {
            h *= p;
            h += s[i] - '0';
            h %= mod;
        }
        string add = "";
        for (int i = 0; i < MAXK; i++) {
            if (h & (1 << i)) add += '1';
            else add += '0';
        }
        cout << s << add << "\n";
    } else {
        string s;
        cin >> s;
        int n = s.size() - MAXK;
        ll h = 0;
        for (int i = n - 1; i >= 0; i--) {
            h *= p;
            h += s[i] - '0';
            h %= mod;
        }
        ll h1 = 0;
        for (int i = n; i < (int)s.size(); i++) {
            if (s[i] == '1') h1 += (1 << (i - n));
        }
        if (h == h1) {
            cout << s.substr(0, n) << "\n";
            return 0;
        }
        for (int i = 0; i < n; i++) {
            if (s[i] == '0') {
                h += my_pow[i];
                h %= mod;
                if (h == h1) {
                    s[i] = '1';
                    cout << s.substr(0, n) << "\n";
                    return 0;
                }
                h -= my_pow[i];
                if (h < 0) h += mod;
            } else {
                h -= my_pow[i];
                if (h < 0) h += mod;
                if (h == h1) {
                    s[i] = '0';
                    cout << s.substr(0, n) << "\n";
                    return 0;
                }
                h += my_pow[i];
                h %= mod;
            }
        }
        cout << s.substr(0, n) << "\n";
    }
    return 0;
}
