#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &p) {
    is >> p.first >> p.second;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
    return os;
}

template<typename T>
ostream &operator<<(ostream &os, pair<T, T> &p) {
    os << p.first << ' ' << p.second;
    return os;
}

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pair<int, int>> vpi;


inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void Solve() {
    vi a;
    int p;
    while (cin >> p) {
        a.pb(p);
    }
    reverse(all(a));
    cout << a;
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    for (int ii = 0; ii < t; ii++) {
        Solve();
    }
    return 0;
}