#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

#define pb emplace_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define out(x); { for (auto i : x) cout << i << " "; cout << endl; }

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pair <int, int>> vii;
typedef vector <ll> vll;



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    string a, b;
    cin >> a >> b;
    reverse(all(a));
    reverse(all(b));

    while (a.size() < b.size()) a += '0';
    while (b.size() < a.size()) b += '0';

    int of = 0;
    string c;
    for (int i = 0; i < a.size(); i++) {
        c += (a[i] + b[i] + of - '0');
        of = (c[i] - '0') / 10;
        c[i] = '0' + (c[i] - '0') % 10;
    }
    if (of) c += '1';

    while (c.back() == '0' && c.size() > 1)
        c.pop_back();

    reverse(all(c));
    cout << c << endl;
}
