#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define f first
#define s second

const int maxk = 26, maxn = 100000, R = 1 << 17;

int used[maxk][maxk];
string s;
int k, n;
string ans[maxn];

bool cmp(int a, int b) {
    for (int i = 0; i < min(ans[a].size(), ans[b].size()); ++i) {
        if (ans[a][i] != ans[b][i]) {
            return ans[a][i] < ans[b][i];
        }
    }
    return ans[a].size() < ans[b].size();
}

int t[R * 2];

void add(int pos) {
    pos += R;
    t[pos] = pos - R;
    for (pos /= 2; pos > 0; pos /= 2) {
        if (cmp(t[pos * 2], t[pos * 2 + 1])) {
            t[pos] = t[pos * 2];
        } else {
            t[pos] = t[pos * 2 + 1];
        }
    }
}

int get1(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return t[node];
    }
    if (qr <= nl || nr <= ql) {
        return ql;
    }
    int nm = (nl + nr) / 2;
    int v1 = get1(ql, qr, node * 2, nl, nm);
    int v2 = get1(ql, qr, node * 2 + 1, nm, nr);
    if (cmp(v1, v2)) {
        return v1;
    } else {
        return v2;
    }
}

void get(int p, int mx) {
    int p2 = p + 1;
    if (p == n - 1 || mx == n - 1) {
        ans[p] = "";
        ans[p] += s[p];
        add(p);
        return;
    }
    for (int j = p + 1; j < n; ++j) {
        if (j == p + 1) {
            p2 = j;
        } else {
//            if (del[p + 1][j - 1] == 0) {
//                break;
//            }
            p2 = j;
        }
    }
    ans[p] = s[p] + ans[get1(p + 1, max(mx + 1, p + 1) + 1)];
    add(p);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            used[i][j] = (c - '0');
        }
    }
    cin >> s;
    int mx = 0;
    for (int i = n - 1; i >= 0; --i) {
        get(i, mx);
        if (used[s[i - 1] - 'a'][s[i] - 'a'] == 0) {
            mx = 0;
            continue;
        }
        vector<int> st;
        mx = i;
        st.pb(i - 1);
        st.pb(i);
        for (int j = i + 1; j < n; ++j) {
            while (st.size() > 1) {
                if (!used[s[st.back()] - 'a'][s[j] - 'a']) {
                    st.pop_back();
                } else {
                    break;
                }
            }
            if (!used[s[st.back()] - 'a'][s[j] - 'a']) {
                break;
            }
            mx = j;
            st.pb(j);
        }
    }
    cout << ans[0];
    return 0;
}