#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n; cin >> n;
    unordered_map <int, int> tasks;
    vector <pair <int, vector <int> > > g(n);
    for (int i = 0; i < n; i++)
    {
        cin >> g[i].first;
        int cnt; cin >> cnt;
        for (int j = 0; j < cnt; j++)
        {
            int temp; cin >> temp;
            g[i].second.push_back(temp);
            if (g[i].first == 2)
            {
                int t = tasks.size();
                tasks[temp] = t;
            } else
            {
                g[i].second.back()--;
            }
        }
    }

    int k = 1 << tasks.size();

    function <int(int, int)> get = [&](int n, int p)
    {
        return n & (1 << p);
    };

    for (int mask = 0; mask < k; mask++)
    {
        bool ok = true;
        vector <bool> used(n, false);
        unordered_map <int, vector <int> > dp;
        unordered_map <int, vector <int> > ans;

        function <void (int)> dfs = [&](int from)
        {
            if (!ok) return;
            used[from] = true;

            if (g[from].first == 2)
            {
                for (auto t : g[from].second)
                {
                    if (get(mask, tasks[t]))
                    {
                        ans[from].push_back(t);
                        dp[from].push_back(t);
                    }
                }

                if (ans[from].size() > 2 || ans[from].size() == 0)
                {
                    ok = false;
                    return;
                }
            } else
            {
                vector <pair <vector <int>, int> > nums;
                for (auto to : g[from].second)
                {
                    if (!used[to])
                        dfs(to);
                    if (!ok)
                        return;
                    nums.push_back({dp[to], to});
                }

                sort(nums.begin(), nums.end());
                bool found = false;

                do
                {
                    vector <int> temp;
                    for (auto& v : nums)
                        for (auto k : v.first)
                            temp.push_back(k);
                    bool sorted = true;
                    for (int i = 1; i < temp.size(); i++)
                        if (temp[i] <= temp[i - 1])
                        {
                            sorted = false;
                            break;
                        }
                    if (sorted)
                    {
                        found = true;
                        for (int i = 0; i < nums.size(); i++)
                            ans[from].push_back(nums[i].second + 1);
                        dp[from] = move(temp);
                        break;
                    }
                } while (next_permutation(nums.begin(), nums.end()));

                if (!found)
                {
                    ok = false;
                    return;
                }
            }
        };

        for (int i = 0; i < n; i++)
            if (!used[i])
                dfs(i);

        if (ok)
        {
            cout << "Yes\n";
            for (int i = 0; i < n; i++)
            {
                copy(ans[i].begin(), ans[i].end(), ostream_iterator <int> (cout, " "));
                cout << "\n";
            }
            return 0;
        }
    }

    cout << "No";
}

