#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; (i) < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; (i) >= 0; i--)

const int N = 500100;
const int A = 26;

bool a[A][A];
int v[N];

int dp[N];

int npos[A];
int r[N][A];

int main() {
	fastio;
	int k, n;
	cin >> k >> n;
	forn(i, k) {
		forn(j, k) {
			char c;
			cin >> c;
			a[i][j] = c == '1';
		}
	}
	for (int i = 0; i < n; i++) {
		char c;
		cin >> c;
		v[i] = c - 'a';
	}

	for (int i = n - 1; i >= 0; i--) {
		int pos = i + 1;
		while (pos < n) {
			if (!a[v[i]][v[pos]]) break;
			pos = dp[pos] + 1;
		}
		dp[i] = pos - 1;
	}

	int last[A];
	for (auto& i : last) i = n;
	for (auto& i : npos) i = n;
	for (int i = n - 1; i >= 0; i--) {
		forn(j, k) r[i][j] = last[j];
		last[v[i]] = i;
	}

	string ans;
	int pos = 0;
	while (true) {
		if (pos >= n) break;

		ans += (char)(v[pos] + 'a');

		if (dp[pos] == n - 1) break;

		for (int i = 0; i < k; i++) {
			if (r[pos][i] <= dp[pos] + 1) {
				pos = r[pos][i];
				break;
			}
		}
	}

	cout << ans << '\n';
	return 0;
}