#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
using namespace std;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; (i) < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; (i) >= 0; i--)

const int N = 500100;
const int A = 26;

bool a[A][A];
int v[N];

int dp[N];

int r[N][A];
int last[A];

bool comp(const pair<int, string>& f, const pair<int, string>& s) {
	return f.first > s.first;
}

string get(int n) {
	int k = 26;

	for (int i = n - 1; i >= 0; i--) {
		int pos = i + 1;
		while (pos < n) {
			if (!a[v[i]][v[pos]]) break;
			pos = dp[pos] + 1;
		}
		dp[i] = pos - 1;
	}

	for (auto& i : last) i = n;
	for (int i = n - 1; i >= 0; i--) {
		forn(j, k) r[i][j] = last[j];
		last[v[i]] = i;
	}

	vector<string> dp2(n + 1, "");

	vector<pair<int, string>> st;
	st.push_back(make_pair(n, ""));

	rforn(i, n) {
		auto it = lower_bound(all(st), make_pair(dp[i] + 1, ""), comp) - st.begin();
		dp2[i] = (char)(v[i] + 'a') + st[it].second;
		while (st.back().second > dp2[i]) {
			st.pop_back();
		}
		st.push_back(make_pair(i, dp2[i]));
	}

	return dp2[0];
}

string slow(int n, vector<int> cur = vector<int>()) {
	string res;

	if (cur.size() <= n) {
		vector<int> vv(n);
		forn(i, n) vv[i] = v[i];

		bool good = true;
		rforn(z, cur.size()) {
			int i = cur[z];
			if (i >= (int)vv.size() - 1 || !a[vv[i]][vv[i + 1]]) {
				good = false;
				break;
			}
			vv.erase(vv.begin() + i + 1);
		}

		if (good) {
			string temp;
			forn(i, vv.size()) temp += (char)(vv[i] + 'a');
			if (res.empty() || temp < res)
				res = temp;
		}
	}
	if (cur.size() < n) {
		for (int i = (cur.empty() ? 0 : cur.back()); i < n - 1; i++) {
			cur.push_back(i);
			auto temp = slow(n, cur);
			if (!temp.empty() && (res.empty() || temp < res)) {
				res = temp;
			}
			cur.pop_back();
		}
	}

	return res;
}

void test() {
	forn(z, 1000) {
		int k = 2;
		int n = 5;
		memset(a, 0, sizeof(a));
		forn(i, k) {
			forn(j, k) {
				a[i][j] = rand() % 2;
			}
		}
		forn(i, n) {
			v[i] = rand() % k;
		}

		auto res1 = slow(n), res2 = get(n);
		if (res1 != res2) {
			get(n);
		}
	}
	exit(0);
}


int main() {
	fastio;
	// test();
	int k, n;
	cin >> k >> n;
	forn(i, k) {
		forn(j, k) {
			char c;
			cin >> c;
			a[i][j] = c == '1';
		}
	}
	for (int i = 0; i < n; i++) {
		char c;
		cin >> c;
		v[i] = c - 'a';
	}

	cout << get(n) << '\n';
	return 0;
}