#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
using namespace std;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; (i) < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; (i) >= 0; i--)

const int N = 510;
vector<int> g[N];
vector<int> u[N];
vector<pair<int, int>> dp[N];

void f(int v, vector<int> order) {
	vector<pair<int, int>> cur = dp[g[v][order[0]]];
	for (int i = 1; i < order.size(); i++) {
		vector<pair<int, int>> ncur;
		for (auto j : cur) {
			for (auto k : dp[g[v][order[i]]]) {
				if (j.second < k.first) {
					ncur.push_back(make_pair(j.first, k.second));
				}
			}
		}
		sort(all(ncur));
		ncur.erase(unique(all(ncur)), ncur.end());
		cur = ncur;
	}
	for (auto i : cur) {
		dp[v].push_back(i);
	}
	sort(all(dp[v]));
	dp[v].erase(unique(all(dp[v])), dp[v].end());
}

void r(int v, vector<int> cur = vector<int>()) {
	if (cur.size() == g[v].size()) {
		f(v, cur);
		return;
	}
	vector<bool> used(g[v].size(), false);
	for (auto i : cur) used[i] = true;
	forn(i, g[v].size()) {
		if (!used[i]) {
			cur.push_back(i);
			r(v, cur);
			cur.pop_back();
		}
	}
}

void dfs(int v = 0) {
	if (!g[v].size()) {
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
	}
	r(v);
}

int main() {
	fastio;
	int n;
	cin >> n;
	vector<int> z;
	forn(i, n) {
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			g[i].resize(k);
			forn(j, k) {
				cin >> g[i][j];
				g[i][j]--;
			}
		}
		else {
			int m;
			cin >> m;
			u[i].resize(m);
			forn(j, m) {
				cin >> u[i][j];
				z.push_back(u[i][j]);
			}
		}
	}
	sort(all(z));
	forn(i, n) {
		if (u[i].size()) {
			for (auto j : u[i]) {
				dp[i].push_back(make_pair(j, j));
			}
		}
	}
	dfs();
	cout << (dp[0].size() ? "Yes\n" : "No\n");
	return 0;
}