#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

const int N = 2e5 + 5;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

int n, m;
int t[N];

vii bad[N]; //all cards where i letter is bad
bool used[N];
set<int> can_be_used;
set<int> bad_pos[N]; // bad positions in card

vector<pii> pos[N];

bitset<N> close;

int main() {
    vii take;

    optimize();
    string s;
    cin >> n >> m >> s;
    for (int i = 0; i < m; ++i) t[i] = s[i] - 'a';

    for (int i = 0; i < n; ++i) {
        int k; cin >> k; int score = 0;
        for (int j = 0; j < k; ++j) {
            int a; char c; cin >> a >> c; --a;
            pos[i].emplace_back(a, c - 'a');
            if (s[a] != c) {
                ++score;
                bad_pos[i].insert(a);
                bad[a].push_back(i);
            }
        }
        if (score == 0) can_be_used.insert(i);
    }

    while (!can_be_used.empty()) {
        int num = *can_be_used.begin(); can_be_used.erase(can_be_used.begin());
        used[num] = 1; take.push_back(num + 1);
        for (auto p : pos[num]) {
            if (close[p.first]) continue;
            if (t[p.first] != p.second) exit(-1);
            while (!bad[p.first].empty()) {
                int n1 = bad[p.first].back(); bad[p.first].pop_back();
                bad_pos[n1].erase(p.first);
                if (bad_pos[n1].empty() && !used[n1] && !can_be_used.count(n1)) {
                    can_be_used.insert(n1);
                }
            }
            close[p.first] = 1;
        }
    }

    bool f = 1;
    for (int i = 0; i < m; ++i) if (!close[i]) f = 0;

    if (!f) {
        cout << -1 << '\n';
    }
    else {
        for (int i : take) cout << i << " ";
        for (int i = 0; i < n; ++i) if (!used[i]) cout << i + 1 << " ";
        cout << '\n';
    }

    return 0;
}
