#include<iostream>
#include<vector>
#include<string>
#include<algorithm>

using namespace std;

#define fastio ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define nint signed
#define ll long long
#define FORN(i, a, b) for (int i = a; i < b; ++i)
#define veci vector<int>
#define pb push_back
#define all(v) v.begin(), v.end()
#define PAI pair<int, int>
#define MAXN 100000

veci g[MAXN];
veci kons[MAXN];

int rec(int mi, int v) {
	if (g[v].size() == 1) {
		if (mi > kons[v].back()) return -1;
		int val = *lower_bound(all(kons[v]), mi);
		return val;
	}
	veci p;
	int K = g[v].size();
	veci dp((1 << K), 1e9);
	dp[0] = 0;
	FORN(mask, 1, (1 << K)) {
		veci pos;
		int mask1 = mask, cnt = 0;
		while (mask1 > 0) {
			if (mask1 % 2 == 0) {
				mask1 /= 2; ++cnt; continue;
			}
			pos.pb(cnt);
			mask1 /= 2;
			++cnt;
		}
		for (int cur : pos) {
			int newmask = (mask ^ (1 << cur));
			int add = rec(dp[newmask], g[v][cur]);
			if (add == -1) {
				continue;
			}
			dp[mask] = min(dp[mask], add);
		}
	}
	if (dp[(1 << K) - 1] == 1e9) {
		return -1;
	}
	return dp[(1 << K) - 1];
}

nint main() {
	fastio;
	int n; cin >> n;
	FORN(i, 0, n) {
		int t; cin >> t;
		if (t == 1) {
			int k; cin >> k;
			FORN(j, 0, k) {
				int soon; cin >> soon; --soon;
				g[i].pb(soon);
			}
		}
		else {
			int m; cin >> m;
			veci ev(m); FORN(i, 0, m) {
				cin >> ev[i];
			}
			sort(all(ev));
			kons[i] = ev;
		}
	}
	int fl = rec(-1, 0);
	if (fl == -1) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n";
	}
}