#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
//#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int n, k, m;
int p = 3;

bool make_move(vvi& a, int msg, int n) {
	for (int x = n - 1; x >= 0; --x) {
		for (int y = n - 1; y >= 0; --y) {
			if (a[x][y])
				continue;
			if ((x + y) % (1 << p) == msg) {
				cout << x + 1 << ' ' << y + 1 << endl;
				for (int i = x; i < n; ++i) {
					for (int j = y; j < n; ++j)
						a[i][j] = 1;
				}
				return x == 0 && y == 0;
			}
		}
	}
	cout << "1 1" << endl;
	return 1;
}

void solve1() {
	string s;
	cin >> s;
	vi msg;
	for (int i = 0; i < (m + p - 1) / p; ++i) {
		int x = 0;
		for (int j = 0; j < p; ++j) {
			x *= 2;
			if (i * p + j < m && s[i * p + j] == '1')
				x += 1;
		}
		msg.pb(x);
	}
	int cur = 0;
	for (int it = 0;; ++it) {
		if (cur == msg.size()) {
			cout << 0 << endl;
			break;
		}
		vvi a(n, vi(n));
		if (it % 2) {
			int x, y;
			cin >> x >> y;
			--x; --y;
			for (int i = x; i < n; ++i) {
				for (int j = y; j < n; ++j)
					a[i][j] = 1;
			}
		}
		while (true) {
			bool flag;
			if (cur == msg.size()) {
				cout << "1 1" << endl;
				flag = 1;
			}
			else {
				flag = make_move(a, msg[cur], n);
				if (!flag)
					++cur;
			}
			if (flag)
				break;
			int x, y;
			cin >> x >> y;
			--x; --y;
			if (!x && !y)
				break;
			for (int i = x; i < n; ++i) {
				for (int j = y; j < n; ++j)
					a[i][j] = 1;
			}
		}
	}
	return;
}

void solve2() {
	int g;
	cin >> g;
	string ans;
	for (int it = 0; it < g; ++it) {
		for (int i = 0;; ++i) {
			int x, y;
			cin >> x >> y;
			--x; --y;
			if (!x && !y)
				break;
			if (i % 2 != it % 2)
				continue;
			int msg = (x + y) % (1 << p);
			string s;
			for (int j = 0; j < p; ++j) {
				if (msg % 2)
					s += '1';
				else
					s += '0';
				msg /= 2;
			}
			reverse(s.begin(), s.end());
			ans += s;
		}
	}
	cout << ans << endl;
	return;
}

signed main() {
//#ifdef LOCAL
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
//#endif

	int t;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1)
		solve1();
	else
		solve2();

	return 0;
}