#pragma GCC optimize ("O3")
#pragma GCC optimize ("Ofast")


#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>

using namespace std;

const int N = 2e6;
const int alp = 27;
const int R = (1 << 4);
typedef long long ll;

int a[N];
int can[alp][alp];
int dp[N];
string ans[N];

string DO[2 * R];

void build()
{
	for (int q = 1; q < 2 * R; q++)
	{
		DO[q] += char('z' + 1);
	}
}

void update(int now,int pos, int tl, int tr,string s)
{
	if (tr - tl == 1)
	{
		DO[now] = s;
		return;
	}
	int m = (tl + tr) / 2;
	if (m > pos)
	{
		update(now * 2, pos, tl, m, s);
	}
	else
	{
		update(now * 2 + 1, pos, m, tr, s);
	}
	DO[now] = min(DO[now * 2 + 1], DO[now * 2]);
}

string mn(int v, int l, int r, int tl, int tr)
{
	if (tl >= l && tr <= r)
	{
		return DO[v];
	}
	if (tl >= r || tr <= l)
	{
		string q; q += char('z' + 1);
		return q;
	}
	int m = (tl + tr) / 2;
	return min(mn(v * 2, l, r, tl, m), mn(v * 2 + 1, l, r, m, tr));
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	int k, n;
	cin >> k >> n;
	char c;
	build();
	for (int q = 0; q < k; q++)
	{
		for (int w = 0; w < k; w++)
		{
			cin >> c;
			can[q][w] = c - '0';
		}
	}
	string s;
	cin >> s;
	dp[n - 1] = n;
	ans[n - 1] += s[n - 1];
	dp[n] = n;
	update(1, n, 0, R, ans[n]);
	update(1, n - 1, 0, R, ans[n - 1]);
	for (int q = n - 2; q > -1; q--)
	{
		int z = s[q] - 'a';
		if (can[z][s[q + 1] - 'a'] == 1)
		{
			dp[q] = dp[q + 1];
			for (int w = dp[q]; w < n;)
			{
				if (can[z][s[w] - 'a'] == 1)
				{
					dp[q] = dp[w];
					w = dp[w];
				}
				else
				{
					break;
				}
			}
			string best = mn(1, q + 1, dp[q] + 1, 0, R);
			string an = ""; an += s[q]; an += best;
			ans[q] = an;
		}
		else
		{
			dp[q] = q + 1;
			ans[q] += s[q];
			ans[q] += ans[q + 1];
		}
		update(1, q, 0, R, ans[q]);
	}
	for (int q = 0; q < ans[0].size(); q++)
	{
		cout << ans[0][q];
	}
}