#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

bool operator>(string& a, string& b) {
	for (int i = 0; i < min(a.size(), b.size()); i++) {
		if (a[i] > b[i]) return true;
		else if (a[i] < b[i]) return false;
	}
	return a.size() > b.size();
}

int main() {
	int k, n;
	cin >> k >> n;
	vector<vector<int>> can_del(k, vector<int>(k));
	for (auto& line : can_del) {
		string s;
		cin >> s;
		for (int i = 0; i < k; i++) line[i] = s[i] - '0';
	}
	string s;
	cin >> s;
	vector<string> best(n);
	vector<string> all_del(n);
	best[n - 1] = s[n - 1];
	all_del[n - 1] = s[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		// calc all_del
		string copy = all_del[i + 1];
		while (!copy.empty() && can_del[s[i] - 'a'][copy[0] - 'a']) copy.erase(copy.begin());
		copy = s[i] + copy;
		all_del[i] = copy;
		// calc best
		string may_be = best[i + 1];
		while (may_be.size() > 1 && can_del[s[i] - 'a'][may_be[0] - 'a'] && may_be[0] > may_be[1])  may_be.erase(may_be.begin());
		may_be = s[i] + may_be;
		if (may_be > copy) best[i] = copy;
		else best[i] = may_be;
	}

	cout << best[0] << endl;
}