#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<vector<pair<int, char> > > a(n);
	vector<bool> there(m, false);
	vector<vector<int> > where(m);
	vector<set<int> > bad(n);
	for(int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		for(int j = 0; j < k; j++)
		{
			int b;
			char c;
			cin >> b >> c;
			--b;
			a[i].push_back({b, c});
			there[b] = true;
			if(s[b] != c)
			{
				bad[i].insert(b);
				where[b].push_back(i);
			}
		}
	}
	for(int i = 0; i < m; i++)
	{
		if(!there[i])
		{
			cout << -1;
			return 0;
		}
	}
	vector<int> res;
	vector<int> good;
	for(int i = 0; i < n; i++)
	{
		if(bad[i].empty())
		{
			good.push_back(i);
		}
	}
	for(int o = 0; o < n; o++)
	{
		if(good.empty())
		{
			cout << -1;
			return 0;
		}
		int now = good[good.size() - 1];
		good.pop_back();
		res.push_back(now);
		for(int i = 0; i < a[now].size(); i++)
		{
			int id1 = a[now][i].first;
			while(!where[id1].empty())
			{
				int here = where[id1][where[id1].size() - 1];
				bad[here].erase(bad[here].find(id1));
				if(bad[here].empty())
				{
					good.push_back(here);
				}
				where[id1].pop_back();
			}
		}
	}
	for(int i = 0; i < n; i++)
	{
		cout << res[i] + 1 << ' ';
	}
}