#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define P 268069
#define MOD 1791791791
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
int k, n;
vector<vector<bool> > can;
vector<int> a;
 
 
vector<int> get_hash(vector<int> a)
{
    int n = a.size();
    vector<int> h(n + 1);
    h[0] = 0;
    for(int i = 1; i <= n; i++)
    {
        h[i] = ((ll)h[i - 1] * P + a[i - 1]) % MOD;
    }
    return h;
}
 
bool lower_or_eq(vector<int> & h1, vector<int> & a1, vector<int> & h2, vector<int> & a2)
{
    int n = a1.size();
    int m = a2.size();
    int l = 0;
    int r = min(n, m) + 1;
    while(r - l > 1)
    {
        int mid = (l + r) / 2;
        if(h1[mid] == h2[mid])
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
    }
    if(l == min(n, m))
    {
        return a1.size() <= a2.size();
    }
    return a1[l] < a2[l];
}
 
ostream & operator<<(ostream & out, vector<int> a)
{
    for(int i = 0; i < a.size(); i++)
    {
        out << (char)(a[i] + 'a');
    }
    return out;
}
 
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _FILE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    cin >> k >> n;
    can.assign(k, vector<bool>(k));
    for(int i = 0; i < k; i++)
    {
        for(int j = 0; j < k; j++)
        {
            char c;
            cin >> c;
            if(c == '1')
            {
                can[i][j] = true;
            }
            else
            {
                can[i][j] = false;
            }
        }
    }
    a.resize(n);
    for(int i = 0; i < n; i++)
    {
        char c;
        cin >> c;
        a[i] = (c - 'a');
    }
    if(k == 1)
    {
    	if(can[0][0])
    	{
    		cout << "a";
    		return 0;
    	}
    	for(int i = 0; i < n; i++)
    	{
    		cout << 'a';
    	}
    	return 0;
    }
    if(k == 2)
    {
    	//cout << n << endl;
    	if(can[1][1])
    	{
    		vector<int> a1;
    		a1.push_back(a[0]);
    		for(int i = 1; i < n; i++)
    		{
    			if(a[i] == 1 && a[i - 1] == 1)
    			{
    				continue;
    			}
    			a1.push_back(a[i]);
    		}
    		a = a1;
    		n = a1.size();
    		//cout << n << endl;
    	}
    	if(can[0][1])
    	{
    		vector<int> a1;
    		bool there0 = false;
    		for(int i = 0; i < n; i++)
    		{
    			if(a[i] == 0)
    			{
    				there0 = true;
    				a1.push_back(0);
    				continue;
    			}
    			if(there0)
    			{
    				continue;
    			}
    			a1.push_back(a[i]);
    		}
    		a = a1;
    		n = a1.size();
    		//cout << n << endl;
    	}
    	if(can[1][0] && can[0][1])
    	{
    		vector<int> a1;
    		a1.push_back(a[0]);
    		for(int i = 1; i < n; i++)
    		{
    			if(a[i] != a1[a1.size() - 1])
    			{
    				break;
    			}
    			a1.push_back(a[i]);
    		}
    		a = a1;
    		n = a.size();
    	}
    	if(can[1][0])
    	{
    		for(int i = n - 1; i >= 0; i--)
    		{
    			if(a[i] == 1)
    			{
    				for(int j = 0; j < n - i - 1; j++)
    				{
    					a.pop_back();
    				}
    				break;
    			}
    		}
    		n = a.size();
    		//cout << n << endl;
    	}
    	if(can[1][0] && can[1][1])
    	{
    		vector<int> a1;
    		int fir1 = -1;
    		for(int i = 0; i < n; i++)
    		{
    			if(a[i] == 1)
    			{
    				fir1 = i;
    				break;
    			}
    		}
    		if(fir1 != -1)
    		{
    			for(int i = 0; i <= fir1; i++)
    			{
    				a1.push_back(a[i]);
    			}
    			a = a1;
    		}
    		n = a.size();
    		//cout << n << endl;
    	}
    	if(can[0][0])
    	{
    		for(int i = n - 1; i >= 0; i--)
    		{
    			if(a[i] == 1)
    			{
    				break;
    			}
    			if(a[i] == 0 && (i == 0 || a[i - 1] == 1))
    			{
    				//cout << i << ' ' << n << ' ' << a.size() << endl;
    				for(int j = 0; j < n - i - 1; j++)
    				{
    					a.pop_back();
    					//cout << a.size() << endl;
    				}
    				break;
    			}
    		}
    		//cout << a.size() << endl;
    		n = a.size();
    		//cout << n << endl;
    	}
    	if(can[1][1])
    	{
    		vector<int> a1;
    		a1.push_back(a[0]);
    		for(int i = 1; i < n; i++)
    		{
    			if(a[i] == 1 && a[i - 1] == 1)
    			{
    				continue;
    			}
    			a1.push_back(a[i]);
    		}
    		a = a1;
    		n = a1.size();
    		//cout << n << endl;
    	}
    	if(can[0][1])
    	{
    		vector<int> a1;
    		bool there0 = false;
    		for(int i = 0; i < n; i++)
    		{
    			if(a[i] == 0)
    			{
    				there0 = true;
    				a1.push_back(0);
    				continue;
    			}
    			if(there0)
    			{
    				continue;
    			}
    			a1.push_back(a[i]);
    		}
    		a = a1;
    		n = a1.size();
    		//cout << n << endl;
    	}
    	if(can[1][0])
    	{
    		for(int i = n - 1; i >= 0; i--)
    		{
    			if(a[i] == 1)
    			{
    				for(int j = 0; j < n - i - 1; j++)
    				{
    					a.pop_back();
    				}
    				break;
    			}
    		}
    		n = a.size();
    		//cout << n << endl;
    	}
    	if(can[0][0])
    	{
    		for(int i = n - 1; i >= 0; i--)
    		{
    			if(a[i] == 1)
    			{
    				break;
    			}
    			if(a[i] == 0 && (i == 0 || a[i - 1] == 1))
    			{
    				//cout << i << ' ' << n << ' ' << a.size() << endl;
    				for(int j = 0; j < n - i - 1; j++)
    				{
    					a.pop_back();
    					//cout << a.size() << endl;
    				}
    				break;
    			}
    		}
    		//cout << a.size() << endl;
    		n = a.size();
    		//cout << n << endl;
    	}
    	for(int i = 0; i < n; i++)
    	{
    		cout << (char)(a[i] + 'a');
    	}
    	return 0;
    }
    vector<int> right(n);
    vector<int> next(n);
    for(int i = 0; i < n; i++)
    {
        next[i] = i + 1;
    }
    for(int i = n - 1; i >= 0; i--)
    {
        while(next[i] != n && can[a[i]][a[next[i]]])
        {
            next[i] = next[next[i]];
        }
        right[i] = next[i];
    }
    /*for(int i = 0; i < n; i++)
    {
        cout << right[i] << ' ';
    }
    cout << endl;*/
    vector<vector<int> > s(n);
    vector<vector<int> > h(n);
    vector<int> st;
    st.push_back(-(n - 1));
    s[n - 1] = {a[n - 1]};
    h[n - 1] = get_hash(s[n - 1]);
    for(int i = n - 2; i >= 0; i--)
    {
        vector<int> here;
        if(right[i] == n)
        {
            s[i] = {a[i]};
            h[i] = get_hash(s[i]);
            //cout << i << " end ";
        }
        else
        {
            int id1 = lower_bound(st.begin(), st.end(), -(right[i])) - st.begin();
            here = {a[i]};
            for(int j = 0; j < s[-(st[id1])].size(); j++)
            {
                here.push_back(s[-(st[id1])][j]);
            }
            //cout << i << ' ' << -(st[id1]) << ' ';
            s[i] = here;
            h[i] = get_hash(here);
        }
        //cout << s[i] << endl;
        while(!st.empty() && lower_or_eq(h[i], s[i],
                h[-st[st.size() - 1]], s[-st[st.size() - 1]]))
        {
            //cout << "deleted: " << -st[st.size() - 1] << endl;
            st.pop_back();
        }
        st.push_back(-i);
    }
    for(int i = 0; i < s[0].size(); i++)
    {
        cout << (char)(s[0][i] + 'a');
    }
}