#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> matr(k, vector<bool> (k, false));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            matr[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    s += 'a';
    n = s.size();
    string res;
    int ptr = 0;
    vector<vector<bool>> can(n, vector<bool> (n, true));
    for (int len = 3; len <= n; ++len) {
        for (int i = 0; i + len - 1 < n; ++i) {
            int j = i + len - 1;
            can[i][j] = false;
            for (int l = i + 1; l < j; ++l) {
                if (matr[s[i] - 'a'][s[l] - 'a'] && can[i][l] && can[l][j]) {
                    can[i][j] = true;
                    break;
                }
            }
        }
    }
    vector<vector<pair<int, char>>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (can[i][j]) {
                g[i].push_back({ j, s[j] });
            }
        }
    }
    vector<bool> fin(n, false);
    for (int i = 0; i < n; ++i) {
       if (can[i][n - 1]) {
           fin[i] = true;
       }
    }
    string t;
    for (int i = 0; i < n; ++i) {
        t += 'z';
    }
    vector<string> dist(n, t);
    vector<bool> used(n, false);
    dist[0] = s[0];
    for (int i = 1; i < n - 1; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            if (can[j][i]) {
                string curr = dist[j];
                curr += s[i];
                if (curr < dist[i]) {
                    dist[i] = curr;
                }
            }
        }
    }
   res = dist[n - 2];
    for (int i = 0; i < n - 1; ++i) {
        if (fin[i] && res > dist[i]) {
            res = dist[i];
        }
    }
    cout << res;
}
/*
3 7
010
001
100
abacaba

 3 5
010
001
100
bcacb
 */