#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using pii = pair<int, int>;

const int INF = 1e9 + 13;

int n, m, k;

int get(vector<vector<bool>> b, int x, int y) {
    int res = 0;

    for(int x1 = x; x1 < n; x1++)
        for(int y1 = y; y1 < n; y1++)
            res += !b[x1][y1];
    return res;
}

void col(vector<vector<bool>>& b, int x, int y) {
    for(int x1 = x; x1 < n; x1++)
        for(int y1 = y; y1 < n; y1++)
            b[x1][y1] = true;
}

namespace t1 {
    void solve() {

        cin >> n >> k >> m;

        string s;
        cin >> s;

        s += '2';

        int i = 0;
        int num = 0;
        while(i < m) {
            vector<vector<bool>> b(n, vector<bool>(n, false));
            if(num % 2 == 1) {
                int x, y;
                cin >> x >> y;

                x--;
                y--;

                col(b, x, y);
            }

            while(true) {
                int mn = INF;
                int x1, y1;
                for(int x = 0; x < n; x++) {
                    for(int y = 0; y < n; y++) if(x + y > 0) {
                        int cnt = get(b, x, y);
                        if(cnt % 2 == s[i] - '0' && mn < cnt) {
                            mn = cnt;
                            x1 = x;
                            y1 = y;
                        }
                    }
                }

                if(mn == INF) {
                    cout << 1 << ' ' << 1 << endl;
                    break;
                }

                cout << x1 + 1 << ' ' << y1 + 1 << endl;
                col(b, x1, y1);

                int x, y;
                cin >> x >> y;

                x--;
                y--;

                col(b, x, y);

                if(x + y == 0)
                    break;
            }


            num++;

            if(i == n)
                break;
        }

        cout << 0 << endl;
    }
}

namespace t2 {
    void solve() {
        cin >> n >> k >> m;

        int t;
        cin >> t;

        string res = "";

        int num = 0;
        while(t--) {
            vector<vector<bool>> b(n, vector<bool>(n, false));
            if(num % 2 == 1) {
                int x, y;
                cin >> x >> y;

                x--;
                y--;

                col(b, x, y);
            }

            while(true) {
                int x, y;
                cin >> x >> y;

                x--;
                y--;

                if(x + y == 0) {
                    break;
                }

                res += char('0' + get(b, x, y));
                col(b, x, y);

                cin >> x >> y;

                x--;
                y--;

                if(x + y == 0) {
                    break;
                }

                col(b, x, y);
            }


            num++;
        }

        cout << res << endl;
    }
}

int main() {
    int t;
    cin >> t;

    if(t == 1)
        t1::solve();
    else
        t2::solve();
}
