class game:
    def __init__(self, n):
        self.field = [[0] * n for _ in range(n)]
        self.n = n
        self.rest = n * n

    def make_move(self, x, y):
        x, y = x - 1, y - 1
        for i in range(x, self.n):
            if self.field[i][y] == 1:
                break
            for j in range(y, self.n):
                if self.field[i][j] == 1:
                    break
                self.field[i][j] = 1
                self.rest -= 1

    def count(self, x, y):
        res = 0
        for i in range(x, self.n):
            if self.field[i][y] == 1:
                break
            for j in range(y, self.n):
                if self.field[i][j] == 1:
                    break
                res += 1
        return res

    def gms2(self):
        res = []
        for x in reversed(range(self.n)):
            for y in reversed(range(self.n)):
                cr = self.count(x, y)
                if cr > 2:
                    break
                if cr > 0:
                    res.append((x + 1, y + 1))
        return res

    def autowin(self):
        pass


def encrypt(s, n, k, m):
    fm = 1
    loses = 0
    while s > 0:
        gm = game(n)
        mv = fm
        while gm.rest > 0:
            if mv:
                mvs = gm.gms2()
                kr = len(mvs)
                if kr == 1:
                    gm.make_move(*mvs[0])
                    print(*mvs[0])
                else:
                    move = mvs[s % kr]
                    s //= kr
                    gm.make_move(*move)
                    print(*move)
            else:
                x, y = map(int, input().split())
                gm.make_move(x, y)
            mv = 1 - mv
        if mv == 0:
            loses += 1
        fm = 1 - fm
    print(0)

def decrypt(gn, n, k, m):
    fm = 1
    s = 0
    denom = 1
    for _ in range(gn):
        gm = game(n)
        mv = fm
        while gm.rest > 0:
            if mv:
                mvs = gm.gms2()
                kr = len(mvs)
                if kr == 1:
                    gm.make_move(*mvs[0])
                    input()
                else:
                    move = tuple(map(int, input().split()))
                    s += mvs.index(move) * denom
                    denom *= kr
                    gm.make_move(*move)
            else:
                x, y = map(int, input().split())
                gm.make_move(x, y)
            mv = 1 - mv
        fm = 1 - fm
    res = ''
    for _ in range(m):
        res += str(s % 2)
        s //= 2
    print(res, sep='')

mode = int(input())
n, k, m = map(int, input().split())
if mode == 1:
    s = int(input()[::-1], base=2)
    encrypt(s, n, k, m)
else:
    gn = int(input())
    decrypt(gn, n, k, m)
