#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
#define int long long

int n;

vector <int> g[100010];
vector <int> a[100010];

int ch[100010];
int mini[100010];
int maxi[100010];

vector <int> ans[100010];

bool dfs(int i)
{
	if (g[i].empty())
	{
		mini[i] = ch[i];
		maxi[i] = ch[i];
		ans[i] = { ch[i] };
		return true;
	}

	vector <pair <pair <int, int>, int>> a;
	mini[i] = 1e9;
	maxi[i] = 0;
	for (auto v : g[i])
	{
		if (!dfs(v)) return false;

		a.push_back({ {mini[v], maxi[v]}, v });
		mini[i] = min(mini[i], mini[v]);
		maxi[i] = max(maxi[i], maxi[v]);
	}

	sort(a.begin(), a.end());
	for (int i = 0; i < a.size() - 1; ++i)
	{
		if (a[i].first.second > a[i + 1].first.first) return false;
	}

	ans[i].clear();

	for (auto j : a) ans[i].push_back(j.second);
	
	return true;
}

void rec(int i)
{
	if (i == n + 1)
	{
		auto got = dfs(1);

		if (!got) return;

		cout << "Yes\n";
		for (int i = 1; i <= n; ++i)
		{
			for (auto j : ans[i]) cout << j << ' ';
			cout << '\n';
		}

		exit(0);
	}

	if (g[i].empty())
	{
		for (auto j : a[i])
		{
			ch[i] = j;
			rec(i + 1);
		}
	}
	else
	{
		rec(i + 1);
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int k;
			cin >> k;

			for (int j = 0; j < k; ++j)
			{
				int v;
				cin >> v;
				g[i].push_back(v);
			}
		}
		else
		{
			int k;
			cin >> k;

			for (int j = 0; j < k; ++j)
			{
				int v;
				cin >> v;
				a[i].push_back(v);
			}
		}
	}

	rec(1);
	cout << "No\n";
	return 0;
}