#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define pb push_back
#define sz(a) ((int)a.size())
#define pi pair<int, int>
#define vpi vector<pair<int, int>>

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 100;

vi g[MAXN], topsort;
char used[MAXN];

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    topsort.pb(v);
}

inline void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<char>> a(n, vector<char>(m, -1));
    forn (i, n) {
        int k;
        cin >> k;
        forn (j, k) {
            int pos;
            char c;
            cin >> pos >> c;
            pos--;
            a[i][pos] = c;
        }
    }
    forn (k, m) {
        forn (i, n) {
            if (a[i][k] != s[k]) {
                continue;
            }
            for (int j = 0; j < n; j++) {
                if (a[j][k] != -1 && a[j][k] != s[i]) {
                    g[i].pb(j);
                }
            }
        }
    }
    forn (i, n) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(all(topsort));
    map<int, int> pos;
    forn (i, n) {
        pos[topsort[i]] = i;
    }
    forn (k, m) {
        forn (i, n) {
            if (a[i][k] != s[k]) {
                continue;
            }
            for (int j = 0; j < n; j++) {
                if (a[j][k] != -1 && a[j][k] != s[i]) {
                    if (pos[i] > pos[j]) {
                        cout << -1;
                        exit(0);
                    }
                }
            }
        }
    }
    for (auto cc : topsort) {
        cout << cc + 1 << ' ';
    }
}

signed main() {
    IO();
    int t = 1;
    while (t--) {
        Solve();
    }
    return 0;
}