#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define pb push_back
#define sz(a) ((int)a.size())

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 100;

struct Node {
    int pos;
    Node *prv;
    Node *nxt;
};

int n, k;
vector<string> v;
string s;
vi g[MAXN], topsort;
char used[MAXN];

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    topsort.pb(v);
}

bool canDel(int l, int r) {
    for (int i = l; i <= r; i++) {
        g[i].clear();
    }
    fill(used + l, used + (r + 1), 0);
    topsort.clear();
    for (int i = l; i <= r; i++) {
        for (int j = i + 1; j <= r; j++) {
            if (v[s[i] - 'a'][s[j] - 'a'] == '1') {
                g[l].pb(r);
            }
        }
    }
    for (int i = r; i >= l; i--) {
        if (!used[i]) {
            dfs(i);
        }
    }
    vector<Node *> nodes(r - l + 1);
    nodes[0] = new Node();
    nodes[0]->pos = 0;
    for (int i = l + 1; i <= r; i++) {
        nodes[i - l] = new Node();
        nodes[i - l]->prv = nodes[i - l - 1];
        nodes[i - l - 1]->nxt = nodes[i - l];
        nodes[i - l]->pos = i - l;
    }
    while (sz(topsort) > 1) {
        bool f = 0;
        forn (i, sz(topsort) - 1) {
//            int qq = nodes[topsort[i] - l]->prv->pos;
//            int ww = nodes[topsort[i] - l]->pos;
//            auto ee = s[nodes[topsort[i] - l]->prv->pos] - 'a';
//            auto rr = s[nodes[topsort[i] - l]->pos] - 'a';
            if (v[s[nodes[topsort[i] - l]->prv->pos + l] - 'a'][s[nodes[topsort[i] - l]->pos + l] - 'a'] == '1') {
                nodes[topsort[i] - l]->prv->nxt = nodes[topsort[i] - l]->nxt;
                if (nodes[topsort[i] - l]->nxt != nullptr) {
                    nodes[topsort[i] - l]->nxt->prv = nodes[topsort[i] - l]->prv;
                }
                topsort.erase(topsort.begin() + i);
                f = 1;
                break;
            }
        }
        if (!f) {
            break;
        }
    }
    return sz(topsort) == 1;
}

inline void Solve() {
    cin >> k >> n;
    v.resize(k);
    forn (i, k) {
        cin >> v[i];
    }
    cin >> s;
    int maxMask = 1 << n;
    string ans;
    ans += 'z' + 1;
    int qq = canDel(0, 1);
    for (int mask = 0; mask < maxMask; mask++) {
        if (mask & 1) {
            continue;
        }
        int fir = -1;
        bool f = 1;
        string ss;
        forn (i, n) {
            if (mask & (1 << i)) {
                if (fir == -1) {
                    fir = i;
                }
            } else {
                ss += s[i];
                if (fir > -1) {
                    if (!canDel(fir - 1, i - 1)) {
                        f = 0;
                        break;
                    }
                    fir = -1;
                }
            }
        }
        if (fir > -1) {
            if (!canDel(fir - 1, n - 1)) {
                f = 0;
            }
        }
        if (f) {
            minq(ans, ss);
        }
    }
    cout << ans;
}

signed main() {
    IO();
    int t = 1;
    while (t--) {
        Solve();
    }
    return 0;
}