#include <bits/stdc++.h>

#define X first
#define Y second
#define int long long

const int INF = 1e9;

const int bits = 1;

using namespace std;

void encode() {
    int n, k, m;
    cin >> n >> k >> m;
    string message;
    cin >> message;

    int i = 0;
    int game = 0;

    while (true) {
        vector<vector<bool>> used(n, vector<bool>(n));

        if (game & 1) {
            int besti, bestj;
            cin >> besti >> bestj;
            --besti, --bestj;
            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;
        }

        if (i == message.size()) {
            cout << "0";
            exit(0);
        }
        while (true) {
            int besti = 0, bestj = 0, bestsq = INF;
            for (int x = n - 1; x >= 0; --x) {
                for (int y = n - 1; y >= 0; --y) {
                    if (used[x][y])
                        continue;
                    if (i >= message.size() || message[i] - '0' != (x & 1))
                        continue;
                    if (i + 1 < message.size() && message[i + 1] - '0' != (y & 1))
                        continue;

                    int sq = 0;
                    for (int xx = x; xx < n; ++xx){
                        for (int yy = y; yy < n; ++yy){
                            if (!used[xx][yy])
                                ++sq;
                        }
                    }
                    if (x != 0 && y != 0 && sq < bestsq) {
                        besti = x;
                        bestj = y;
                        bestsq = sq;
                    }
                }
            }

            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;


            cout << besti + 1 << " " << bestj + 1 << endl;

            if (besti == 0 && bestj == 0)
                break;

            if (i < message.size() && message[i] - '0' == (besti & 1))
                ++i;
            if (i < message.size() && message[i] - '0' == (bestj & 1))
                ++i;

            cin >> besti >> bestj;
            --besti, --bestj;

            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;
            if (besti == 0 && bestj == 0)
                break;
        }
        ++game;
    }
}

void decode() {
    int n, k, m;
    cin >> n >> k >> m;
    vector<int> message(m);

    int t;
    cin >> t;

    int i = 0;
    int game = 0;

    while (t--) {
        ++game;

        if (game % 2 == 0) {
            int x, y;
            cin >> x >> y;
            --x, --y;
        }

        while (true) {
            int mi, mj;
            cin >> mi >> mj;
            --mi, --mj;

            if (mi == 0 && mj == 0)
                break;

            if (i < message.size())
                message[i++] = mi & 1;
            if (i < message.size())
                message[i++] = mj & 1;


            cin >> mi >> mj;
            --mi, --mj;
            if (mi == 0 && mj == 0)
                break;
        }

    }

    for (int d : message)
        cout << d;
}

void solve() {
    int t;
    cin >> t;
    if (t == 1)
        encode();
    else
        decode();
}

signed main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    //freopen("C:\\work\\temp\\clion\\log.txt", "r", stdin);
    solve();
    return 0;
}