#include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

string to_string(const char* a) {
    return (string) a;
}

string to_string(string a) {
    return a;
}

string to_string(bool a) {
    return (a ? "true" : "false");
}

void debug_out() {
    cerr << endl;
}

string to_string(const vector<int> &a) {
    string res = "";
    bool first = 1;
    for (auto &i : a) {
        if (!first) {
            res += ", ";
        }
        first = 0;
        res += to_string(i);
    }
    return res;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << ' ' << to_string(H);
    debug_out(T...);
}

//#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
//#else
//#define debug(...) 42

#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()

const int N = 2e5 + 5;

//vector<vector<int>> g(N);
//vector<int> order;
map<pair<int, int>, bool> mp;

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;
//    vector<vector<int>> can(m);
    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            char y;
            cin >> x >> y;
            --x;
            if (s[x] == y) {
                mp[{i, x}] = 1;
//                can[x].pb(i);
            } else {
                mp[{i, x}] = 0;
            }
        }
    }
    vector<bool> post(m);
    vector<int> viv;
    for (int c = 0; c < n; c++) {
        int best = -1;
        int best_res = -1;
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            bool cond = !used[i];
            for (int j = 0; j < m; j++) {
                cond &= (post[j]) || (mp.find(make_pair(i, j)) == mp.end()) || (mp[{i, j}]);
                if (mp.find(make_pair(i, j)) != mp.end()) {
                    cnt += mp[{i, j}];
                }
            }
            if (cond && cnt > best_res) {
                best_res = cnt;
                best = i;
            }
        }
        if (best == -1) {
            cout << -1;
            return;
        } else {
            used[best] = 1;
            for (int j = 0; j < m; j++) {
                if (mp[{best, j}]) {
                    post[j] = 1;
                }
            }
        }
        viv.pb(best);
    }
    for (auto &i : viv) {
        cout << i + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
//    cin >> T;

    while (T-- > 0) {
        solve();
    }
    return 0;
}
