#include <bits/stdc++.h>
#define x first
#define y second
#define int long long

using namespace std;

int k, n;

const int p1 = 239;
const int mod1 = 1000000007;

const int p2 = 41;
const int mod2 = 1000000009;

struct sstring{
    char * a;
    int * h1;
    int * h2;
    sstring(){}
    sstring(string s, char c){
        a = new char[n];
        a[0] = c;
        for(int i = 0; i<s.length(); i++)
            a[i+1] = s[i];
        for(int i = s.length(); i<n-1; i++)
            a[i+1] = '$';
        calc_hash();
    }
    sstring(sstring s, char c){
        a = new char[n];
        a[0] = c;
        for(int i = 1; i<n; i++)
            a[i] = s.a[i-1];
        calc_hash();
    }
    sstring(string s){
        a = new char[n];
        for(int i = 0; i<s.length(); i++)
            a[i] = s[i];
        for(int i = s.length(); i<n; i++)
            a[i] = '$';
        calc_hash();
    }
    void calc_hash(){
        h1 = new int[n];
        h1[0] = a[0]-'$';
        for(int i = 1; i<n; i++){
            h1[i] = (h1[i-1]*p1+(a[i]-'$'))%mod1;
        }
        h2 = new int[n];
        h2[0] = a[0]-'$';
        for(int i = 1; i<n; i++){
            h2[i] = (h2[i-1]*p2+(a[i]-'$'))%mod2;
        }
    }
    bool operator<(const sstring &b) const{
        int l = -1, r = n;
        while(r-l>1){
            int m = (r+l)/2;
            if(h1[m]==b.h1[m] && h2[m]==b.h2[m]){
                l = m;
            } else r = m;
        }
        if(r==n)
            return 0;
        return a[r]<b.a[r];
    }
    void print(){
        string res = "";
        for(int i = 0; i<n; i++){
            if(a[i]!='$')
                res+=a[i];
        }
        cout << res;
    }
};

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> k >> n;
    bool del[k][k];
    for(int i = 0; i<k; i++){
        string s1;
        cin >> s1;
        for(int j = 0; j<k; j++){
            del[i][j] = s1[j]-'0';
        }
    }
    string s;
    cin >> s;
    pair<pair<sstring, sstring>, int> dp[n];
    dp[n-1] = {{sstring(""), sstring("", s[n-1])}, n};
    for(int i = n-2; i>=0; i--){
        sstring res = dp[i+1].x.y;
        dp[i].y = i+2;
        for(int j = i+1; j<dp[i].y; j++){
            res = min(res, dp[j].x.y);
            if(del[s[i]-'a'][s[j]-'a']){
                res = min(res, dp[j].x.x);
                dp[i].y = max(dp[i].y, dp[j].y);
            }
        }
        dp[i].x.x = res;
        dp[i].x.y = sstring(res, s[i]);
    }
    dp[0].x.y.print();
    return 0;
}
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/
