#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<int>> mustBeBlocked(m);
    vector<vector<pair<int, char>>> t(n);
    vector<int> bad(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k--) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            t[i].pb({p, c});
            if (s[p] != c) {
                mustBeBlocked[p].pb(i);
                bad[i]++;
            }
        }
    }
    queue<int> order;
    string res(m, '.');
    for (int i = 0; i < n; i++) {
        if (bad[i] == 0) {
            order.push(i);
        }
    }
    vector<int> answer, used(n);
    while (!order.empty()) {
        int v = order.front();
        order.pop();
        answer.pb(v);
        used[v] = 1;
        for (auto p : t[v]) {
            if (res[p.first] == '.') {
                res[p.first] = p.second;
                for (auto u : mustBeBlocked[p.first]) {
                    bad[u]--;
                    if (bad[u] == 0) {
                        order.push(u);
                    }
                }
            }
        }
    }
    if (res != s) {
        cout << -1;
        return;
    }
    for (auto i : answer) {
        cout << i + 1 << " ";
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            cout << i + 1 << " ";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
