#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()

void solve() {
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> g(k, vector<bool>(k));
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            if (s[j] == '1') {
                g[i][j] = true;
            }
        }
    }
    vector<int> arr(n);
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        arr[i] = s[i] - 'a';
    }
    vector<vector<bool>> can(n, vector<bool>(n + 1));
    for (int i = 0; i + 1 < n; i++) {
        vector<bool> lst(k);
        lst[arr[i]] = true;
        can[i][i + 1] = true;
        vector<int> pl = {arr[i]};
        for (int j = i + 1; j < n; j++) {
            while (!pl.empty() and !g[pl.back()][arr[j]]) {
                pl.pop_back();
            }
            if (pl.empty()) {
                break;
            }
            can[i][j + 1] = true;
            pl.push_back(arr[j]);
        }
    }
    vector<vector<pair<int, int>>> go(n + 1);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (can[i][j]) {
                go[i].pb({j, arr[j]});
            }
        }
        if (can[i][n]) {
            go[i].pb({n, -1});
        }
    }
    set<int> q;
    string answer;
    answer.pb(s[0]);
    q.insert(0);
    while (!q.empty()) {
        vector<set<int>> keks(k);
        bool term = false;
        for (auto i : q) {
            for (auto p : go[i]) {
                if (p.second < 0) {
                    term = true;
                    break;
                }
                keks[p.second].insert(p.first);
            }
        }
        if (term) {
            break;
        }
        q.clear();
        for (int i = 0; i < k; i++) {
            if (!keks[i].empty()) {
                q = keks[i];
                answer.pb('a' + i);
                break;
            }
        }
        while (q.size() > 1) {
            q.erase(*q.rbegin());
        }
    }
    cout << answer;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}