#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

signed main()
{
	ll n, m; cin >> n >> m;
	string s; cin >> s;

	vector<int> have1(m, 0);
	vector<int> have_1(n, 0);
	vector<vector<int>> nomatch(m); // -1 in coloumn
	vector<vector<int>> match(n); // 1 in row
	for (int i = 0; i < n; ++i)
	{
		ll k; cin >> k;
		while (k--)
		{
			ll a; cin >> a; a--;
			char b; cin >> b;
			if (s[a] == b)
			{
				have1[a]++;
				match[i].push_back(a);
			}
			else
			{
				have_1[i]++;
				nomatch[a].push_back(i);
			}
		}
	}
	bool may = true;
	for (int j = 0; j < m; ++j)
	{
		if (have1[j] == 0)
			may = false;
	}
	if (!may)
	{
		cout << -1;
		return 0;
	}

	set<pair<int, int>> se;
	for (int i = 0; i < n; ++i)
		se.insert({ have_1[i],i });
	vector<ll> ans;
	while (!se.empty())
	{
		pair<int, int> p = *se.begin();
		if (p.first == 0)
		{
			ans.push_back(p.second + 1);
			for (auto mem : match[p.second])
			{
				for (auto num : nomatch[mem])
				{
					se.erase({ have_1[num],num });
					have_1[num]--;
					se.insert({ have_1[num],num });
				}
				nomatch[mem].clear();
			}
			se.erase(p);
		}
		else
		{
			cout << -1;
			return 0;
		}
	}

	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] << ' ';

	return 0;
}