#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
using namespace std;
int need[200 * 1000];
int taken[200 * 1000];
vector<pair<int, char>> cards[200 * 1000];
set<int> bad[200 * 1000];
vector<int> have_me[200 * 1000];
void sol1(int n, int m, string s) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < cards[i].size(); j++) {
            if (cards[i][j].second != s[cards[i][j].first]) {
                bad[i].insert(cards[i][j].first);
                have_me[cards[i][j].first].push_back(i);
            }
        }
    }

    int passed = 0;
    fill(need, need + m, 1);
    vector<int> ans;
    int already = 0;
    while (already != n) {
        vector<int> take;
        for (int i = 0; i < n; i++) {
            if (taken[i]) {
                continue;
            }
            if (bad[i].size() == 0) {
                take.push_back(i);
                taken[i] = true;
                already++;
            }
        }
        if (take.size() == 0) {
            cout << -1;
            return;
        }
        for (auto i : take) {
            ans.push_back(i + 1);
            for (int j = 0; j < cards[i].size(); j++) {
                if (need[cards[i][j].first]) {
                    need[cards[i][j].first] = 0;
                    for (auto k : have_me[cards[i][j].first]) {
                        bad[k].erase(cards[i][j].first);
                    }
                    passed++;
                }
            }
        }
        if (passed == m) {
            for (auto x : ans) {
                cout << x << ' ';
            }
            for (int i = 0; i < n; i++) {
                if (!taken[i]) {
                    cout << i + 1 << ' ';
                }
            }
            return;
        }

    }
    cout << -1;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        cards[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> cards[i][j].first >> cards[i][j].second;
            cards[i][j].first--;
        }
    }
    sol1(n, m, s);
}
