#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  int n, k, m;
  cin >> n >> k >> m;
  if (t == 1) {
    string s;
    cin >> s;
    int id = 0;
    int start_turn = 1;
    while (true) {
      if (id == m) {
        cout << 0 << endl;
        break;
      }
      vector<vector<int>> field(n, vector<int>(n, 0));
      int turn = start_turn;
      while (true) {
        if (turn) {
          vector<int> A(n);
          for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j)
              A[i] += field[i][j];
          }
          int x = 5;
          while (A[(1 << x) - 1] == n)
            --x;
          x = min(x, m - id);
          if (x == 0) {
            cout << 1 << ' ' << 1 << endl;
            break;
          }
          int val = 0;
          for (int i = 0; i < x; ++i)
            val = val * 2 + (s[id + i] - '0');
          id += x;
          cout << val + 1 << ' ' << n - A[val] << endl;
          if (val == 0 && A[val] == n - 1)
            break;
          for (int i = val; i < n; ++i) {
            for (int j = n - A[val] - 1; j < n; ++j)
              field[i][j] = 1;
          }
        } else {
          int x, y;
          cin >> x >> y;
          --x;
          --y;
          if (x == 0 && y == 0)
            break;
          for (int i = x; i < n; ++i) {
            for (int j = y; j < n; ++j)
              field[i][j] = 1;
          }
        }
        turn = 1 - turn;
      }
      start_turn = 1 - start_turn;
    }
  } else {
    int kek;
    cin >> kek;
    vector<int> ans(m);
    int id = 0;
    int start_turn = 1;
    while (kek--) {
      if (id == m)
        break;
      vector<vector<int>> field(n, vector<int>(n, 0));
      int turn = start_turn;
      while (true) {
        if (turn) {
          vector<int> A(n);
          for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j)
              A[i] += field[i][j];
          }
          int x = 5;
          while (A[(1 << x) - 1] == n)
            --x;
          x = min(x, m - id);
          if (x == 0) {
            int a, b;
            cin >> a >> b;
            break;
          }
          int a, b;
          cin >> a >> b;
          --a;
          --b;
          for (int i = a; i < n; ++i) {
            for (int j = b; j < n; ++j)
              field[i][j] = 1;
          }

          int val = a;
          for (int i = x - 1; i >= 0; --i) {
            ans[id + i] = val % 2;
            val /= 2;
          }
          id += x;
          if (a == 0 && b == 0)
            break;
        } else {
          int x, y;
          cin >> x >> y;
          --x;
          --y;
          if (x == 0 && y == 0)
            break;
          for (int i = x; i < n; ++i) {
            for (int j = y; j < n; ++j)
              field[i][j] = 1;
          }
        }
        turn = 1 - turn;
      }
      start_turn = 1 - start_turn;
    }
    for (int i = 0; i < m; ++i)
      cout << ans[i];
    cout << endl;
  }
  return 0;
}
