#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
#include <cassert>
using namespace std;
//#define int long long

bool check(int l, int r, vector <vector <int>>& able, string& s, vector <int>& maxOne) {
	auto can = [&maxOne](int l, int r) {
		return maxOne[l] >= r;
	};
	int len = r - l + 1;
	if (len == 1) {
		if (l != 0 && able[s[l - 1] - 'a'][s[l] - 'a']) {
			return 1;
		}
	}
	else {
		for (int k = max(0, l - 1); k < r; ++k) {
			bool ok = true;
			if (!able[s[k] - 'a'][s[r] - 'a']) ok = false;
			if (k < r - 1 && maxOne[k + 1] < r - 1) ok = false;
			if (ok) {
				return 1;
			}
		}
	}
	return 0;
}

void solve() {
	int k, n;
	cin >> k >> n;
	vector <vector <int>> able(k, vector <int>(k));
	for (int i = 0; i < k; ++i) {
		string tmp;
		cin >> tmp;
		for (int j = 0; j < k; ++j) {
			able[i][j] = (tmp[j] - '0');
		}
	}
	string s;
	cin >> s;
	//vector <vector <int>> can(n, vector <int>(n));
	vector <int> maxOne(n, -1);
	
	for (int l = n - 1; l >= 0; --l) {
		if (check(l, l, able, s, maxOne) == false) {
			maxOne[l] = -1;
			continue;
		}
		maxOne[l] = l;
		while (maxOne[l] + 1 < n && check(l, maxOne[l] + 1, able, s, maxOne)) {
			++maxOne[l];
		}
	}
	auto can = [&maxOne](int l, int r) {
		return maxOne[l] >= r;
	};
	vector <string> d(n);
	set <pair <string, int>> st;
	d[n - 1] = s[n - 1];
	st.insert({ d[n - 1], n - 1 });
	st.insert({ "", n });
	for (int i = n - 2; i >= 0; --i) {
		for (auto& vt : st) {
			if (vt.second == i + 1 || maxOne[i + 1] >= vt.second - 1) {
				d[i] = s[i] + vt.first;
				break;
			}
		}
		st.insert({ d[i], i });
	}
	cout << d[0];
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	while (test--) {
		solve();
	}
}