#include <iostream>
#include <string>

using namespace std;

long long mode, n, k, m, a, b, l, answer[100100], message[100100], table[40][40], need_to_paint, colored, pos;
char buffer;
//string message;

void clean_table()
{
    for (int i = 0; i <= 32; i ++)
        for (int j = 0; j <= 32; j ++)
            table[i][j] = 0;
}

long long color_table(long long a, long long b)
{
    long long count = 0;
    for (int i = 32; i >= a; i --)
        for (int j = 32; j >= b; j --)
        {
            if (table[i][j] == 0)
                count ++;
            table[i][j] = 1;
        }

    return count;
}

long long count_without_coloring(long long a, long long b)
{
    long long count = 0;
    for (int i = 32; i >= a; i --)
        for (int j = 32; j >= b; j --)
        {
            if (table[i][j] == 0)
                count ++;
        }

    return count;
}

long long get_color(long long a, long long b) {
    return table[a][b];
}

int main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    cin >> mode;
    cin >> n >> k >> m;

    if (mode == 1)
    {
        for (int i = 0; i < m; i++) {
            cin >> buffer;
            message[i] = buffer - '0';
        }
        for (long long bite_pos = 0; bite_pos < m / 100; bite_pos++)
        {
            clean_table();

            if (bite_pos % 2) {
                cin >> a >> b;
                color_table(a, b);
            }

            for (int move = 0; move < 50; move++) {
                //cout << "Ready";
                need_to_paint = message[bite_pos*100+move*2] * 2 + message[bite_pos*100+move*2 + 1] + 1;

                colored = 0;
                for (int i = 32; i >= 1; i--) {
                    for (int j = 32; j >= 1; j--) {
                        //cout << i << ' ' << j << ' ' << count_without_coloring(i, j) << endl;
                        if (count_without_coloring(i, j) == need_to_paint) {
                            color_table(i, j);
                            cout << i << ' ' << j << endl;
                            cin >> a >> b;
                            color_table(a, b);

                            colored = 1;
                        }

                        if (colored)
                            break;
                    }

                    if (colored)
                        break;
                }
            }

            //cin >> a >> b;
            //if (color_table(1, 2) == 0) {
                cout << 1 << ' ' << 2 << endl;
                cin >> a >> b;
            //}
            //if (color_table(2, 1) == 0) {
                cout << 2 << ' ' << 1 << endl;
                cin >> a >> b;
            //}
            //if (color_table(1, 1) == 0) {
            //    cout << 1 << ' ' << 1 << endl;
            //    cin >> a >> b;
            //}
        }

        cout << 0 << endl;
    }
    else
    {
        int side = 1, information, count = 0;

        cin >> l;

        pos = 0;

        for (long long game = 0; game < l; game ++)
        {
            count = 0;
            side = 1;

            clean_table();

            if (game % 2)
                side = -1;

            a = 0;
            b = 0;
            while (a != 1 or b != 1)
            {
                cin >> a >> b;
                if (side == 1)
                {
                    information = color_table(a,b) - 1;
                    if (count < 50) {

                        //cout << "Adding in pos " << pos << " game " << game << " count " << count << endl;

                        answer[pos] = information / 2;
                        answer[pos + 1] = information % 2;
                        pos += 2;

                        count ++;
                    }
                    side = -1;
                }
                else
                {
                    color_table(a,b);
                    side = 1;
                }
            }
        }

        for (long long game = 0; game < pos; game ++)
            cout << answer[game];
        cout << endl;
    }

    return 0;
}
