#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;

/*struct q {
	int l, r, i;
	int otr;
};*/
struct tree {
	int x, h, l = 0, r = 0, i;
	bool operator< (tree b) const{
		pair<bool, pair<int, int>> a1 = { (max(l, r) >= h), {l + r, i} }, b1 = { (max(b.l, b.r) >= b.h), {b.l + b.r, b.i} };
		return a1 < b1;
	}
};

ll inf = -1e18;
int sq = 707;
vector<tree>arr;
tree trash({ -1, -1, -1, -1, -1 });

/*bool comp(q& a, q& b) {
	return (a.otr < b.otr) || (a.otr == b.otr && a.r < b.r);
}

void r1(int& r, int pr) {
	while (r < pr) {
		r++;
		d.push_back(arr[r]);
	}
}
void r0(int& r, int pr) {
	while (r > pr) {
		d.pop_back();
		r--;
	}
}
void l1(int& l, int pl) {
	while (l + 1 < pl) {
		d.pop_front();
		l++;
	}
}
void l0(int& l, int pl) {
	while (l + 1 > pl) {
		d.push_front(arr[l]);
		l--;
	}
}*/

set<tree>s;

int get_ans(int l, int r) {
	while (s.size() != 0) {
		tree x = *(--s.end());
		if (max(x.l, x.r) < x.h)
			break;
		s.erase(x);
		tree left = trash, right = trash;
		auto it = s.begin();
		while (it != s.end()) {
			if ((*it).i < x.i && (left.i == -1 || (*it).i > left.i))
				left = *it;
			if ((*it).i > x.i && (right.i == -1 || (*it).i < right.i))
				right = *it;
			it++;
		}
		if (left.x != -1) {
			s.erase(left);
			left.r += x.r;
			s.insert(left);
		}
		if (right.x != -1) {
			s.erase(right);
			right.l += x.l;
			s.insert(right);
		}
	}
	return (r - l) + 1 - s.size();
}

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, Q; cin >> n >> Q;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].h;
		arr[i].i = i;
		if (i != 0) {
			arr[i].l = abs(arr[i].x - arr[i - 1].x);
			arr[i - 1].r = abs(arr[i].x - arr[i - 1].x);
		}
	}
	for (int z = 0; z < Q; z++) {
		int l, r; cin >> l >> r;
		l--; r--;
		for (int i = l; i <= r; i++)
			s.insert(arr[i]);
		int ans = get_ans(l, r);
		cout << ans << '\n';
		s.clear();
	}
	return 0;
}