#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()

const int N = 3e5 + 10;

struct edge {
	int u, v;
	edge() {}
	edge(int u_, int v_) {
		u = u_, v = v_;
	}
	int get(int from) {
		if (u == from) return v;
		return u;
	}
};

vector<edge> g[N];
int n;
int m;

int used[N];

pii dp[N];
int bad[N];

vector<vector<int>> ans;

void solve(int u, int p) {
	used[u] = 1;

	vector<int> dw;
	vector<int> up;

	for (auto i : g[u]) {
		int to = i.get(u);
		if (to == p) continue;
		if (!used[to]) {
			solve(to, u);
		}

		if (i.v == to) {
			if (dp[to].second == 1) {
				bad[to]--;
				ans.push_back({u, to, to, dp[to].first});
			} else if (dp[to].second == 0) {
				dw.push_back(to);
			} else {
				dw.push_back(to);
				bad[to]++;
			}
		} else {
			if (dp[to].second == -1) {
				bad[to]--;
				ans.push_back({dp[to].first, to, to, u});
			} else if (dp[to].second == 0) {
				up.push_back(to);
			} else {
				up.push_back(to);
				bad[to]++;
			}
		}
	}

	for (auto i : g[u]) {
		int to = i.get(u);
		if (to == p) continue;
		if (bad[to] > 0) {
			cout << "No\n";
			exit(0);
		}
	}

	if (abs((int)dw.size() - (int)up.size()) > 1) {
		cout << "No\n";
		exit(0);
	}

	while (!dw.empty() && !up.empty()) {
		ans.push_back({up.back(), u, u, dw.back()});
		up.pop_back();
		dw.pop_back();
	}

	if (dw.size() != 0) {
		dp[u].second = 1;
		dp[u].first = dw[0];
	} else if (up.size() != 0) {
		dp[u].second = -1;
		dp[u].first = up[0];
	} else {
		dp[u].second = 0;
	}
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		g[u].push_back(edge(u, v));
		g[v].push_back(edge(u, v));
	}

	for (int i = 0; i < N; i++) {
		if (!used[i]) {
			solve(i, i);
			if (dp[i].second != 0) {
				cout << "No\n";
				exit(0);
			}
		}
	}


	cout << "Yes\n";
	for (auto a : ans) {
		for (auto i : a) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}





	return 0;
}