#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define all(x) x.begin(), x.end()

int x[] = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000,
           1000000, 5000000, 10000000, 50000000, 100000000, 500000000, 1000000000,
           5000000000ll, 10000000000ll, 50000000000ll, 100000000000ll, 500000000000ll, 1000000000000ll,
           5000000000000ll};

map<int, char> byVal;

int get_by_char(char c) {
    return x[c - 'A'];
}

char get_by_val(int xv) {
    return byVal[xv];
}

const int inf = 1e17;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for (int i = 0; i < 26; ++i)byVal[x[i]] = (char) (i + 'A');

    int t;
    cin >> t;

    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<int>> dp(n, vector<int>(26, -inf));
        vector<vector<int>> p(n, vector<int>(26, -1));

        for (int i = n - 1; i >= 0; --i) {
            if (s[i] == '?') {
                for (int cur_mx = 0; cur_mx < 26; ++cur_mx) {
                    for (int last_mx = 0; last_mx <= cur_mx; ++last_mx) {
                        if (i != n - 1) {
                            if (dp[i + 1][last_mx] != -inf &&
                                dp[i][cur_mx] < dp[i + 1][last_mx] + get_by_char((char) (cur_mx + 'A'))) {
                                dp[i][cur_mx] = dp[i + 1][last_mx] + get_by_char((char) (cur_mx + 'A'));
                                p[i][cur_mx] = last_mx;
                            }
                        } else {
                            dp[i][cur_mx] = get_by_char((char) (cur_mx + 'A'));
                        }
                    }
                }
            } else {
                for (int cur_mx = s[i] - 'A'; cur_mx < 26; ++cur_mx) {
                    if (s[i] - 'A' < cur_mx) {
                        if (i != n - 1) {
                            if (dp[i + 1][cur_mx] != -inf && dp[i][cur_mx] < dp[i + 1][cur_mx] - get_by_char(s[i])) {
                                dp[i][cur_mx] = dp[i + 1][cur_mx] - get_by_char(s[i]);
                                p[i][cur_mx] = cur_mx;
                            }
                        }
                    } else {
                        for (int last_mx = 0; last_mx <= cur_mx; ++last_mx) {
                            if (i != n - 1) {
                                if (dp[i + 1][last_mx] != -inf &&
                                    dp[i][cur_mx] < dp[i + 1][last_mx] + get_by_char(s[i])) {
                                    dp[i][cur_mx] = dp[i + 1][last_mx] + get_by_char(s[i]);
                                    p[i][cur_mx] = last_mx;
                                }
                            } else {
                                dp[i][cur_mx] = get_by_char(s[i]);
                            }
                        }
                    }
                }
            }
        }

        int res = -inf;
        int buk = -1;
        for (int i = 0; i < 26; ++i) {
            if (dp[0][i] > res)buk = i;
            res = max(res, dp[0][i]);
        }
        cout << res << '\n';
        int pi = buk;
        int i = 0;
        while (i != n) {
            if (s[i] != '?')cout << s[i];
            else {
               cout << (char) (buk + 'A');
            }
            buk = p[i][buk];
            ++i;
        }
        cout << '\n';
    }
}
