#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()

const int max_n = 5e5 + 3;
int val[27];
int n;
int s[max_n];
int dp[max_n][26];
int id[max_n][26];
bool used[max_n];
int res = 0;

void build() {
	res = 0;
	{
		string t;
		cin >> t;
		n = size(t);
		for(int i = 0;i < n;i++) {
			s[i] = t[i] - 'A';
			if (t[i] == '?') s[i] = -1;
		}
	}
	fill(used, used + n, false);

	vector<int> a[26];
	for(int i = 0;i < n;i++) {
		if (s[i] == -1) continue;
		res += val[s[i]];
		for(int j = 0;j < s[i];j++) {
			for(auto id : a[j]) {
				used[id] = true;
				res -= 2 * val[s[id]];
			}
			a[j].clear();
		}
		a[s[i]].emplace_back(i);
	}
}

void solve() {
	build();

	int lst = max_n - 1;
	deque<int> q;
	vector<int> sum(26);
	for(int i = 0;i < n;i++) {
		if (s[i] == -1) {
			for(int j = 10;j < 26;j++) {
				dp[i][j] = max(dp[lst][j], dp[lst][j + 1]) - sum[j - 1] + val[j];
				id[lst][j] = dp[lst][j] < dp[lst][j + 1];	
			}
			fill(sum.begin(), sum.end(), 0);
			q.emplace_front(i);
			lst = i;
		}else {
			if (!used[i]) {
				for(int j = s[i];j < 26;j++)
					sum[j] += val[s[i]];
			}
		}
	}

	cout << res + *max_element(dp[lst] + 10, dp[lst] + 26) << endl;

	int j = max_element(dp[lst] + 10, dp[lst] + 26) - dp[lst];
	for(int i : q) {
		s[i] = j;
		j += id[i][j];
	}
	for(int i = 0;i < n;i++) {
		cout << (char)(s[i] + 'A');
	}
	cout << endl;
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	val[0] = 1;
	for(int i = 1;i < 26;i += 2) {
		val[i] = val[i - 1] * 5;
		val[i + 1] = 2 * val[i];
	}
	int t;
	cin >> t;
	while(t--) solve();
}