#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 5e5 + 100, K = 26, INF = 2e18;

int n, q;
vector<pair<int, int>> a;
bool used[N];

void solve() {
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    int l, r, ans, ds;
    while (q--) {
        cin >> l >> r;
        l--, r--;
        ans = 0;
        for (int h = 0; h < (r - l + 1); h++) {
            for (int i = l; i <= r; i++) {
                if (used[i]) continue;
                ds = 0;
                for (int j = i - 1; j >= 0; j--) {
                    ds = max(ds, a[i].first - a[j].first);
                    if (!used[j]) break;
                }
                for (int j = i + 1; j < n; j++) {
                    ds = max(ds, a[j].first - a[i].first);
                    if (!used[j]) break;
                }
                if (ds >= a[i].second) {
                    used[i] = true;
                    ans++;
                }
            }
        }
        for (int i = l; i <= r; i++) {
            used[i] = false;
        }
        cout << ans << '\n';
    }
}
