#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<string>
#include<vector>
#include<cmath>
#include<queue>
#include<cassert>
#include <algorithm>
using namespace std;
#define int long long
vector<vector<pair<int,int>>> g;
vector<int> cost, ans;
void dfs(int v, int p = -1, int ma = 0, int mi = 2e9) {
	if (p != -1) ans[v] = ma + mi;
	for (auto& x : g[v]) {
		if (x.first == p) continue;
		dfs(x.first, v, max(ma, cost[x.second]), min(mi, cost[x.second]));
	}
	return;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int q, w, c;
		cin >> q >> w >> c;
		--q, --w;
		g[q].push_back({ w, i });
		g[w].push_back({ q,i });
		cost.push_back(c);
	}
	ans.resize(n);
	dfs(0);
	for (int i = 1; i < n; ++i) cout << ans[i] << '\n';
	return 0;
}