#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int n, m;
	cin >> n >> m;

	vector<set<int>> a(n);
	set<pair<int, int>> e;

	for (int i{}; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[x].insert(y);
		a[y].insert(x);
		e.insert({ x, y });
	}

	vector<vector<int>> min(n), mout(n);
	set<pair<int, int>> q;
	vector<pair<pair<int, int>, pair<int ,int>>> ans;
	for (int i{}; i < n; ++i) {
		q.insert({ a[i].size(), i });
	}

	while (!q.empty()) {
		auto j = *q.begin();
		q.erase(q.begin());

		while (!min[j.y].empty() && !mout[j.y].empty()) {
			int t1 = min[j.y].back();
			int t2 = mout[j.y].back();

			ans.push_back({ {t1, j.y}, {j.y, t2} });
			min[j.y].pop_back();
			mout[j.y].pop_back();
		}

		if (j.x == 0) {
			if (!min[j.y].empty() || !mout[j.y].empty()) {
				cout << "No\n";
				return 0;
			}
			continue;
		}

		auto par = *a[j.y].begin();
		if (min[j.y].size() > 1 || mout[j.y].size() > 1) {
			cout << "No\n";
			return 0;
		}

		if (!min[j.y].empty()) {
			if (e.count({ j.y, par })) {
				e.erase({ j.y, par });
				ans.push_back({ {min[j.y][0], j.y}, {j.y, par} });
				min[j.y].clear();
			}
			else {
				cout << "No\n";
				return 0;
			}
		}

		if (!mout[j.y].empty()) {
			if (e.count({ par, j.y })) {
				e.erase({ par, j.y });
				ans.push_back({ {par, j.y}, {j.y, mout[j.y][0]} });
				mout[j.y].clear();
			}
			else {
				cout << "No\n";
				return 0;
			}
		}

		if (e.count({ j.y, par }) && e.count({ par, j.y })) {
			ans.push_back({ {j.y, par}, {par, j.y} });
			e.erase({ j.y, par });
			e.erase({ par, j.y });
		}

		if (e.count({ j.y, par })) {
			min[par].push_back({ j.y });
			e.erase({ j.y, par });
		}

		if (e.count({ par, j.y })) {
			mout[par].push_back({ j.y });
			e.erase({ par, j.y });
		}

		q.erase({ a[par].size(), par });
		a[par].erase(j.y);
		q.insert({ a[par].size(), par });
	}
	cout << "Yes\n";
	for (auto i : ans) {
		cout << i.x.x + 1 << " " << i.x.y + 1 << " " << i.y.x + 1 << " " << i.y.y + 1 << '\n';
	}

	return 0;
}