#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

map<char, ll> mp;

ll Calc(const string& s, char c) {
    ll ans = 0;
    char sufMx = 'A';
    for (int i = sz(s) - 1; i >= 0; i--) {
        char cur = s[i] == '?' ? c : s[i];
        int sign = sufMx > cur ? -1 : 1;
        ans += sign * mp[cur];
        maxq(sufMx, cur);
    }
    return ans;
}

void Solve() {
    string s;
    cin >> s;
    ll ans = Calc(s, 'A');
    char ansC = 'A';
    for (char c = 'B'; c <= 'Z'; c++) {
        ll lans = Calc(s, c);
        if (ans < lans) {
            ans = lans;
            ansC = c;
        }
    }
    cout << ans << nl;
    for (auto& i : s) {
        cout << (i == '?' ? ansC : i);
    }
    cout << nl;
}

signed main() {
    ull v = 1;
    for (char c = 'A'; c <= 'Z'; c++) {
        mp[c] = v;
        if ((c - 'A') & 1)
            v *= 2;
        else
            v *= 5;
    }
    IO();
    int t = 1;
    cin >> t;
    forn(i, t) {
        Solve();
    }
}
