#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
#define int ll
using namespace std;

const int maxn = 3e5 + 50;
vector<pii> r[maxn];
int ans[maxn];
void dfs(int v, int p = -1, int mn = 1e9, int mx = 0) {
    ans[v] = mn + mx;
    for (auto &u : r[v]) {
        if (u.f != p) {
            dfs(u.f, v, min(mn, u.s), max(mx, u.s));
        }
    }
}
int p[maxn];
int s[maxn];

int get(int v) {
    return (p[v] == v ? v : p[v] = get(p[v]));
}
int merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a != b) {
        if (s[a] > s[b])
            swap(a, b);
        p[a] = b;
        s[b] += s[a];
        return 1;
    }
    return 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    iota(p, p + n, 0);
    fill(s, s + n, 1);
    vector<pair<int, pii>> e;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int w;
        cin >> w;
        e.pb({w, {a, b}});
    }
    sort(e.rbegin(), e.rend());
    for (auto &i : e) {
        if (merge(i.s.f, i.s.s)) {
            r[i.s.f].pb({i.s.s, i.f});
            r[i.s.s].pb({i.s.f, i.f});
        }
    }
    dfs(0);
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--)
        solve();
}
