#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

map<char, int> value;

int ans; string sans;

void rec(string s, int k, int sum, char mx)
{
	if (k == -1)
	{
		if (sum > ans)
		{
			ans = sum;
			sans = s;
		}
		return;
	}

	while (k >= 0 && s[k] != '?')
	{
		if (s[k] >= mx)
		{
			mx = s[k];
			sum += value[s[k]];
		}
		else sum -= value[s[k]];
		k--;
	}
	if (k >= 0)
	{
		for (char c = 'A'; c <= 'Z'; c++)
		{
			s[k] = c;
			rec(s, k - 1, mx > s[k] ? sum - value[s[k]] : sum + value[s[k]], max(mx, s[k]));
		}
	}
	else rec(s, k, sum, mx);
}

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int k = 1;
	for (char c = 'A'; c <= 'Z'; c += 2)
	{
		value[c] = k;
		value[c + 1] = k * 5;
		k *= 10;
	}

	int q;
	cin >> q;
	while (q--)
	{
		string s;
		cin >> s;
		ans = -1e18, sans = "";
		rec(s, s.length() - 1, 0, 'A');

		cout << ans << endl << sans << endl;
	}
}