#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
void initial()
{
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
#define all(x) (x).begin(), (x).end()
#define sz(x) ((long long)(x).size())
#define pb push_back
#define f first
#define s second
typedef long long ll;
const ll maxn = 5e5 + 10;
vector <ll> g[maxn];
vector <ll> gr[maxn];
bool used[maxn];
vector <pair <pair <ll, ll>, pair <ll, ll> > > ans;
set <pair <ll, ll> > was;
pair <ll, ll> dfs(ll v, ll p = -1, bool kk = false)
{
    if (used[v]) return {0, 0};
    vector <ll> in, out;
    used[v] = true;
    bool ok = false;
    for (auto to: g[v])
    {
        if (to == p) {
            ok = true;
            continue;
        }
        auto [w1, w2] = dfs(to, v, 1);
        if (w1) in.pb(to);
        if (w2) out.pb(to);
    }
    for (auto to: gr[v])
    {
        if (to == p) {
            continue;
        }
        auto [w1, w2] = dfs(to, v, 0);
        if (w1) in.pb(to);
        if (w2) out.pb(to);
    }
    if (sz(in) - sz(out) > 1)
    {
        cout << "No";
        exit(0);
    }
    pair <bool, bool> ret = {ok, kk};
    if (sz(in) != sz(out))
    {

        if (p == -1)
        {
            cout << "No";
            exit(0);
        }
        if (sz(in) > sz(out))
        {
            if (!ok)
            {
                cout << "No";
                exit(0);
            }
            ret = {0, kk};
            ans.pb({{in.back(), v}, {v, p}});
        }
        else
        {
            if (!kk)
            {
                cout << "No";
                exit(0);
            }
            ret = {ok, 0};
            ans.pb({{p, v}, {v, out.back()}});
        }
    }
    for (int i = 0; i < min(sz(in), sz(out)); i++)
    {
        ans.pb({{in[i], v}, {v, out[i]}});
    }
    return ret;
}
int main() {
    initial();
    ll n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        ll f, t;
        cin >> f >> t;
        was.insert({f, t});
        g[f].pb(t);
        gr[t].pb(f);
    }
    for (int i = 1; i <= n; i++)
        if (!used[i])
        {
            auto it = dfs(i);
            if (it.f)
            {
                cout << "No";
                return 0;
            }
        }
        cout << "Yes\n";
       // if (sz(ans) * 2 != m)
       //     assert(false);
      for (auto [a, b] : ans)
      {
      //    if (!was.count(a) || !was.count(b)) assert(false);
          cout << a.f << " " << a.s << " " << b.f << " " << b.s << endl;
      }
    return 0;
}
