#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}


vector<bool> used;

struct edge {
    ll u, v, t;
};

struct ged {
    ll u;
    ll edge_id;
};

vector<vector<ged>> gr;
vector<edge> edges;

vector<ll> ans;

void dfs(ll v, ll mn = 1e18, ll mx = 0) {
    if (v != 0) {
        ans[v] = mn + mx;
    }
    for (auto[u, eid]: gr[v]) {
        if (!used[eid]) {
            used[eid] = true;
            dfs(u, min(mn, edges[eid].t), max(mx, edges[eid].t));
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    used.resize(m);
    ans.resize(n);
    for (int i = 0; i < m; ++i) {
        ll u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        gr[u].push_back({v, i});
        gr[v].push_back({u, i});
        edges.push_back({u, v, t});
    }
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << endl;
    }
}
