#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

map<char, ll> mp = {
        {'A', 1},
        {'B', 5},
        {'C', 10},
        {'D', 50},
        {'E', 100},
        {'F', 500},
        {'G', 1e3},
        {'H', 5e5},
        {'I', 1e4},
        {'J', 5e4},
        {'K', 1e5},
        {'L', 5e5},
        {'M', 1e6},
        {'N', 5e6},
        {'O', 1e7},
        {'P', 5e7},
        {'Q', 1e8},
        {'R', 5e8},
        {'S', 1e9},
        {'T', 5e9},
        {'U', 1e10},
        {'V', 5e10},
        {'W', 1e11},
        {'X', 5e11},
        {'Y', 1e12},
        {'Z', 5e12},
};
const ll INF = 2e18;

void solve() {
    string s; cin >> s;
    int n = s.size();
    vector<vector<ll>> dp(n + 1, vector<ll> (26, -INF));
    vector<vector<int>> p1(n + 1, vector<int> (26, -1)), p2(n + 1, vector<int> (26, -1));
    dp[n][0] = 0;
    for(int i = (int)s.size() - 1; i >= 0; --i) {
        if (s[i] != '?') {
            int c = s[i] - 'A';
            range(e, 26) {
                int k = max(e, c);
                ll cur = dp[i+1][e] + (c < e ? -mp[s[i]] : mp[s[i]]);
                if (dp[i][k] < cur) {
                    dp[i][k] = cur;
                    p1[i][k] = e;
                    p2[i][k] = c;
                }
            }
        } else {
            range(e, 26) {
                range(w, 26) {
                    ll cur = dp[i+1][e];
                    if (w < e) cur -= mp['A'+w];
                    else cur += mp['A'+w];
                    int k = max(e, w);
                    if (dp[i][k] < cur) {
                        dp[i][k] = cur;
                        p1[i][k] = e;
                        p2[i][k] = w;
                    }
                }
            }
        }
    }
    int j = 0;
    range(e, 26) if (dp[0][e] > dp[0][j]) j = e;
    cout << dp[0][j] << '\n';
    for(int i = 0; i < n; ++i) {
        cout << char('A' + p2[i][j]);
        j = p1[i][j];
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}