#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()

vector<vector<int> > in;
vector<vector<int> > out;
vector<pair<int, int> > e;
vector<vector<int> > dp;
vector<vector<int> > mt;
vector<vector<int> > g;
vector<int> sz;
vector<bool> used;

void dfs(int v, int p)
{
    used[v] = 1;
    for(int u : g[v])
    {
        if(u == p)
            continue;
        dfs(u, v);
    }
    dp[v][0] = 0;
    mt[v][0] = p;
    dp[v][1] = 0;
    pair<int, int> mx = {(int)(-1e9) - 7, -1};
    for(int u : g[v])
    {
        if(u == p)
            continue;
        sz[v] += sz[u];
        dp[v][0] += dp[u][1];
        mx = max(make_pair(dp[u][0] - dp[u][1], u), mx);
    }
    dp[v][1] = dp[v][0];
    dp[v][1] += 1 + mx.first;
    mt[v][1] = mx.second;
}

vector<pair<int, int> > ans;

void rec(int v, int state, int p)
{
    ans.emplace_back(v, mt[v][state]);
    int u1 = mt[v][state];
    for(int u : g[v])
    {
        if(u == p)
            continue;
        if(u == u1)
        {
            rec(u, 0, v);
        }
        else
        {
            rec(u, 1, v);
        }
    }
}

signed main()
{
    ios;
    int n, m;
    cin >> n >> m;
        used.assign(m, 0);
    sz.assign(m, 1);
    dp.assign(m, vector<int>(2, 0));
    mt.assign(m, vector<int>(2, -1));
    in.resize(n);
    out.resize(n);
    for(int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        in[v].push_back(e.size());
        out[u].push_back(e.size());
        e.emplace_back(u, v);
    }
    g.resize(m);
    for(int v = 0; v < n; ++v)
    {
        for(int e1 : in[v])
        {
            for(int e2 : out[v])
            {
                g[e1].push_back(e2);
                g[e2].push_back(e1);
            }
        }
    }
    for(int v = 0; v < m; ++v)
    {
        unordered_set<int> q;
        for(int u : g[v])
            q.insert(u);
        g[v].clear();
        for(int u : q)
            g[v].push_back(u);
    }
    for(int v = 0; v < m; ++v)
    {
        if(!used[v]) {
            dfs(v, -1);
            if(dp[v][1] * 2 != sz[v])
            {
                cout << "No";
                return 0;
                rec(v, 1, -1);
            }
        }
    }

    if(1)
    {
        for(auto &[e1, e2] : ans)
            {
                cout << e[e1].first  + 1 << ' ' << e[e1].second + 1 << ' ' << e[e2].first + 1 << ' ' << e[e2].second + 1 << '\n';
            }
    }
    else
    {
        cout << "No" << endl;
    }
    return 0;
}
