#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>

using namespace std;

#define endl '\n'

struct Cur
{
	vector<long long> plus = vector<long long>(26, 0);
	vector<long long> minus = vector<long long>(26, 0);

	long long sum = 0;

	string fill;
};

void task()
{
	long long n;
	cin >> n;

	for (long long t = 0; t < n; t++)
	{
		string str;
		cin >> str;

		vector<pair<Cur, long long>> dp(26, { {}, 0 });

		Cur here;

		for (long long i = 0; i < str.size(); i++)
		{
			if (str[i] != '?')
			{
				here.plus[str[i] - 'A']++;
				here.sum += ((str[i] - 'A') % 2 == 1 ? 5 : 1) * pow(10, (str[i] - 'A') / 2);

				for (long long j = 0; j < str[i] - 'A'; j++)
				{
					here.sum -= 2 * here.plus[j] * (j % 2 == 1 ? 5 : 1) * pow(10, j / 2);
					here.minus[j] += here.plus[j];
					here.plus[j] = 0;
				}
			}
			else
			{
				vector<pair<Cur, long long>> newdp(26, { {}, LLONG_MIN });

				for (long long j = 0; j < 26; j++)
				{
					if (j == 25)
					{
						j = j;
					}

					Cur newcur = here;
					newcur.plus[j]++;
					newcur.sum += (j % 2 == 1 ? 5 : 1) * pow(10, j / 2);

					for (long long k = 0; k < j; k++)
					{
						newcur.sum -= newcur.plus[k] * 2 * (k % 2 == 1 ? 5 : 1) * pow(10, k / 2);
						newcur.minus[k] += newcur.plus[k];
						newcur.plus[k] = 0;
					}

					long long max = -1;

					for (long long k = 0; k < 26; k++)
					{
						if (newcur.plus[k] > 0)
						{
							max = k;
						}
					}

					for (long long k = 0; k < 26; k++)
					{
						Cur dpcount = dp[k].first;

						for (long long f = 0; f < max; f++)
						{
							dpcount.sum -= dpcount.plus[f] * 2 * (f % 2 == 1 ? 5 : 1) * pow(10, f / 2);
							dpcount.minus[f] += dpcount.plus[f];
							dpcount.plus[f] = 0;
						}

						long long allcount = dpcount.sum + newcur.sum;

						if (allcount > newdp[k].second)
						{
							Cur ins;
							ins.fill = dpcount.fill;
							ins.fill.push_back('A' + j);

							for (long long f = 0; f < 26; f++)
							{
								ins.plus[f] = dpcount.plus[f] + newcur.plus[f];
								ins.minus[f] = dpcount.minus[f] + newcur.minus[f];
								ins.sum = dpcount.sum + newcur.sum;
							}

							newdp[j] = { ins, ins.sum };
						}
					}
				}

				dp = newdp;
				here.plus.clear();
				here.minus.clear();
				here.plus.resize(26, 0);
				here.minus.resize(26, 0);
				here.sum = 0;
			}
		}

		long long max = 0;

		for (long long j = 0; j < 26; j++)
		{
			dp[j].second = dp[j].first.sum + here.sum;
			if (dp[j].second > dp[max].second)
			{
				max = j;
			}
		}

		string ans;
		int pos = 0;

		for (int j = 0; j < str.size(); j++)
		{
			if (str[j] != '?')
			{
				ans.push_back(str[j]);
			}
			else
			{
				ans.push_back(dp[max].first.fill[pos]);
				pos++;
			}
		}

		cout << dp[max].second << endl;
		cout << ans << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}
