#include <iostream>
#include <vector>

using namespace std;

long long letters[26];

long long get_str_sum(string s) {
    long long summa = 0;
    char m_char = 'A';
    for (long long j = s.size() - 1; j >= 0; --j) {
        if (s[j] >= m_char) {
            summa += letters[s[j] - 'A'];
            m_char = s[j];
        }
        else {
            summa -= letters[s[j] - 'A'];
        }
    }
    return summa;
}

int main()
{
    long long n;
    cin >> n;
    long long st = 1;
    for (long long i = 0; i < 13; ++i) {
        letters[2 * i] = st;
        letters[2 * i + 1] = st * 5;
        st *= 10;
    }
    for (long long i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int cnt = 0;
        vector<int> pos;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '?') {
                pos.push_back(i);
                cnt++;
            }
        }
        /*if (s == "????") {
            s = "ZZZZ";
        }
        else if (s == "A?B?C?D") {
            s = "AZBZCZD";
        }
        else if (s == "YYYYY?") {
            s = "YYYYYY";
        }*/
        long long summa = -1000000000000000000;
        string ans;
        if (cnt == 0) {
            summa = get_str_sum(s);
            ans = s;
            cout << summa << '\n';
            cout << ans << '\n';
            continue;
        }
        long long m = s.size();
        pair<long long, string> dp_max[m];
        pair<long long, string> dp_min[m];
        if (s[0] == '?') {
            dp_max[0] = {letters[25], "Z"};
            dp_min[0] = {letters[0], "A"};
        }
        else {
            string minim = "";
            minim += s[0];
            dp_max[0] = {letters[s[0] - 'A'], minim};
            dp_min[0] = {letters[s[0] - 'A'], minim};
        }
        for (int j = 1; j < m; ++j) {
            if (s[j] != '?') {
                string s1 = dp_max[j - 1].second + s[j];
                string s2 = dp_min[j - 1].second + s[j];
                long long sum1 = get_str_sum(s1);
                long long sum2 = get_str_sum(s2);
                if (sum1 > sum2) {
                    dp_max[j] = {sum1, s1};
                    dp_min[j] = {sum2, s2};
                }
                else {
                    dp_min[j] = {sum1, s1};
                    dp_max[j] = {sum2, s2};
                }
            }
            else {
                string s1 = dp_max[j - 1].second + 'A';
                string s2 = dp_min[j - 1].second + 'A';
                long long sum1 = get_str_sum(s1);
                long long sum2 = get_str_sum(s2);
                if (sum1 < sum2) {
                    swap(sum1, sum2);
                    swap(s1, s2);
                }
                for (int k = 1; k < 26; ++k) {
                    char c = 'A' + k;
                    string new_s1 = dp_max[j - 1].second + c;
                    string new_s2 = dp_min[j - 1].second + c;
                    long long new_sum1 = get_str_sum(new_s1);
                    long long new_sum2 = get_str_sum(new_s2);
                    if (new_sum1 > sum1) {
                        sum1 = new_sum1;
                        s1 = new_s1;
                    }
                    if (new_sum2 > sum1) {
                        sum1 = new_sum2;
                        s1 = new_s2;
                    }
                    if (new_sum1 < sum2) {
                        sum2 = new_sum1;
                        s2 = new_s1;
                    }
                    if (new_sum2 < sum2) {
                        sum2 = new_sum2;
                        s2 = new_s2;
                    }
                }
                dp_max[j] = {sum1, s1};
                dp_min[j] = {sum2, s2};
            }
        }
        cout << dp_max[m - 1].first << '\n';
        cout << dp_max[m - 1].second << '\n';
    }
    return 0;
}
