#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

const int N = 3e5 + 5;

vector<pair<int, int>> a[N];
vi ans(N);

void dfs(int v, int p = -1, int mins = -1, int maxx = -1) {
	ans[v] = mins + maxx;
	for (auto u : a[v]) {
		if (u.first == p) continue;
		if (mins == -1) dfs(u.first, v, u.second, u.second);
		else dfs(u.first, v, min(mins, u.second), max(maxx, u.second));
	}
}

void solve() {
	
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y, t; cin >> x >> y >> t;
		--x, --y;
		a[x].push_back({y, t});
		a[y].push_back({x, t});
	}
	dfs(0);
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}