#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

const int N = 3e5 + 5;
const ll INF = 1e18;

vi w(N, INF);
vi mi(N, INF), ma(N, -INF);
void solve() {
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y, t; cin >> x >> y >> t;
		--x, --y;
		w[min(x, y)] = min(w[min(x, y)], t);
	}
	for (int i = 0; i < n - 1; ++i) {
		mi[i + 1] = min(mi[i], w[i]);
		ma[i + 1] = max(ma[i], w[i]);
	}
	for (int i = 1; i < n; ++i) {
		cout << mi[i] + ma[i] << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}