#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<int> ans;
vector<vector<pair<int, int>>> g;

void dfs(int v, int par, int mn, int mx) {
    if (v != 0) {
        ans[v] = mn + mx;
    }
    for (auto [u, len] : g[v]) {
        if (u != par) {
            dfs(u, v, min(mn, len), max(mx, len));
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    ans.resize(n);

    for (int i = 0; i < m; ++i) {
        int u, v, len;
        cin >> u >> v >> len;
        --u; --v;
        g[u].emplace_back(v, len);
        g[v].emplace_back(u, len);
    }
    dfs(0, -1, INT64_MAX, INT64_MIN);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}

int32_t main() {

    solve();

    return 0;
}
