#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 1e18;
int pows[18];

void pows_build() {
    rep(i, 18) {
        if (i == 0) pows[i] = 1;
        else pows[i] = pows[i - 1] * 10;
    }
}

int f(int n) {
    if (n % 2 == 0) return pows[n / 2];
    return 5 * pows[n / 2];
}

void run() {
    pows_build();
    string s;
    cin >> s;
    reverse(all(s));
    int n = s.size();
    vector<vector<int>> dp(n, vector<int> (26, -inf));
    vector<vector<int>> pr(n, vector<int> (26, -1));
    rep(j, 26) {
        if (s[0] != '?' && s[0] - 'A' != j) continue;
        dp[0][j] = f(j);
    }
    rep(i, n - 1) {
        rep(mx, 26) {
            if (s[i + 1] != '?') {
                int num = s[i + 1] - 'A';
                dp[i + 1][max(mx, num)] = max(dp[i + 1][max(mx, num)], dp[i][mx] + f(num) * (num >= mx ? 1 : -1));
            } else {
                rep(num, 26) {
                    dp[i + 1][max(mx, num)] = max(dp[i + 1][max(mx, num)], dp[i][mx] + f(num) * (num >= mx ? 1 : -1));
                }
            }
        }
    }
    int ans = -inf;
    rep(j, 26) {
        ans = max(ans, dp[n - 1][j]);
    }
    cout << ans << '\n';
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        run();
    return 0;
}
