#include <bits/stdc++.h>

#define ll long long
//#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 2e9;

vector<vector<int>> tree, g;
vector<bool> used;
vector<int> mt;
vector<int> parts;

void bipart(int v, int cur) {
    used[v] = 1;
    parts[v] = cur;
    for (int to : g[v]) {
//        if (parts[to] != -1) {
//            assert(cur != parts[to]);
//        }
        if (used[to]) continue;
        bipart(to, (cur ^ 1));
    }
}

bool kunh(int v) {
    if (used[v]) return false;
    used[v] = 1;
    for (int to : g[v]) {
        if (mt[to] == -1 || kunh(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void run() {
    int n, m;
    cin >> n >> m;
    g.resize(m);
    tree.resize(n);
    used.resize(n, 0);
    vector<pii> edges;
    rep(i, m) {
        int v, to;
        cin >> v >> to;
        v--;
        to--;
        tree[v].pb(to);
        tree[to].pb(v);
        edges.pb({v, to});
    }
    rep(i, m) {
        rep(j, m) {
            if (i == j) continue;
//            if (parts[i] != 0) continue;
            if (edges[i].ss == edges[j].ff) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }
//    rep(i, m) {
//        random_shuffle(all(g[i]));
//        //olei
//    }
    used.assign(m, 0);
    parts.assign(m, -1);
    rep(i, m) {
        if (!used[i]) bipart(i, 0);
    }
//    mx.resize(n, -inf);
//    mn.resize(n, inf);
    mt.resize(m, -1);
    used.assign(m, 0);
    int sz = 0;
    vector<int> fst;
    rep(i, m) {
        if (parts[i] == 0) fst.pb(i);
    }
    random_shuffle(all(fst));
    for (int i : fst) {
        if (parts[i] != 0) continue;
        if (kunh(i)) {
            used.assign(m, 0);
            sz++;
        }
    }
    if (sz == m / 2) {
        cout << "Yes\n";
        rep(i, m) {
            if (parts[i] == 1) {
                cout << edges[mt[i]].ff + 1 << ' ' << edges[mt[i]].ss + 1 << ' ';
                cout << edges[i].ff + 1 << ' ' << edges[i].ss + 1 << '\n';
            }
        }
    } else {
        cout << "No\n";
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}