#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define INF 1000000000000000000ll
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
int n, m;
vector<vector<pair<int, int> > > g;
vector<ll> res;
void dfs(int v, int p, ll max1, ll min1)
{
	if(v != 0)
	{
		res[v] = max1 + min1;
	}
	for(int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i].first;
		int w = g[v][i].second;
		if(u == p)
		{
			continue;
		}
		dfs(u, v, max(max1, (ll)w), min(min1, (ll)w));
	}
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n >> m;
	g.resize(n);
	for(int i = 0; i < m; i++)
	{
		int v, u, w;
		cin >> v >> u >> w;
		--v;
		--u;
		g[v].push_back({u, w});
		g[u].push_back({v, w});
	}
	res.assign(n, INF);
	if(m == n - 1)
	{
		dfs(0, -1, -INF, INF);
	}
	for(int i = 1; i < n; i++)
	{
		cout << res[i] << '\n';
	}
}