#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

vector<lpair> v;
vector<lvec> left_list, right_list;
lvec left_n, right_n;
lvec left_c, right_c;

ll solve(ll l, ll r) {
    ll ans = 0;
    lvec st;
    left_c = left_n;
    right_c = right_n;
    for (ll i = l; i < r; i++)
        if (left_n[i] == 0 || right_n[i] == 0)
            st.push_back(i);
    while (!st.empty()) {
        ans++;
        ll i = st.back();
        st.pop_back();
        for (auto j : left_list[i])
            if (--left_c[j] == 0 && j >= l && j < r)
                st.push_back(j);
        for (auto j : right_list[i])
            if (--right_c[j] == 0 && j >= l && j < r)
                st.push_back(j);
    }
    return ans;
}

int main() {
   // freopen("C.in", "r", stdin);
    ll n, q;
    cin >> n >> q;
    v.resize(n);
    for (auto &p : v) cin >> p.first >> p.second;
    v.push_back(v.back());
    v.insert(v.begin(), *v.begin());
    left_list.resize(n + 2);
    right_list.resize(n + 2);
    left_n.resize(n + 2);
    right_n.resize(n + 2);
    for (ll i = 1; i < n + 1; i++) {
        for (ll j = 0; j < i; j++)
            if (v[j].first > v[i].first - v[i].second)
                left_list[j].push_back(i), left_n[i]++;
        for (ll j = i + 1; j < n + 2; j++)
            if (v[j].first < v[i].first + v[i].second)
                right_list[j].push_back(i), right_n[i]++;
    }
    while (q--) {
        ll l, r;
        cin >> l >> r;
        cout << solve(l, r + 1) << "\n";
    }
    return 0;
}