#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 3e5, maxm = 2e6;

vector<pair<int, int>> g[maxn];
bool used[maxn];

int prv[maxn], tin[maxn], timer = 0, ans[maxn];
bool bridge[maxn];
void dfs1(int v) {
	map<int, int> ct;
	
	tin[v] = timer++;
	prv[v] = tin[v];
	for (auto e: g[v]) {
		int u = e.first;
		if (!used[u]) {
			dfs1(u);
			ct[u]++;
		}
	}
	
	for (auto e: g[v]) {
		int u = e.first;
		if (ct[u] == 1) {
			if (tin[v] < prv[u]) {
				bridge[u] = true;
			}
		}
		prv[v] = min(prv[v], prv[u]);
	}
}

bool tused[maxn];
int dfs3(int v) {
	if (tused[v] || bridge[v]) return inf;
	tused[v] = true;
	int cv = inf;
	for (auto e: g[v]) {
		cv = min(cv, dfs3(e.first));
	}
	return cv;
}

void dfs2(int v, int cv) {
	if (used[v]) return;
	bridge[v] = false;
	cv = min(cv, dfs3(v));
	used[v] = true;
	
	ans[v] = min(ans[v], cv);
	for (auto e: g[v]) {
		dfs2(e.first, cv);
	}
}


int main() {
	FAST;
	
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
	}
	
	for (int i = 0; i < n; i++) ans[i] = inf;
	dfs1(0);
	for (int i = 0; i < n; i++) used[i] = false;
	dfs2(0, inf);
	for (int i = 1; i < n; i++) cout << ans[i] + inf << nl;
}
