#include <bits/stdc++.h>

#define int long long

using namespace std;

int x1, xn;
int deleted;

struct tree
{
    int x, h;
    tree *left, *right;
    bool deleted = false;
    int index;

    tree(int x=0, int h=0, int index=0): x(x), h(h), index(index) {}

    friend ostream &operator<<(ostream &out, tree &T) {
        out << T.x << " " << T.h;
        return out;
    }

    friend bool operator<(tree &A, tree &B) {
        return A.x < B.x;
    }
};
/*
void do_delete(tree* tree)
{
    if (tree)
}
*/
void try_to_delete(tree* tree, int left, int right)
{
    //cout << "! " << tree->x << " " << tree->h << " " << tree->deleted << "\n";
    if (tree == nullptr || tree->deleted || tree->index < left || tree->index > right)
        return;
    //cout << "! " << tree->x << " " << tree->h << " " << tree->deleted << "\n";
    if ((tree->left != nullptr && tree->x - tree->h >= tree->left->x) || (tree->left == nullptr && tree->x - tree->h >= x1)) {
        if (tree->left != nullptr)
            tree->left->right = tree->right;
        if (tree->right != nullptr)
            tree->right->left = tree->left;
        deleted += 1;
        tree->deleted = true;
    }
    if (!tree->deleted &&
        ((tree->right != nullptr && tree->x + tree->h <= tree->right->x) || (tree->right == nullptr && tree->x + tree->x <= xn))) {
        if (tree->left != nullptr)
            tree->left->right = tree->right;
        if (tree->right != nullptr)
            tree->right->left = tree->left;
        deleted += 1;
        tree->deleted = true;
    }

    if (tree->deleted)
        try_to_delete(tree->left, left, right);
}

signed main()
{
    int n, Q; cin >> n >> Q;
    vector <tree*> forest(n);
    vector <tree> forest2(n);
    for (int i = 0; i < n; ++i) {
        tree* now = new tree;
        int x, h; cin >> x >> h;
        now->x = x; now->h = h;
        now->left = now->right = nullptr;
        now->index = i;
        forest[i] = now;

        forest2[i] = {x, h, i};
        forest2[i].left = now;
    }
    x1 = forest2[0].x, xn = forest2[n - 1].x;
    for (int i = 0; i < n; ++i) {
        if (i != 0)
            forest[i]->left = forest[i - 1];
        if (i != n - 1)
            forest[i]->right = forest[i + 1];
    }

    while (Q--) {
        int left, right; cin >> left >> right; left -= 1; right -= 1;
/*
        int bleft = -1, bright = n - 1;
        while (bright - bleft > 1) {
            int middle = (bleft + bright) / 2;
            cout << "middle " << middle << "   " << forest2[middle] << "\n";
            if (forest2[middle].x < left)
                bleft = middle;
            else
                bright = middle;
        }
        tree x = forest2[bright];
        cout << "! " << *(x.left) << "\n";*/

        deleted = 0;
        for (int i = left; i <= right; ++i) {
            try_to_delete(forest2[i].left, left, right);
        }

        cout << deleted << "\n";
        for (int i = 0; i < n; ++i) {
            if (i != 0)
                forest[i]->left = forest[i - 1];
            if (i != n - 1)
                forest[i]->right = forest[i + 1];
            forest[i]->deleted = false;
        }
    }
}
