#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

map<char, ll> to_values;

int n;
int solve() {
    if (!(cin >> n))
        return 1;
    ll val = 1;
    for (char c = 'A'; c <= 'Z'; ++c) {
        to_values[c] = val;
        if ((c - 'A') % 2 == 0) {
            val *= 5LL;
        } else {
            val *= 2LL;
        }
    }

    for (int _ = 0; _ < n; ++_) {
        string s;
        cin >> s;
        int l = s.length();
        vector<vector<ll>> dp(l, vector<ll>(26, LLONG_MIN));
        vector<vector<int>> pred(l, vector<int>(26, -1));
        vector<vector<char>> placed(l, vector<char>(26, 'A'));
        if (s[l - 1] != '?') {
            dp[l - 1][s[l - 1] - 'A'] = to_values[s[l - 1]];
            placed[l - 1][s[l - 1] - 'A'] = s[l - 1];
        } else {
            for (char c = 'A'; c <= 'Z'; ++c) {
                dp[l - 1][c - 'A'] = to_values[c];
                placed[l - 1][c - 'A'] = c;
            }
        }

        for (int i = l - 2; i >= 0; --i) {
            for (char c = 'A'; c <= 'Z'; ++c) {
                if (s[i] != '?') {
                    placed[i][c - 'A'] = s[i];
                    if (s[i] == c) {
                        for (char cc = 'A'; cc <= c; ++cc) {
                            if (dp[i + 1][cc - 'A'] + to_values[c] > dp[i][c - 'A']) {
                                dp[i][c - 'A'] = max(dp[i][c - 'A'], dp[i + 1][cc - 'A'] + to_values[c]);
                                pred[i][c - 'A'] = cc - 'A';
                            }
                        }
                    } else if (s[i] > c) {
                        continue;
                    } else {
                        if (dp[i + 1][c - 'A'] == LLONG_MIN) continue;
                        if (dp[i][c - 'A'] < dp[i + 1][c - 'A'] - to_values[s[i]]) {
                            dp[i][c - 'A'] = dp[i + 1][c - 'A'] - to_values[s[i]];
                            pred[i][c - 'A'] = c - 'A';
                        }
                    }
                } else {
                    for (char ccc = 'A'; ccc <= 'Z'; ++ccc) {
                        if (ccc == c) {
                            for (char cc = 'A'; cc <= c; ++cc) {
                                if (dp[i + 1][cc - 'A'] + to_values[c] > dp[i][c - 'A']) {
                                    placed[i][c - 'A'] = ccc;
                                    dp[i][c - 'A'] = max(dp[i][c - 'A'], dp[i + 1][cc - 'A'] + to_values[c]);
                                    pred[i][c - 'A'] = cc - 'A';
                                }
                            }
                        } else if (ccc > c) {
                            continue;
                        } else {
                            if (dp[i + 1][c - 'A'] == LLONG_MIN) continue;
                            if (dp[i][c - 'A'] < dp[i + 1][c - 'A'] - to_values[ccc]) {
                                placed[i][c - 'A'] = ccc;
                                dp[i][c - 'A'] = dp[i + 1][c - 'A'] - to_values[ccc];
                                pred[i][c - 'A'] = c - 'A';
                            }
                        }
                    }
                }
            }
        }
        ll max_val = LLONG_MIN;
        int max_pos = 0;
        for (int i = 0; i < 26; ++i) {
            if (dp[0][i] > max_val) {
                max_val = dp[0][i];
                max_pos = i;
            }
        }
        string r_s;
        int i = 0;
        while (max_pos != -1) {
            r_s += placed[i][max_pos];
            max_pos = pred[i][max_pos];
            i++;
        }
        cout << max_val << '\n';
        cout << r_s << '\n';
    }
    return 0;
}


int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}
