#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using query = pair<int, int>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int j = 0; j < q; ++j) {
        vector<int> left(n), right(n);
        left[0] = x[0];
        for (int i = 1; i < n; ++i) left[i] = x[i - 1];
        for (int i = 0; i + 1 < n; ++i) right[i] = x[i + 1];
        right.back() = x.back();
        int l, r;
        cin >> l >> r;
        --l;
        vector<bool> alive(n, true);
        int cnt = 0;
        bool progress = true;
        while (progress) {
            progress = false;
            auto erase = [&](int i) {
                if (!alive[i]) return;
                alive[i] = false;
                for (int j = i + 1; j < r; ++j) {
                    if (left[j] == x[i]) left[j] = left[i];
                }
                for (int j = i - 1; j >= l; --j) {
                    if (right[j] == x[i]) right[j] = right[i];
                }
                progress = true;
                cnt++;
            };
            for (int i = l; i < r; ++i) {
                if (x[i] - h[i] >= left[i] || x[i] + h[i] <= right[i]) erase(i);
            }
        }
        cout << cnt << '\n';
    }

}