#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

//#define GLIBCXX_DEBUG

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while(t--)
        solve();
}

ll dfs(string& s, int idx, vector<ll>& values) {
    int found = -1;
    for (int i = idx; i < s.size(); i++) {
        if (s[i] == '?') {
            found = i;
            break;
        }
    }
    if (found == -1) {
        ll answer = 0;
        int ma = 0;
        for (int i = s.size() - 1; i >= 0; i--) {
            int ch = s[i] - 'A';
            if (ch < ma)
                answer -= values[ch];
            else
                answer += values[ch];
            ma = max(ma, ch);
        }
        return answer;
    }
    ll ma = -1e18;
    char miAns = '@';
    for (char a = 'A'; a <= 'Z'; a++) {
        s[found] = a;
        ll res = dfs(s, found + 1, values);
        if (res > ma) {
            ma = res;
            miAns = a;
        }
    }
    s[found] = miAns;
    return ma;
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();

    vector<ll> values = {1, 5};
    while (values.size() < 26) {
        values.push_back(values.back() * 2);
        values.push_back(values.back() * 5);
    }
    assert(values.size() == 26);

    ll res = dfs(s, 0, values);

    cout << res << '\n' << s << '\n';
}