#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>


#define x first
#define y second


//typedef pair<int, int> pii;


using namespace std;


#pragma warning(disable:4996)


const int maxn = 5e5;
int h[maxn];
int x[maxn];
bool used[maxn];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, q;
	cin >> n >> q;
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		for (int i = 0; i < n; i++)
			used[i] = 0;
		bool f = 1;
		int ans = 0;
		while (f) {
			f = 0;
			int last = x[0];
			if (l != 0)
				last = x[l - 1];
			for (int j = l; j <= r; j++) {
				if (!used[j]) {
					if (h[j] <= x[j] - last) {
						used[j] = 1;
						f = 1;
						ans++;
						continue;
					}
					last = x[j];
				}
			}
			last = x[n - 1];
			if (r != n - 1)
				last = x[r + 1];
			for (int j = r; j >= l; j--) {
				if (!used[j]) {
					if (h[j] <= last - x[j]) {
						used[j] = 1;
						f = 1;
						ans++;
						continue;
					}
					last = x[j];
				}
			}
		}
		cout << ans << '\n';
	}
}