#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 2010;

int n, m;
int mn[N][2];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		mn[i][0] = mn[i][1] = INF;
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		if (v < u) swap(u, v);
		int cur = w;
		for (int j = 0; j < 2; j++) {
			if (cur < mn[v][j]) {
				swap(cur, mn[v][j]);
			}
		}
	}
	int curmn = INF, curmx = 0;
	for (int i = 1; i < n; i++) {
		chkmin(curmn, mn[i][0]);
		chkmax(curmx, mn[i][0]);
		int ans = curmn + curmx;
		int curmn1 = curmn, curmx1 = curmx;
		for (int j = i + 1; j < n; j++) {
			for (int k = 0; k < 2; k++) {
				chkmin(curmn1, mn[j][k]);
				chkmax(curmx1, mn[j][k]);
			}
			chkmin(ans, curmn1 + curmx1);
		}
		cout << ans << "\n";
	}
}
/*
4 3
1 2 1000000000
2 3 2 
3 4 3
*/