#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <functional>
#include <map>
#include <bitset>
#include <utility>
#include <cstring>
#include <algorithm>
#include <chrono>
#include <random>

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define mp make_pair
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define ppb pop_back()
#define all(x) x.begin(),x.end()


#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;


template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef vector<int> vi;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<char> vch;
typedef vector<pii> vpii;
typedef vector<vi> vvi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2010;
const int INF = 2e9 + 228;
int ans[N];
vpii g[N];
int dp[N][N];

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;	
	vi nums;
	fi(0, m) {
		int a, b, t;
		cin >> a >> b >> t;
		--a, --b;
		g[a].pb({b, t});
		g[b].pb({a, t});
		nums.pb(t);
	}
	nums.pb(0);
	sort(all(nums));
	nums.pb(INF);
	nums.resize(unique(all(nums)) - nums.begin());
	int c = nums.size();
	fi(0, n) {
		for (auto&[b, t] : g[i]) {
			t = lb(all(nums), t) - nums.begin();
		}
		fj(0, c) {
			dp[i][j] = c - 1;
		}
	}
	dp[0][c - 1] = 0;
	set<pii> q;
	q.insert(mp(c - 1, 0));
	while (q.size()) {
		auto[mn, v] = *q.begin();
		int mx = dp[v][mn];
		q.erase(q.begin());
		for (auto[to, t] : g[v]) {
			int mn2 = min(t, mn);
			int mx2 = max(t, mx);
			if (dp[to][mn2] > mx2) {
				q.erase(mp(dp[to][mn2], to));
				dp[to][mn2] = mx2;
				q.insert(mp(dp[to][mn2], to));
			}
		} 
	}
	fi(1, n) {
		ans[i] = INF;
		fj(0, c) {
			mine(ans[i], nums[j] + nums[dp[i][j]]);
		}		
		cout << ans[i] << '\n';
	}
}
