#include <iostream>
#include <map>

using namespace std;
#define int long long
const int inf = 2e18;

string s;

void read() {
    cin >> s;
}

void solve() {
    map<char, int> m;
    m['A'] = 1;
    for (char i = 'B'; i <= 'Z'; ++i) {
        if (i & 1) {
            m[i] = m[i - 1] * 2;
        } else {
            m[i] = m[i - 1] * 5;
        }
    }

    string ans;
    int res = -inf;
    for (char c = 'A'; c <= 'Z'; ++c) {
        string t = s;
        for (int i = 0; i < s.size(); ++i) {
            if (t[i] == '?') {
                t[i] = c;
            }
        }
        int g = 0;
        for (int i = 0; i < s.size(); ++i) {
            bool z = true;
            for (int j = i + 1; j < s.size(); ++j) {
                if (t[i] < t[j]) {
                    z = false;
                    break;
                }
            }
            if (z) {
                g += m[t[i]];
            } else {
                g -= m[t[i]];
            }
        }

        if (g > res) {
            res = g;
            ans = t;
        }
    }
    cout << res << "\n" << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        read();
        solve();
    }

    return 0;
}
