#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)
#define rep(i, n) for (int i = 0; i < n; i++)
#define re return
#define pb emplace_back

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

void solve()
{
    int n, q;
    cin >> n >> q;
    vi x(n), h(n);
    rep(i, n)
    {
        cin >> x[i] >> h[i];
    }
    rep(i, q)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        vi nx, nh;
        nh.pb(-1);
        if (l == 0) nx.pb(x[0]);
        else nx.pb(x[l - 1]);
        for (int j = l; j <= r; j++)
        {
            nx.pb(x[j]);
            nh.pb(h[j]);
        }
        nh.pb(-1);
        if (r == n - 1) nx.pb(x[n - 1]);
        else nx.pb(x[r + 1]);
        queue<int> can;
        set<int> s;
        s.insert(0); s.insert(sz(nx) - 1);
        for (int i = 1; i < sz(nx) - 1; i++)
        {
            bool ok = 0;
            if (nx[i] + nh[i] <= nx[i + 1] || nx[i] - nh[i] >= nx[i - 1]) {
                can.push(i);
                ok = 1;
            }
            if (!ok) s.insert(i);
        }
        int ret = 0;
        while (sz(can) > 0)
        {
            ret++;
            int i = can.front();
            can.pop();
            int next = -1, prev = -1;
            auto it = s.lower_bound(i);
            next = *it;
            prev = *(--it);
            if (prev != 0) {
                if (nx[prev] + nh[prev] <= nx[next]) {
                    can.push(prev);
                    s.erase(prev);
                }
            }
            if (next != sz(nx) - 1) {
                if (nx[next] - nh[next] >= nx[prev]) {
                    can.push(next);
                    s.erase(next);
                }
            }
        }
        cout << ret << endl;
    }
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
