#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
using namespace  std;

vector<pair<int, int>> g[3000 * 101];

vector<int> ans;

void dfs(int v, int minn = 1e9, int maxx = -1e9, int p = -1) {
    if (v != 1) {
        ans[v] = minn + maxx;
    }
    for (auto [u, t] : g[v]) {
        if (u != p) {
            dfs(u, min(minn, t), max(maxx, t), v);
        }
    }
}

int main() {
   int n, m;
   cin >> n >> m;
   ans.resize(n + 1);
   for (int i = 0; i < m; i++) {
       int a, b, t;
       cin >> a >> b >> t;
       g[a].emplace_back(b, t);
       g[b].emplace_back(a, t);
   }
   dfs(1);
   for (int i = 2; i <= n; i++) {
       cout << ans[i] << ' ';
   }
}