#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int K = 26;
vector<ll> cost = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000, 100000000,
                   500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000, 1000000000000,
                   5000000000000};


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<ll>> dp(n + 1, vector<ll>(K, -l_inf));
        vector<vector<pair<char, int>>> P(n + 1, vector<pair<char, int>>(K, {-1, -1}));
        dp[n][0] = 0;
        for (int i = n - 1; i >= 0; --i) {
            for (int j = 0; j < K; ++j) {
                for (int z = 0; z < j; ++z) {
                    if (s[i] != '?' && s[i] - 'A' != j) {
                        continue;
                    }
                    if (dp[i + 1][z] + cost[j] > dp[i][j]) {
                        dp[i][j] = dp[i + 1][z] + cost[j];
                        P[i][j] = make_pair(j + 'A', z);
                    }
                }
                //
                if (s[i] == '?' || s[i] == j + 'A') {
                    ll x = dp[i + 1][j] + cost[j];
                    if (x > dp[i][j]) {
                        dp[i][j] = x;
                        P[i][j] = make_pair(j + 'A', j);
                    }
                } else if (s[i] < j + 'A') {
                    ll x = dp[i + 1][j] - cost[s[i] - 'A'];
                    if (x > dp[i][j]) {
                        dp[i][j] = x;
                        P[i][j] = make_pair(s[i], j);
                    }
                }
            }
        }
        //
        int j = max_element(dp[0].begin(), dp[0].end()) - dp[0].begin();
        cout << dp[0][j] << "\n";
        for (int i = 0; i < n; ++i) {
            cout << P[i][j].first;
            j = P[i][j].second;
        }
        cout << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}