//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

int n, q;
vector<int> x, h;

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> q;
    x.resize(n), h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        vector<int> us(n, 0);
        int ans = 0;
        queue<int> q;
        set<int> st;
        for (int i = l; i <= r; ++i) {
            q.push(i);
            st.insert(i);
        }
        if (l != 0) st.insert(l - 1);
        if (r != n - 1) st.insert(r + 1);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            if (us[v] == 1) continue;

            bool ch = false;
            int l1 = -1, r1 = -1;
            auto it = st.lower_bound(v);
            if (it != st.begin()) {
                it--;
                l1 = *it;
            }
            it = st.upper_bound(v);
            if (it != st.end()) {
                r1 = *it;
            }

            if (v != 0 && x[v] - h[v] >= x[0]) {
                if (l1 != -1) {
                    if (x[l1] + h[v] <= x[v]) ch = true;
                } else ch = true;
            }
            if (v != n - 1 && x[v] + h[v] <= x[n - 1]) {
                if (r1 != -1) {
                    if (x[v] + h[v] <= x[r1]) ch = true;
                } else ch = true;
            }

            if (ch) {
                st.erase(v);
                us[v] = 1;
                ans++;
                if (l1 != -1 && l1 >= l) q.push(l1);
                if (r1 != -1 && r1 <= r) q.push(r1);
            }
        }
        cout << ans << "\n";
    }

}