#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct edge {
    int u, v, w;
};

bool cmp(edge &a, edge &b) {
    if (a.w < b.w)return true;
    return false;
}

int n, m;
vector<edge> e;

const int maxn = 20;
vector<int> adj[maxn];
vector<int> ans;
int us[maxn];

void dfs(int v) {
    us[v] = 1;
    for (auto num : adj[v]) {
        int to = e[num].u + e[num].v - v;
        if (us[to] == 0) dfs(to);
    }
}

void ch() {
    dfs(0);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (size(adj[i]) != 0 && us[i] == 0) return;
        if (size(adj[i]) % 2 == 1) cnt++;
    }
    if (cnt != 2) return;
    int fr[2];
    cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (size(adj[i]) % 2 == 1) {
            fr[cnt++] = i;
        }
    }
    if (fr[0] > fr[1]) swap(fr[0], fr[1]);
    if (fr[0] != 0) return;
    int mn = 1e9, mx = 0;
    for (int i = 0; i < n; ++i) {
        for (auto num : adj[i]) {
            mn = min(mn, e[num].w);
            mx = max(mx, e[num].w);
        }
    }
    ans[fr[1]] = min(ans[fr[1]], mx + mn);
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        e.push_back({u, v, w});
    }
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = 2e9;
    }

    for (int i = 0; i < (1 << m); ++i) {
        for (int j = 0; j < n; ++j) {
            adj[j].clear();
            us[j] = 0;
        }
        for (int j = 0; j < m; ++j) {
            if ((1 & (i >> j)) != 0) {
                edge ed = e[j];
                adj[ed.u].push_back(j);
                adj[ed.v].push_back(j);
            }
        }
        ch();
    }

    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}