#include <bits/stdc++.h>

#define ll long long
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define x first
#define y second
#define vpi vector <pii>

using namespace std;

const int N = 3e5 + 7, inf = 2e9 + 7, K = 26;

struct edge{
    int to, w, id;
};

vector <edge> v[N];
int d[N];

int used[N];

void gen(int x, int mn, int mx) {
    d[x] = min(d[x], mn + mx);
    for (auto u : v[x]) {
        if(used[u.id])
            continue;
        used[u.id] = 1;
        gen(u.to, min(mn, u.w), max(mx, u.w));
        used[u.id] = 0;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    fill(d, d + n, inf);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        v[a].pb({b, w, i});
        v[b].pb({a, w, i});
    }

    gen(0, inf, -inf);

    for (int i = 1; i < n; i++)
        cout << d[i] << ' ';

}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
