#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<random>
using namespace std;

mt19937 gen(0);

const long long INF = 4e18;
string global_s;
long long mx_ans;
string stupid_ans;
long long smart_ans;
string s;
map<char, long long> cost;

void rec(string my_s, vector<int> pos, int i) {
	if (i == pos.size()) {
		long long cur_sum = 0;
		map<char, long long> vis_sym;
		for (int pos = 0; pos < my_s.size(); ++pos) {
			for (int less_sym = 'A'; less_sym < my_s[pos]; ++less_sym) {
				cur_sum -= 2 * vis_sym[less_sym] * cost[less_sym];
				vis_sym[less_sym] = 0;
			}
			vis_sym[my_s[pos]] += 1;
			cur_sum += cost[my_s[pos]];
		}
		if (cur_sum > mx_ans) {
			mx_ans = cur_sum;
			stupid_ans = my_s;
		}
		return;
	}
	for (char sym = 'A'; sym <= 'Z'; ++sym) {
		my_s[pos[i]] = sym;
		rec(my_s, pos, i + 1);
	}
}
void stupid() {
	string my_s = global_s;
	vector<int> pos;
	for (int i = 0; i < my_s.size(); ++i) {
		if (my_s[i] == '?')
			pos.push_back(i);
	}
	mx_ans = -INF;
	rec(my_s, pos, 0);
}
void generate() {
	global_s = "";
	int n = gen() % 10 + 1;
	for (int i = 0; i < n; ++i) {
		global_s += (char)(gen() % 26 + 'A');
	}
	int k = gen() % 3;
	for (int i = 0; i < k; ++i) {
		global_s[gen() % n] = '?';
	}
}

void smart(int debug = 0) {
	long long sum = 0;
	s = global_s;
	vector<vector<vector<long long>>> last_vis_sym(s.size() + 1, vector<vector<long long>>(26, vector<long long>(26, 0)));
	vector<vector<long long>> dp(s.size() + 1, vector<long long>(26, 0));
	vector<vector<char>> parent(s.size() + 1, vector<char>(26, 0));
	for (int i = 0; i < s.size(); ++i) {
		for (char cur = 'A'; cur <= 'Z'; ++cur) {
			last_vis_sym[i + 1][cur - 'A'] = last_vis_sym[i][cur - 'A'];
			if (s[i] != '?') {
				long long cur_minus = 0;
				for (char del = 'A'; del < s[i]; ++del) {
					cur_minus -= 2 * last_vis_sym[i][cur - 'A'][del - 'A'] * cost[del];
					last_vis_sym[i + 1][cur - 'A'][del - 'A'] = 0;
				}
				last_vis_sym[i + 1][cur - 'A'][s[i] - 'A'] = last_vis_sym[i][cur - 'A'][s[i] - 'A'] + 1;
				dp[i + 1][cur - 'A'] = dp[i][cur - 'A'] + cost[s[i]] + cur_minus;
				parent[i + 1][cur - 'A'] = cur - 'A';
			}
			else {
				long long last_max = -INF;
				for (char last_used = cur; last_used <= 'Z'; ++last_used) {
					if (last_max < dp[i][last_used - 'A']) {
						last_max = dp[i][last_used - 'A'];
						parent[i + 1][cur - 'A'] = last_used - 'A';
					}
				}
				for (char del = 'A'; del < cur; ++del) {
					last_max -= 2 * last_vis_sym[i][cur - 'A'][del - 'A'] * cost[del];
					last_vis_sym[i + 1][cur - 'A'][del - 'A'] = 0;
				}
				dp[i + 1][cur - 'A'] = last_max + cost[cur];
				last_vis_sym[i + 1][cur - 'A'][cur - 'A'] = last_vis_sym[i][cur - 'A'][cur - 'A'] + 1;
			}
		}
	}
	long long ans = -INF;
	int pos = 0;
	for (int i = 0; i < 26; ++i){
		if (dp[s.size()][i] > ans) {
			ans = dp[s.size()][i];
			pos = i;
		}
	}
	
	for (int i = s.size() - 1; i >= 0; --i) {
		if (s[i] == '?') {
			s[i] = (char)(pos + 'A');
			pos = parent[i + 1][pos];
		}
	}
	smart_ans = ans;
}

int main() {
	long long cur = 1;
	for (int i = 0; i < 26; ++i) {
		cost[i + 'A'] = cur;
		if (i % 2 == 0)
			cur *= 5;
		else
			cur *= 2;
	}
	int t;
	cin >> t;
	while (t--) {
		cin >> global_s;
		smart();
		cout << smart_ans << '\n';
		cout << s << '\n';
	}
}