#include <iostream>
#include<vector>
#include<algorithm>
#include<map>
#include<random>
#include<ctime>

using namespace std;

map<char, long long> m;

long long count(string& s) {
	int n = s.size();
	vector<char> maxx(n);
	maxx[n - 1] = s[n - 1];
	for (int i = n - 2; i >= 0; --i)
		maxx[i] = max(maxx[i + 1], s[i]);
	long long res = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] < maxx[i])
			res -= m[s[i]];
		else
			res += m[s[i]];
	}
	return res;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	m['A'] = 1;
	for (char i = 'B'; i <= 'Z'; ++i) {
		if (i % 2 == 'A' % 2)
			m[i] = m[i - 1] * 2;
		else
			m[i] = m[i - 1] * 5;
	}
	int t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;
		int n = s.size();
		int cnt = 0;
		vector<int> ind;
		for (int i = 0; i < n; ++i)
			if (s[i] == '?') {
				++cnt;
				ind.push_back(i);
			}
		if (cnt == 0) {
			cout << count(s) << '\n' << s << '\n';
		}
		if (cnt == 1) {
			long long maxx = -4e18;
			string ss;
			for (char i = 'A'; i <= 'Z'; ++i) {
				s[ind[0]] = i;
				long long res = count(s);
				if (res > maxx) {
					maxx = res, ss = s;
				}
			}
			cout << maxx << '\n' << ss << '\n';
		}
		if (cnt == 2) {
			long long maxx = -4e18;
			string ss;
			for (char i = 'A'; i <= 'Z'; ++i) {
				for (int j = i; j >= 'A'; --j) {
					s[ind[0]] = i;
					s[ind[1]] = j;
					long long res = count(s);
					if (res > maxx) {
						maxx = res, ss = s;
					}
				}
			}
			cout << maxx << '\n' << ss << '\n';
		}
		if (cnt == 3) {
			long long maxx = -4e18;
			string ss;
			for (char i = 'A'; i <= 'Z'; ++i) {
				for (int j = i; j >= 'A'; --j) {
					for (int k = j; k >= 'A'; --k) {
						s[ind[0]] = i;
						s[ind[1]] = j;
						s[ind[2]] = k;
						long long res = count(s);
						if (res > maxx) {
							maxx = res, ss = s;
						}
					}
				}
			}
			cout << maxx << '\n' << ss << '\n';
		}
	}
}