#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve1()
{
    int n;
    cin >> n;
    int left = 1, right = n + 1;
    while (right - left > 1)
    {
        int middle = (left + right) / 2;
        cout << middle << endl;
        int ans;
        cin >> ans;
        if (ans == 0)
        {
            return;
        }
        if (ans == 1)
        {
            left = middle + 1;
        }
        else
        {
            right = middle;
        }
    }
    cout << left << endl;
    int ans;
    cin >> ans;
    return;
}

void solve2()
{
    int n, k;
    cin >> n >> k;
    int left = 1, right = n + 1;
    for (int i = 0; i < k; i++)
    {
        int ans, middle = (left + right) / 2;
        cin >> ans;
        if (ans == 0)
        {
            cout << middle << endl;
            return;
        }
        if (ans == 1)
        {
            left = middle + 1;
        }
        else
        {
            right = middle;
        }
    }
    cout << left << endl;
    return;
}

signed main()
{
    int type;
    cin >> type;
    if (type == 1)
    {
        solve1();
    }
    else
    {
        solve2();
    }
    return 0;
}