#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);



int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tp;
	cin >> tp;
	if (tp == 1)
	{
		int n;
		cin >> n;
		int left = 0, right = n + 1, mid, ans;
		while (true)
		{
			mid = (left + right) / 2;
			cout << mid << endl;
			cin >> ans;
			if (ans == 1)
				left = mid;
			else if (ans == -1)
				right = mid;
			else
				break;
		}
	}
	else
	{
		int n;
		cin >> n;
		int left = 0, right = n + 1, mid, ans, q;
		cin >> q;
		for (int i=0; i<q; i++)
		{
			mid = (left + right) / 2;
			cin >> ans;
			if (ans == 1)
				left = mid;
			else if (ans == -1)
				right = mid;
			else
				break;
		}
		cout << mid << endl;
	}

	return 0;
}