#include <bits/stdc++.h>

using namespace std;


vector<int> poschecksum;


string encode(string s) {
	int n = s.size();
	for(int i = 0; i < 17; i++) {
		poschecksum.push_back(rand() % n);
	}
	sort(poschecksum.rbegin(), poschecksum.rend());

	int xor_ones_pos = 0;
	for(int i = 0; i < n; i++) {
		if(s[i] == '1') {
			xor_ones_pos ^= i + 1;
		}
	}

	stringstream ss;
	ss << bitset<17>(xor_ones_pos);
	string checksum = ss.str();
	for(int i = 0; i < 17; i++) {
		s.insert(s.begin() + poschecksum[i], checksum[i]);
	}
	return s;
}


string decode(string t) {
	int n = t.size() - 17;
	for(int i = 0; i < 17; i++) {
		poschecksum.push_back(rand() % n);
	}
	sort(poschecksum.begin(), poschecksum.end());

	int xor_ones_pos = 0;
	for(int i = 0; i < 17; i++) {
		xor_ones_pos |= (poschecksum[i] - '0') << i;
		t.erase(t.begin() + i);
	}

	if(xor_ones_pos == cur_xor_ones_pos) {
		return t;
	} else {
		int pos = (xor_ones_pos ^ cur_xor_ones_pos) - 1;
		t[pos] ^= 1;
		return t;
	}
}


signed main() {
	srand(1791791791);

	int t;
	cin >> t;

	string s;
	cin >> s;

	if(t == 1) {
		cout << encode(s) << endl;
	} else {
		cout << decode(s) << endl;
	}

	return 0;
}