#include <bits/stdc++.h>

#define int long long
using namespace std;

string sum(string a, string b) {
    string ans = "";
    int pr = 0;
    while (a.size() != 0 || b.size() != 0) {
        int a1 = 0;
        if (a.size() != 0) {
            a1 = a.back() - '0';
            a.pop_back();
        }
        int b1 = 0;
        if (b.size() != 0) {
            b1 = b.back() - '0';
            b.pop_back();
        }
        pr += a1 + b1;
        ans.push_back(pr % 10 + '0');
        pr /= 10;
    }
    ans.push_back(pr +'0');
    while (ans.size() != 1 && ans.back() == '0')ans.pop_back();
    reverse(ans.begin(), ans.end());
    return ans;
}

bool bigger(string a, string b) {
    if (a.size() < b.size())return false;
    if (b.size() < a.size())return true;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] < b[i])return false;
        if (b[i] < a[i])return true;
    }
    return false;
}

string sub(string a, string b) {
    string ans = "";
    int pr = 0;
    while (a.size() != 0 || b.size() != 0) {
        int a1 = 0;
        if (a.size() != 0) {
            a1 = a.back() - '0';
            a.pop_back();
        }
        int b1 = 0;
        if (b.size() != 0) {
            b1 = b.back() - '0';
            b.pop_back();
        }
        pr += a1 - b1;
        ans.push_back((pr % 10 + 10) % 10 + '0');
        pr = pr / 10 + pr < 0;
    }
    while (ans.size() != 1 && ans.back() == '0')ans.pop_back();
    reverse(ans.begin(), ans.end());
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    string a;
    cin >> a;
    string b;
    cin >> b;

    bool min1 = false;
    bool min2 = false;
    if (a[0] == '-') {
        min1 = true;
        a = a.substr(1, a.size() - 1);
    }
    if (b[0] == '-') {
        min2 = true;
        b = b.substr(1, b.size() - 1);
    }
    if (bigger(b, a)) {
        swap(min1, min2);
        swap(a, b);
    }
    if (!min1 && !min2) {
        string ans = sum(a, b);
        cout << ans;
        exit(0);
    }
    if (min1 && min2) {
        string ans = sum(a, b);
        if (ans != "0")ans = "-" + ans;
        cout << ans;
        exit(0);
    }
    if (min1 && !min2) {
        string ans = sub(a, b);
        if (ans != "0")ans = "-" + ans;
        cout << ans;
        exit(0);
    }
    if (!min1 && min2) {
        string ans = sub(a, b);
        cout << ans;
        exit(0);
    }
}
