//
// Created by roi on 07.04.2021.
//

//
// Created by roi on 07.04.2021.
//

//
// Created by roi on 07.04.2021.
//

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int ll

template<typename T>
using vec = vector<T>;

#define ALL(a) a.begin(), a.end()

mt19937 rnd(228);

const int LEN = 60;
const int MOD = 1LL << LEN;


namespace sol1 {
  void run() {
    string s;
    cin >> s;
    if (s.size() <= 10) {
      cout << s + s + s << '\n';
    } else {
      int n = s.size();
      vec<int> hs(n);
      for (int i = 0; i < n; i++) {
        hs[i] = rnd() % MOD;
      }
      int hash = 0;
      for (int i = 0; i < n; i++) {
        if (s[i] == 1)
          hash = (hash + hs[i]) % MOD;
      }
      string shs;
      for (int i = 0; i < LEN; i++) {
        shs.push_back(((hash >> i) & 1) + '0');
      }
      cout << shs << shs << shs << s << endl;
    }
  }
}

namespace sol2 {
  void run() {
    string s;
    cin >> s;
    if (s.size() <= 30) {
      int n = s.size() / 3;
      map<string, int> cnt;
      string t;
      for (int i = 0; i < n; i++) {
        t.push_back(s[i]);
      }
      cnt[t]++;
      t.clear();
      for (int i = n; i < n * 2; i++) {
        t.push_back(s[i]);
      }
      cnt[t]++;
      t.clear();
      for (int i = n * 2; i < n * 3; i++) {
        t.push_back(s[i]);
      }
      cnt[t]++;
      for (auto &[k, v] : cnt) {
        if (v >= 2) {
          cout << k << endl;
          return;
        }
      }
    } else {
      string shs;
      map<string, int> cnt;
      for (int i = 0; i < LEN; i++) {
        shs += s[i];
      }
      cnt[shs]++;
      shs.clear();
      for (int i = LEN; i < LEN * 2; i++) {
        shs += s[i];
      }
      cnt[shs]++;
      shs.clear();
      for (int i = LEN * 2; i < LEN * 3; i++) {
        shs += s[i];
      }
      cnt[shs]++;
      shs.clear();
      int rhash = 0;
      for (auto &[k, v] : cnt) {
        if (v >= 2) {
          for (int i = 0; i < LEN; i++) {
            if (shs[i]) {
              rhash += 1LL << i;
            }
          }
          break;
        }
      }
      int n = s.size() - LEN * 3;
      vec<int> hs(n);
      for (int i = 0; i < n; i++) {
        hs[i] = rnd() % MOD;
      }
      int hash = 0;
      for (int i = 0; i < n; i++) {
        if (s[i + 3 * LEN] == 1)
          hash = (hash + hs[i]) % MOD;
      }
      string st;
      for (int i = LEN * 3; i < s.size(); i++) {
        st.push_back(s[i]);
      }
      if (rhash == hash) {
        cout << st << endl;
        return;
      }
      for (int i = 0; i < n; i++) {
        int chash = hash;
        if (st[i] == '0') {
          chash = (chash + hs[i]) % MOD;
        } else {
          chash = (chash - hs[i] + MOD) % MOD;
        }
        if (chash == hash) {
          if (st[i] == '0') st[i] = '1';
          else st[i] = '0';
          cout << st << endl;
          return;
        }
      }
    }
  }
}

void run() {
  int T;
  cin >> T;
  if (T == 1) {
    sol1::run();
  } else {
    sol2::run();
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}