#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {signed(1e5) + 3, 117, 239, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

signed main() {
    fastio;

    int n; cin >> n;
    int left = 0, right = n + 1;

    while (right - left > 1) {
        int mid = (left + right) / 2;
        cout << mid << endl;

        int answer; cin >> answer;

        if (answer == 0) {
            return 0;
        }
        else if (answer == -1) {
            right = mid;
        }
        else {
            assert(answer == 1);
            left = mid;
        }
    }

    return 0;
}