#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

inline string dec2bin(int x, int binary_length) {
    string result;
    for (int i = binary_length - 1; i >= 0; i--) {
        if ((1 << i) <= x) {
            result.push_back('1');
            x -= (1 << i);
        } else {
            result.push_back('0');
        }
    }

    return result;
}

inline void solve() {
    int type;
    cin >> type;

    if (type == 1) {
        string x;
        cin >> x;

        int cnt1 = 0;
        for (char c: x) {
            if (c == '1') {
                cnt1++;
            }
        }

        cout << x << x << dec2bin(cnt1, (x.length() == 10 ? 4 : 17)) << '\n';
    } else {
        string z;
        cin >> z;

        int n = (z.size() == 24 ? 10 : 100000);
        cout << z.size() << endl;

        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < n; i++) {
            if (z[i] == '1') {
                cnt1++;
            }
        }

        for (int i = n; i < 2 * n; i++) {
            if (z[i] == '1') {
                cnt2++;
            }
        }

        if (cnt1 == cnt2) {
            for (int i = 0; i < n; i++)
                cout << z[i];
        } else {
            int cnt0 = 0;
            for (int i = 2 * n; i < z.size(); i++) {
                if (z[i] == '1') {
                    cnt0 += (1 << (z.size() - i - 1));
                }
            }

            if (cnt1 == cnt0) {
                for (int i = 0; i < n; i++)
                    cout << z[i];
            } else if (cnt2 == cnt0) {
                for (int i = n; i < 2 * n ; i++)
                    cout << z[i];
            }
        }
    }
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
