#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

int n;
int _x;

int ask(int x) {
	cout << x << endl;
#ifdef DEBUG
	if (_x < x) {
		return cout << "-1" << endl, -1;
	} else if (_x == x) {
		return cout << "0" << endl, 0;
	} else {
		return cout << "1" << endl, 1;
	}
#else
	int q;
	cin >> q;
	return q;
#endif
}

const int Q = 31;

int a[Q];

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int type;
	cin >> type >> n;
	if (type == 1) {
#ifdef DEBUG
		cin >> _x;
#endif
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			int res = ask(mid);
			if (res == 0)
				return 0;
			if (res == -1)
				r = mid;
			else
				l = mid;
		}
	} else {
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i)
			cin >> a[i];
		int cnt = 0;
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			int res = a[cnt++];
			if (res == 0)
				return cout << mid, 0;
			if (res == -1)
				r = mid;
			else
				l = mid;
		}
	}
	return 0;
}