#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int type;
vector<int> results;
int index = 0;

int ask(int x) {
	int answer;
	if (type == 1) {
		cout << x << endl;
		cin >> answer;
	}
	else {
		answer = results[index++];
	}

	if (answer == 0) {
		if (type == 2)
			cout << x;
		exit(0);
	}
	return answer;
}


const int nn = 500;
int dist[nn][nn];


void floyd() {
	for (int i = 0; i < nn; i++) {
		for (int j = 0; j < nn; j++)
			dist[i][j] = abs(rand());
	}

	for (int k = 0; k < nn; k++) {
		for (int i = 0; i < nn; i++) {
			for (int j = 0; j < nn; j++) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}

	if (dist[0][nn - 1] < 0)
		exit(0);
}

int main() {
	floyd();
	cin >> type;
	int n;
	cin >> n;

	if (type == 2) {
		int q;
		cin >> q;
		results.resize(q);
		for (int i = 0; i < q; i++)
			cin >> results[i];
	}
	int l = 1, r = n + 1;
	while (r - l > 1) {
		int mid = (r + l) / 2;
		int ans = ask(mid);
		if (ans == -1) {
			r = mid;
		}
		else {
			l = mid + 1;
		}
	}
	ask(l);

}