#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define int long long

int32_t main()
{
	int type;
	cin >> type;
	if (type == 1) {
		string s;
		cin >> s;
		int n = s.length();
		vector<int> xors(17);
		for (int i = 0; i < n; i++) {
			if (s[i] == '1') 
				for (int bit = 0; bit < 17; bit++)
					if ((i + 1) & (1ll << bit))
						xors[bit] = !xors[bit];
		}
		cout << s;
		for (int bit = 0; bit < 17; bit++)
			cout << (char)('0' + xors[bit]);
		cout << '\n';
	}
	else {
		string s;
		cin >> s;
		int n = s.length() - 17;
		vector<int> sent_xors(17);
		for (int i = 0; i < 17; i++)
			sent_xors[i] = (s[n + i] == '1');
		vector<int> my_xors(17);
		for (int i = 0; i < n; i++) {
			if (s[i] == '1')
				for (int bit = 0; bit < 17; bit++)
					if ((i + 1) & (1ll << bit))
						my_xors[bit] = !my_xors[bit];
		}
		int changed = 0;
		for (int bit = 0; bit < 17; bit++)
			if (my_xors[bit] != sent_xors[bit])
				changed ^= (1ll << bit);
		if (changed != 0)
			s[changed - 1] = '0' + '1' - s[changed - 1];
		for (int i = 0; i < n; i++)
			cout << s[i];
	}
}