#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll LG = 17;

void sol1() {
	string s;
	cin >> s;

	string nw = s;
	ll nm = 1;

	for (int j = 0; j < LG; j++) {
		ll cnt = 0;
		for (int i = 0; i < s.size(); i++) {
			if ((i / nm) % 2 == 0) {
				if (s[i] == '0') cnt++;
			}
		}

		nw.push_back(cnt % 2 + '0');

		nm *= 2;
	}

	cout << nw;

	exit(0);
}

void sol2() {
	string st;
	cin >> st;
	
	vector<ll> bad(st.size());
	ll c = st[st.size() - LG];
	for (int i = 0; i < bad.size(); i++) bad[i] = 1;

	ll nm = 1;
	for (int i = 0; i < LG; i++) {
		ll c1 = 0;
		for (int j = st.size() - LG - 1; j >= 0; j--) {
			if ((j / nm) % 2 == 0 && st[j] == '0') c1++;
		}

		if (c1 == st[st.size() - LG + i] - '0') {
			for (int j = st.size() - LG - 1; j >= 0; j--) {
				if ((j / nm) % 2 == 0) bad[j] = 0;
			}
		}
		else {
			for (int j = st.size() - LG - 1; j >= 0; j--) {
				if ((j / nm) % 2 != 0) bad[j] = 0;
			}
		}

		nm *= 2;
	}

	string ans;
	ll cnt = 0;
	for (int i = 0; i < st.size() - LG; i++) cnt += bad[i];

	if (cnt > 1) {
		for (int i = 0; i < st.size() - LG; i++) bad[i] = 0;
	}

	for (int j = st.size() - LG - 1; j >= 0; j--) {
		if (bad[j]) {
			ans.push_back(((st[j] - '0') ^ 1) + '0');
		}
		else {
			ans.push_back(st[j]);
		}
	}

	reverse(ans.begin(), ans.end());

	cout << ans;

	exit(0);
}

int main() {
	fastInp;

	ll t;
	cin >> t;

	if (t == 1) {
		sol1();
	}
	else {
		sol2();
	}

	return 0;
}  