#include <iostream>
#include <bitset>

using namespace std;

int x;
string s;

void read() {
    cin >> x >> s;
}

void solve() {
    if (x == 1) {
        int sum = 0;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1') {
                sum ^= (i + 1);
            }
        }
        if (s.size() <= 10) {
            bitset<6> y(sum);
            cout << y << y << y;
        } else {
            bitset<20> y(sum);
            cout << y << y << y;
        }
        cout << s << "\n";
    } else {
        int k = 20;
        if (s.size() <= 28) {
            k = 6;
        }
        int y = 0;
        for (int i = 0; i < k; ++i) {
            y <<= 1;
            y += s[i] - '0';
            if (s[i] != s[i + k] || s[i + k] != s[i + 2 * k]) {
                cout << s.substr(i + 3 * k);
                return;
            }
        }
        cout << y << "\n";

        int sum = 0;
        for (int i = 3 * k; i < s.size(); ++i) {
            if (s[i] == '1') {
                sum ^= i - 3 * k + 1;
            }
        }

        string ans = s.substr(3 * k);
        if (sum != y) ans[abs(sum ^ y) - 1] = '0' + '1' - ans[abs(sum ^ y) - 1];

        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
