#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

string pluss(string &a, string &b) {
	bool ex = false;
	string res;
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	if (b.size() < a.size())
		swap(a, b);
	for (int i = 0; i < min(a.size(), b.size()); i++) {
		int val = a[i] + b[i] - '0' - '0';
		if (ex) val++;
		ex = false;
		if (val > 10) {
			ex = true;
			val -= 10;
		}
		res.push_back(val + '0');
	}
	for (int i = a.size(); i < b.size(); i++) {
		int val = b[i] - '0';
		if (ex) val++;
		ex = false;
		if (val > 10) {
			ex = true;
			val -= 10;
		}
		res.push_back(val + '0');
	}
	if (ex) res.push_back('1');
	reverse(res.begin(), res.end());
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	return res;
}

int main()
{
	string a, b;
	cin >> a >> b;

	if (a[0] == '-' && b[0] == '-') {
		a.erase(a.begin(), a.begin());
		b.erase(a.begin(), a.begin());
		cout << '-' << pluss(a, b);
	}
	else if (a[0] != '-' && b[0] != '-') {
		cout << pluss(a, b);
	}
	else {
		long long aa = 0;
		long long bb = 0;
		reverse(a.begin(), a.end());
		reverse(b.begin(), b.end());
		for (auto e : a) {
			aa *= 10;
			aa += (e - '0');
		}
		for (auto e : b) {
			bb *= 10;
			bb += (e - '0');
		}
		cout << aa + bb;
	}
}